/* Device.c generated by valac 0.56.14, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "wacom.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <glib-object.h>

enum  {
	WACOM_BACKEND_DEVICE_0_PROPERTY,
	WACOM_BACKEND_DEVICE_NAME_PROPERTY,
	WACOM_BACKEND_DEVICE_DEVICE_FILE_PROPERTY,
	WACOM_BACKEND_DEVICE_VENDOR_ID_PROPERTY,
	WACOM_BACKEND_DEVICE_PRODUCT_ID_PROPERTY,
	WACOM_BACKEND_DEVICE_DEV_TYPE_PROPERTY,
	WACOM_BACKEND_DEVICE_NUM_PROPERTIES
};
static GParamSpec* wacom_backend_device_properties[WACOM_BACKEND_DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WacomBackendDevicePrivate {
	gchar* _name;
	gchar* _device_file;
	gchar* _vendor_id;
	gchar* _product_id;
	WacomBackendDeviceDeviceType _dev_type;
};

static gint WacomBackendDevice_private_offset;
static gpointer wacom_backend_device_parent_class = NULL;

static void wacom_backend_device_finalize (GObject * obj);
static GType wacom_backend_device_get_type_once (void);
static void _vala_wacom_backend_device_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_wacom_backend_device_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
wacom_backend_device_get_instance_private (WacomBackendDevice* self)
{
	return G_STRUCT_MEMBER_P (self, WacomBackendDevice_private_offset);
}

static GType
wacom_backend_device_device_type_get_type_once (void)
{
	static const GFlagsValue values[] = {{WACOM_BACKEND_DEVICE_DEVICE_TYPE_MOUSE, "WACOM_BACKEND_DEVICE_DEVICE_TYPE_MOUSE", "mouse"}, {WACOM_BACKEND_DEVICE_DEVICE_TYPE_KEYBOARD, "WACOM_BACKEND_DEVICE_DEVICE_TYPE_KEYBOARD", "keyboard"}, {WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD, "WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD", "touchpad"}, {WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET, "WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET", "tablet"}, {WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN, "WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN", "touchscreen"}, {WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD, "WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD", "pad"}, {0, NULL, NULL}};
	GType wacom_backend_device_device_type_type_id;
	wacom_backend_device_device_type_type_id = g_flags_register_static ("WacomBackendDeviceDeviceType", values);
	return wacom_backend_device_device_type_type_id;
}

GType
wacom_backend_device_device_type_get_type (void)
{
	static volatile gsize wacom_backend_device_device_type_type_id__once = 0;
	if (g_once_init_enter (&wacom_backend_device_device_type_type_id__once)) {
		GType wacom_backend_device_device_type_type_id;
		wacom_backend_device_device_type_type_id = wacom_backend_device_device_type_get_type_once ();
		g_once_init_leave (&wacom_backend_device_device_type_type_id__once, wacom_backend_device_device_type_type_id);
	}
	return wacom_backend_device_device_type_type_id__once;
}

GSettings*
wacom_backend_device_get_settings (WacomBackendDevice* self)
{
	gchar* schema = NULL;
	gchar* path = NULL;
	WacomBackendDeviceDeviceType _tmp0_;
	const gchar* _tmp16_;
	GSettings* result;
#line 37 "../src/Backend/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Backend/Device.vala"
	schema = NULL;
#line 38 "../src/Backend/Device.vala"
	path = NULL;
#line 40 "../src/Backend/Device.vala"
	_tmp0_ = self->priv->_dev_type;
#line 40 "../src/Backend/Device.vala"
	if ((_tmp0_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN) {
#line 117 "Device.c"
		gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 41 "../src/Backend/Device.vala"
		_tmp1_ = g_strdup ("org.gnome.desktop.peripherals.touchscreen");
#line 41 "../src/Backend/Device.vala"
		_g_free0 (schema);
#line 41 "../src/Backend/Device.vala"
		schema = _tmp1_;
#line 42 "../src/Backend/Device.vala"
		_tmp2_ = self->priv->_vendor_id;
#line 42 "../src/Backend/Device.vala"
		_tmp3_ = self->priv->_product_id;
#line 42 "../src/Backend/Device.vala"
		_tmp4_ = g_strdup_printf ("/org/gnome/desktop/peripherals/touchscreens/%s:%s/", _tmp2_, _tmp3_);
#line 42 "../src/Backend/Device.vala"
		_g_free0 (path);
#line 42 "../src/Backend/Device.vala"
		path = _tmp4_;
#line 138 "Device.c"
	} else {
		WacomBackendDeviceDeviceType _tmp5_;
#line 43 "../src/Backend/Device.vala"
		_tmp5_ = self->priv->_dev_type;
#line 43 "../src/Backend/Device.vala"
		if ((_tmp5_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET) {
#line 145 "Device.c"
			gchar* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 44 "../src/Backend/Device.vala"
			_tmp6_ = g_strdup ("org.gnome.desktop.peripherals.tablet");
#line 44 "../src/Backend/Device.vala"
			_g_free0 (schema);
#line 44 "../src/Backend/Device.vala"
			schema = _tmp6_;
#line 45 "../src/Backend/Device.vala"
			_tmp7_ = self->priv->_vendor_id;
#line 45 "../src/Backend/Device.vala"
			_tmp8_ = self->priv->_product_id;
#line 45 "../src/Backend/Device.vala"
			_tmp9_ = g_strdup_printf ("/org/gnome/desktop/peripherals/tablets/%s:%s/", _tmp7_, _tmp8_);
#line 45 "../src/Backend/Device.vala"
			_g_free0 (path);
#line 45 "../src/Backend/Device.vala"
			path = _tmp9_;
#line 166 "Device.c"
		} else {
			gboolean _tmp10_ = FALSE;
			WacomBackendDeviceDeviceType _tmp11_;
#line 46 "../src/Backend/Device.vala"
			_tmp11_ = self->priv->_dev_type;
#line 46 "../src/Backend/Device.vala"
			if ((_tmp11_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_MOUSE) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_MOUSE) {
#line 46 "../src/Backend/Device.vala"
				_tmp10_ = TRUE;
#line 176 "Device.c"
			} else {
				WacomBackendDeviceDeviceType _tmp12_;
#line 46 "../src/Backend/Device.vala"
				_tmp12_ = self->priv->_dev_type;
#line 46 "../src/Backend/Device.vala"
				_tmp10_ = (_tmp12_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD;
#line 183 "Device.c"
			}
#line 46 "../src/Backend/Device.vala"
			if (_tmp10_) {
#line 187 "Device.c"
				gchar* _tmp13_;
#line 47 "../src/Backend/Device.vala"
				_tmp13_ = g_strdup ("org.gnome.desktop.peripherals.mouse");
#line 47 "../src/Backend/Device.vala"
				_g_free0 (schema);
#line 47 "../src/Backend/Device.vala"
				schema = _tmp13_;
#line 195 "Device.c"
			} else {
				WacomBackendDeviceDeviceType _tmp14_;
#line 48 "../src/Backend/Device.vala"
				_tmp14_ = self->priv->_dev_type;
#line 48 "../src/Backend/Device.vala"
				if ((_tmp14_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_KEYBOARD) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_KEYBOARD) {
#line 202 "Device.c"
					gchar* _tmp15_;
#line 49 "../src/Backend/Device.vala"
					_tmp15_ = g_strdup ("org.gnome.desktop.peripherals.keyboard");
#line 49 "../src/Backend/Device.vala"
					_g_free0 (schema);
#line 49 "../src/Backend/Device.vala"
					schema = _tmp15_;
#line 210 "Device.c"
				} else {
#line 51 "../src/Backend/Device.vala"
					result = NULL;
#line 51 "../src/Backend/Device.vala"
					_g_free0 (path);
#line 51 "../src/Backend/Device.vala"
					_g_free0 (schema);
#line 51 "../src/Backend/Device.vala"
					return result;
#line 220 "Device.c"
				}
			}
		}
	}
#line 54 "../src/Backend/Device.vala"
	_tmp16_ = path;
#line 54 "../src/Backend/Device.vala"
	if (_tmp16_ != NULL) {
#line 229 "Device.c"
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		GSettings* _tmp19_;
#line 55 "../src/Backend/Device.vala"
		_tmp17_ = schema;
#line 55 "../src/Backend/Device.vala"
		_tmp18_ = path;
#line 55 "../src/Backend/Device.vala"
		_tmp19_ = g_settings_new_with_path (_tmp17_, _tmp18_);
#line 55 "../src/Backend/Device.vala"
		result = _tmp19_;
#line 55 "../src/Backend/Device.vala"
		_g_free0 (path);
#line 55 "../src/Backend/Device.vala"
		_g_free0 (schema);
#line 55 "../src/Backend/Device.vala"
		return result;
#line 247 "Device.c"
	} else {
		const gchar* _tmp20_;
		GSettings* _tmp21_;
#line 57 "../src/Backend/Device.vala"
		_tmp20_ = schema;
#line 57 "../src/Backend/Device.vala"
		_tmp21_ = g_settings_new (_tmp20_);
#line 57 "../src/Backend/Device.vala"
		result = _tmp21_;
#line 57 "../src/Backend/Device.vala"
		_g_free0 (path);
#line 57 "../src/Backend/Device.vala"
		_g_free0 (schema);
#line 57 "../src/Backend/Device.vala"
		return result;
#line 263 "Device.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 283 "Device.c"
}

WacomBackendDeviceDeviceType
wacom_backend_device_get_device_type (GdkDevice* device)
{
	GdkInputSource source = 0;
	WacomBackendDeviceDeviceType result;
#line 61 "../src/Backend/Device.vala"
	g_return_val_if_fail (device != NULL, 0U);
#line 62 "../src/Backend/Device.vala"
	source = gdk_device_get_source (device);
#line 63 "../src/Backend/Device.vala"
	switch (source) {
#line 63 "../src/Backend/Device.vala"
		case GDK_SOURCE_MOUSE:
#line 63 "../src/Backend/Device.vala"
		case GDK_SOURCE_TRACKPOINT:
#line 301 "Device.c"
		{
#line 66 "../src/Backend/Device.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_MOUSE;
#line 66 "../src/Backend/Device.vala"
			return result;
#line 307 "Device.c"
		}
#line 63 "../src/Backend/Device.vala"
		case GDK_SOURCE_PEN:
#line 63 "../src/Backend/Device.vala"
		case GDK_SOURCE_ERASER:
#line 63 "../src/Backend/Device.vala"
		case GDK_SOURCE_CURSOR:
#line 315 "Device.c"
		{
			const gchar* _tmp0_;
			const gchar* _tmp1_;
#line 70 "../src/Backend/Device.vala"
			_tmp0_ = gdk_device_get_name (device);
#line 70 "../src/Backend/Device.vala"
			_tmp1_ = _tmp0_;
#line 70 "../src/Backend/Device.vala"
			if (string_contains (_tmp1_, "pad")) {
#line 71 "../src/Backend/Device.vala"
				result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET | WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD;
#line 71 "../src/Backend/Device.vala"
				return result;
#line 329 "Device.c"
			}
#line 74 "../src/Backend/Device.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET;
#line 74 "../src/Backend/Device.vala"
			return result;
#line 335 "Device.c"
		}
#line 63 "../src/Backend/Device.vala"
		case GDK_SOURCE_KEYBOARD:
#line 339 "Device.c"
		{
#line 76 "../src/Backend/Device.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_KEYBOARD;
#line 76 "../src/Backend/Device.vala"
			return result;
#line 345 "Device.c"
		}
#line 63 "../src/Backend/Device.vala"
		case GDK_SOURCE_TOUCHSCREEN:
#line 349 "Device.c"
		{
#line 78 "../src/Backend/Device.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN;
#line 78 "../src/Backend/Device.vala"
			return result;
#line 355 "Device.c"
		}
#line 63 "../src/Backend/Device.vala"
		case GDK_SOURCE_TOUCHPAD:
#line 359 "Device.c"
		{
#line 80 "../src/Backend/Device.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD;
#line 80 "../src/Backend/Device.vala"
			return result;
#line 365 "Device.c"
		}
#line 63 "../src/Backend/Device.vala"
		case GDK_SOURCE_TABLET_PAD:
#line 369 "Device.c"
		{
#line 82 "../src/Backend/Device.vala"
			result = WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET | WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD;
#line 82 "../src/Backend/Device.vala"
			return result;
#line 375 "Device.c"
		}
		default:
		{
#line 84 "../src/Backend/Device.vala"
			result = 0;
#line 84 "../src/Backend/Device.vala"
			return result;
#line 383 "Device.c"
		}
	}
}

WacomBackendDevice*
wacom_backend_device_construct (GType object_type)
{
	WacomBackendDevice * self = NULL;
#line 20 "../src/Backend/Device.vala"
	self = (WacomBackendDevice*) g_object_new (object_type, NULL);
#line 20 "../src/Backend/Device.vala"
	return self;
#line 396 "Device.c"
}

WacomBackendDevice*
wacom_backend_device_new (void)
{
#line 20 "../src/Backend/Device.vala"
	return wacom_backend_device_construct (WACOM_BACKEND_TYPE_DEVICE);
#line 404 "Device.c"
}

const gchar*
wacom_backend_device_get_name (WacomBackendDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../src/Backend/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Backend/Device.vala"
	_tmp0_ = self->priv->_name;
#line 31 "../src/Backend/Device.vala"
	result = _tmp0_;
#line 31 "../src/Backend/Device.vala"
	return result;
#line 420 "Device.c"
}

static void
wacom_backend_device_set_name (WacomBackendDevice* self,
                               const gchar* value)
{
	gchar* old_value;
#line 31 "../src/Backend/Device.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Backend/Device.vala"
	old_value = wacom_backend_device_get_name (self);
#line 31 "../src/Backend/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 434 "Device.c"
		gchar* _tmp0_;
#line 31 "../src/Backend/Device.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../src/Backend/Device.vala"
		_g_free0 (self->priv->_name);
#line 31 "../src/Backend/Device.vala"
		self->priv->_name = _tmp0_;
#line 31 "../src/Backend/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_NAME_PROPERTY]);
#line 444 "Device.c"
	}
}

const gchar*
wacom_backend_device_get_device_file (WacomBackendDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/Backend/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Backend/Device.vala"
	_tmp0_ = self->priv->_device_file;
#line 32 "../src/Backend/Device.vala"
	result = _tmp0_;
#line 32 "../src/Backend/Device.vala"
	return result;
#line 461 "Device.c"
}

static void
wacom_backend_device_set_device_file (WacomBackendDevice* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 32 "../src/Backend/Device.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Backend/Device.vala"
	old_value = wacom_backend_device_get_device_file (self);
#line 32 "../src/Backend/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 475 "Device.c"
		gchar* _tmp0_;
#line 32 "../src/Backend/Device.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/Backend/Device.vala"
		_g_free0 (self->priv->_device_file);
#line 32 "../src/Backend/Device.vala"
		self->priv->_device_file = _tmp0_;
#line 32 "../src/Backend/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_DEVICE_FILE_PROPERTY]);
#line 485 "Device.c"
	}
}

const gchar*
wacom_backend_device_get_vendor_id (WacomBackendDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/Backend/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Backend/Device.vala"
	_tmp0_ = self->priv->_vendor_id;
#line 33 "../src/Backend/Device.vala"
	result = _tmp0_;
#line 33 "../src/Backend/Device.vala"
	return result;
#line 502 "Device.c"
}

static void
wacom_backend_device_set_vendor_id (WacomBackendDevice* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 33 "../src/Backend/Device.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Backend/Device.vala"
	old_value = wacom_backend_device_get_vendor_id (self);
#line 33 "../src/Backend/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 516 "Device.c"
		gchar* _tmp0_;
#line 33 "../src/Backend/Device.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/Backend/Device.vala"
		_g_free0 (self->priv->_vendor_id);
#line 33 "../src/Backend/Device.vala"
		self->priv->_vendor_id = _tmp0_;
#line 33 "../src/Backend/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_VENDOR_ID_PROPERTY]);
#line 526 "Device.c"
	}
}

const gchar*
wacom_backend_device_get_product_id (WacomBackendDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/Backend/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Backend/Device.vala"
	_tmp0_ = self->priv->_product_id;
#line 34 "../src/Backend/Device.vala"
	result = _tmp0_;
#line 34 "../src/Backend/Device.vala"
	return result;
#line 543 "Device.c"
}

static void
wacom_backend_device_set_product_id (WacomBackendDevice* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 34 "../src/Backend/Device.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Backend/Device.vala"
	old_value = wacom_backend_device_get_product_id (self);
#line 34 "../src/Backend/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 557 "Device.c"
		gchar* _tmp0_;
#line 34 "../src/Backend/Device.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/Backend/Device.vala"
		_g_free0 (self->priv->_product_id);
#line 34 "../src/Backend/Device.vala"
		self->priv->_product_id = _tmp0_;
#line 34 "../src/Backend/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_PRODUCT_ID_PROPERTY]);
#line 567 "Device.c"
	}
}

WacomBackendDeviceDeviceType
wacom_backend_device_get_dev_type (WacomBackendDevice* self)
{
	WacomBackendDeviceDeviceType result;
#line 35 "../src/Backend/Device.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 35 "../src/Backend/Device.vala"
	result = self->priv->_dev_type;
#line 35 "../src/Backend/Device.vala"
	return result;
#line 581 "Device.c"
}

static void
wacom_backend_device_set_dev_type (WacomBackendDevice* self,
                                   WacomBackendDeviceDeviceType value)
{
	WacomBackendDeviceDeviceType old_value;
#line 35 "../src/Backend/Device.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Backend/Device.vala"
	old_value = wacom_backend_device_get_dev_type (self);
#line 35 "../src/Backend/Device.vala"
	if (old_value != value) {
#line 35 "../src/Backend/Device.vala"
		self->priv->_dev_type = value;
#line 35 "../src/Backend/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_DEV_TYPE_PROPERTY]);
#line 599 "Device.c"
	}
}

static void
wacom_backend_device_class_init (WacomBackendDeviceClass * klass,
                                 gpointer klass_data)
{
#line 20 "../src/Backend/Device.vala"
	wacom_backend_device_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Backend/Device.vala"
	g_type_class_adjust_private_offset (klass, &WacomBackendDevice_private_offset);
#line 20 "../src/Backend/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wacom_backend_device_get_property;
#line 20 "../src/Backend/Device.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wacom_backend_device_set_property;
#line 20 "../src/Backend/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_backend_device_finalize;
#line 20 "../src/Backend/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_BACKEND_DEVICE_NAME_PROPERTY, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Backend/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_BACKEND_DEVICE_DEVICE_FILE_PROPERTY, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_DEVICE_FILE_PROPERTY] = g_param_spec_string ("device-file", "device-file", "device-file", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Backend/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_BACKEND_DEVICE_VENDOR_ID_PROPERTY, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_VENDOR_ID_PROPERTY] = g_param_spec_string ("vendor-id", "vendor-id", "vendor-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Backend/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_BACKEND_DEVICE_PRODUCT_ID_PROPERTY, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_PRODUCT_ID_PROPERTY] = g_param_spec_string ("product-id", "product-id", "product-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Backend/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_BACKEND_DEVICE_DEV_TYPE_PROPERTY, wacom_backend_device_properties[WACOM_BACKEND_DEVICE_DEV_TYPE_PROPERTY] = g_param_spec_flags ("dev-type", "dev-type", "dev-type", WACOM_BACKEND_DEVICE_TYPE_DEVICE_TYPE, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 627 "Device.c"
}

static void
wacom_backend_device_instance_init (WacomBackendDevice * self,
                                    gpointer klass)
{
#line 20 "../src/Backend/Device.vala"
	self->priv = wacom_backend_device_get_instance_private (self);
#line 636 "Device.c"
}

static void
wacom_backend_device_finalize (GObject * obj)
{
	WacomBackendDevice * self;
#line 20 "../src/Backend/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_BACKEND_TYPE_DEVICE, WacomBackendDevice);
#line 31 "../src/Backend/Device.vala"
	_g_free0 (self->priv->_name);
#line 32 "../src/Backend/Device.vala"
	_g_free0 (self->priv->_device_file);
#line 33 "../src/Backend/Device.vala"
	_g_free0 (self->priv->_vendor_id);
#line 34 "../src/Backend/Device.vala"
	_g_free0 (self->priv->_product_id);
#line 20 "../src/Backend/Device.vala"
	G_OBJECT_CLASS (wacom_backend_device_parent_class)->finalize (obj);
#line 655 "Device.c"
}

static GType
wacom_backend_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomBackendDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_backend_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomBackendDevice), 0, (GInstanceInitFunc) wacom_backend_device_instance_init, NULL };
	GType wacom_backend_device_type_id;
	wacom_backend_device_type_id = g_type_register_static (G_TYPE_OBJECT, "WacomBackendDevice", &g_define_type_info, 0);
	WacomBackendDevice_private_offset = g_type_add_instance_private (wacom_backend_device_type_id, sizeof (WacomBackendDevicePrivate));
	return wacom_backend_device_type_id;
}

GType
wacom_backend_device_get_type (void)
{
	static volatile gsize wacom_backend_device_type_id__once = 0;
	if (g_once_init_enter (&wacom_backend_device_type_id__once)) {
		GType wacom_backend_device_type_id;
		wacom_backend_device_type_id = wacom_backend_device_get_type_once ();
		g_once_init_leave (&wacom_backend_device_type_id__once, wacom_backend_device_type_id);
	}
	return wacom_backend_device_type_id__once;
}

static void
_vala_wacom_backend_device_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	WacomBackendDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WACOM_BACKEND_TYPE_DEVICE, WacomBackendDevice);
#line 20 "../src/Backend/Device.vala"
	switch (property_id) {
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_NAME_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		g_value_set_string (value, wacom_backend_device_get_name (self));
#line 20 "../src/Backend/Device.vala"
		break;
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_DEVICE_FILE_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		g_value_set_string (value, wacom_backend_device_get_device_file (self));
#line 20 "../src/Backend/Device.vala"
		break;
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_VENDOR_ID_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		g_value_set_string (value, wacom_backend_device_get_vendor_id (self));
#line 20 "../src/Backend/Device.vala"
		break;
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_PRODUCT_ID_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		g_value_set_string (value, wacom_backend_device_get_product_id (self));
#line 20 "../src/Backend/Device.vala"
		break;
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_DEV_TYPE_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		g_value_set_flags (value, wacom_backend_device_get_dev_type (self));
#line 20 "../src/Backend/Device.vala"
		break;
#line 720 "Device.c"
		default:
#line 20 "../src/Backend/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Backend/Device.vala"
		break;
#line 726 "Device.c"
	}
}

static void
_vala_wacom_backend_device_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	WacomBackendDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WACOM_BACKEND_TYPE_DEVICE, WacomBackendDevice);
#line 20 "../src/Backend/Device.vala"
	switch (property_id) {
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_NAME_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		wacom_backend_device_set_name (self, g_value_get_string (value));
#line 20 "../src/Backend/Device.vala"
		break;
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_DEVICE_FILE_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		wacom_backend_device_set_device_file (self, g_value_get_string (value));
#line 20 "../src/Backend/Device.vala"
		break;
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_VENDOR_ID_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		wacom_backend_device_set_vendor_id (self, g_value_get_string (value));
#line 20 "../src/Backend/Device.vala"
		break;
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_PRODUCT_ID_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		wacom_backend_device_set_product_id (self, g_value_get_string (value));
#line 20 "../src/Backend/Device.vala"
		break;
#line 20 "../src/Backend/Device.vala"
		case WACOM_BACKEND_DEVICE_DEV_TYPE_PROPERTY:
#line 20 "../src/Backend/Device.vala"
		wacom_backend_device_set_dev_type (self, g_value_get_flags (value));
#line 20 "../src/Backend/Device.vala"
		break;
#line 770 "Device.c"
		default:
#line 20 "../src/Backend/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Backend/Device.vala"
		break;
#line 776 "Device.c"
	}
}

