/* DeviceManagerX11.c generated by valac 0.56.14, the Vala compiler
 * generated from DeviceManagerX11.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "wacom.h"
#include <gee.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <gdk/gdkx.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <X11/extensions/XInput2.h>

enum  {
	WACOM_BACKEND_DEVICE_MANAGER_X11_0_PROPERTY,
	WACOM_BACKEND_DEVICE_MANAGER_X11_NUM_PROPERTIES
};
static GParamSpec* wacom_backend_device_manager_x11_properties[WACOM_BACKEND_DEVICE_MANAGER_X11_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WacomBackendDeviceManagerX11Private {
	GeeHashMap* devices;
};

static gint WacomBackendDeviceManagerX11_private_offset;
static gpointer wacom_backend_device_manager_x11_parent_class = NULL;

static void wacom_backend_device_manager_x11_add_device (WacomBackendDeviceManagerX11* self,
                                                  GdkDevice* gdk_device);
static void _wacom_backend_device_manager_x11_add_device_gdk_seat_device_added (GdkSeat* _sender,
                                                                         GdkDevice* device,
                                                                         gpointer self);
static void wacom_backend_device_manager_x11_remove_device (WacomBackendDeviceManagerX11* self,
                                                     GdkDevice* gdk_device);
static void _wacom_backend_device_manager_x11_remove_device_gdk_seat_device_removed (GdkSeat* _sender,
                                                                              GdkDevice* device,
                                                                              gpointer self);
static gchar* wacom_backend_device_manager_x11_get_xdevice_node (gint id);
static WacomBackendDevice* wacom_backend_device_manager_x11_create_device (GdkDevice* gdk_device,
                                                                    const gchar* device_file);
static GeeArrayList* wacom_backend_device_manager_x11_real_list_devices (WacomBackendDeviceManager* base,
                                                                  WacomBackendDeviceDeviceType type);
static WacomBackendDevice* wacom_backend_device_manager_x11_real_lookup_gdk_device (WacomBackendDeviceManager* base,
                                                                             GdkDevice* device);
static void wacom_backend_device_manager_x11_finalize (GObject * obj);
static GType wacom_backend_device_manager_x11_get_type_once (void);

static inline gpointer
wacom_backend_device_manager_x11_get_instance_private (WacomBackendDeviceManagerX11* self)
{
	return G_STRUCT_MEMBER_P (self, WacomBackendDeviceManagerX11_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/Backend/DeviceManagerX11.vala"
	return self ? g_object_ref (self) : NULL;
#line 90 "DeviceManagerX11.c"
}

static void
_wacom_backend_device_manager_x11_add_device_gdk_seat_device_added (GdkSeat* _sender,
                                                                    GdkDevice* device,
                                                                    gpointer self)
{
#line 27 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_manager_x11_add_device ((WacomBackendDeviceManagerX11*) self, device);
#line 100 "DeviceManagerX11.c"
}

static void
_wacom_backend_device_manager_x11_remove_device_gdk_seat_device_removed (GdkSeat* _sender,
                                                                         GdkDevice* device,
                                                                         gpointer self)
{
#line 28 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_manager_x11_remove_device ((WacomBackendDeviceManagerX11*) self, device);
#line 110 "DeviceManagerX11.c"
}

WacomBackendDeviceManagerX11*
wacom_backend_device_manager_x11_construct (GType object_type)
{
	WacomBackendDeviceManagerX11 * self = NULL;
	GeeHashMap* _tmp0_;
	GdkSeat* seat = NULL;
	GdkDisplay* _tmp1_;
	GdkSeat* _tmp2_;
	GdkSeat* _tmp3_;
	GdkSeat* _tmp4_;
	GdkSeat* _tmp5_;
	GList* devices = NULL;
	GdkSeat* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
#line 23 "../src/Backend/DeviceManagerX11.vala"
	self = (WacomBackendDeviceManagerX11*) wacom_backend_device_manager_construct (object_type);
#line 24 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = gee_hash_map_new (gdk_device_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, WACOM_BACKEND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 24 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (self->priv->devices);
#line 24 "../src/Backend/DeviceManagerX11.vala"
	self->priv->devices = _tmp0_;
#line 26 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = gdk_display_get_default ();
#line 26 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = gdk_display_get_default_seat (_tmp1_);
#line 26 "../src/Backend/DeviceManagerX11.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 26 "../src/Backend/DeviceManagerX11.vala"
	seat = _tmp3_;
#line 27 "../src/Backend/DeviceManagerX11.vala"
	_tmp4_ = seat;
#line 27 "../src/Backend/DeviceManagerX11.vala"
	g_signal_connect_object (_tmp4_, "device-added", (GCallback) _wacom_backend_device_manager_x11_add_device_gdk_seat_device_added, self, 0);
#line 28 "../src/Backend/DeviceManagerX11.vala"
	_tmp5_ = seat;
#line 28 "../src/Backend/DeviceManagerX11.vala"
	g_signal_connect_object (_tmp5_, "device-removed", (GCallback) _wacom_backend_device_manager_x11_remove_device_gdk_seat_device_removed, self, 0);
#line 30 "../src/Backend/DeviceManagerX11.vala"
	_tmp6_ = seat;
#line 30 "../src/Backend/DeviceManagerX11.vala"
	_tmp7_ = gdk_seat_get_slaves (_tmp6_, GDK_SEAT_CAPABILITY_ALL);
#line 30 "../src/Backend/DeviceManagerX11.vala"
	devices = _tmp7_;
#line 31 "../src/Backend/DeviceManagerX11.vala"
	_tmp8_ = devices;
#line 160 "DeviceManagerX11.c"
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
#line 31 "../src/Backend/DeviceManagerX11.vala"
		device_collection = _tmp8_;
#line 31 "../src/Backend/DeviceManagerX11.vala"
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 168 "DeviceManagerX11.c"
			GdkDevice* device = NULL;
#line 31 "../src/Backend/DeviceManagerX11.vala"
			device = (GdkDevice*) device_it->data;
#line 172 "DeviceManagerX11.c"
			{
				GdkDevice* _tmp9_;
#line 32 "../src/Backend/DeviceManagerX11.vala"
				_tmp9_ = device;
#line 32 "../src/Backend/DeviceManagerX11.vala"
				wacom_backend_device_manager_x11_add_device (self, _tmp9_);
#line 179 "DeviceManagerX11.c"
			}
		}
	}
#line 23 "../src/Backend/DeviceManagerX11.vala"
	(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
#line 23 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (seat);
#line 23 "../src/Backend/DeviceManagerX11.vala"
	return self;
#line 189 "DeviceManagerX11.c"
}

WacomBackendDeviceManagerX11*
wacom_backend_device_manager_x11_new (void)
{
#line 23 "../src/Backend/DeviceManagerX11.vala"
	return wacom_backend_device_manager_x11_construct (WACOM_BACKEND_TYPE_DEVICE_MANAGER_X11);
#line 197 "DeviceManagerX11.c"
}

static void
wacom_backend_device_manager_x11_add_device (WacomBackendDeviceManagerX11* self,
                                             GdkDevice* gdk_device)
{
	GdkDeviceType _tmp0_;
	GdkDeviceType _tmp1_;
	gint id = 0;
	gchar* device_file = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	WacomBackendDevice* device = NULL;
	GeeHashMap* _tmp6_;
	gpointer _tmp7_;
	WacomBackendDevice* _tmp8_;
#line 36 "../src/Backend/DeviceManagerX11.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Backend/DeviceManagerX11.vala"
	g_return_if_fail (gdk_device != NULL);
#line 37 "../src/Backend/DeviceManagerX11.vala"
	g_object_get (gdk_device, "type", &_tmp0_, NULL);
#line 37 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = _tmp0_;
#line 37 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp1_ == GDK_DEVICE_TYPE_MASTER) {
#line 38 "../src/Backend/DeviceManagerX11.vala"
		return;
#line 226 "DeviceManagerX11.c"
	}
#line 41 "../src/Backend/DeviceManagerX11.vala"
	id = -1;
#line 42 "../src/Backend/DeviceManagerX11.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (gdk_device, gdk_x11_device_xi2_get_type ())) {
#line 232 "DeviceManagerX11.c"
		gint _tmp2_;
		gint _tmp3_;
#line 43 "../src/Backend/DeviceManagerX11.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_TYPE (gdk_device, gdk_x11_device_xi2_get_type ()) ? ((GdkX11DeviceXI2*) gdk_device) : NULL, "device-id", &_tmp2_, NULL);
#line 43 "../src/Backend/DeviceManagerX11.vala"
		_tmp3_ = _tmp2_;
#line 43 "../src/Backend/DeviceManagerX11.vala"
		id = _tmp3_;
#line 241 "DeviceManagerX11.c"
	} else {
#line 45 "../src/Backend/DeviceManagerX11.vala"
		id = gdk_x11_device_get_id (G_TYPE_CHECK_INSTANCE_CAST (gdk_device, gdk_x11_device_core_get_type (), GdkX11DeviceCore));
#line 245 "DeviceManagerX11.c"
	}
#line 48 "../src/Backend/DeviceManagerX11.vala"
	if (id == -1) {
#line 49 "../src/Backend/DeviceManagerX11.vala"
		return;
#line 251 "DeviceManagerX11.c"
	}
#line 52 "../src/Backend/DeviceManagerX11.vala"
	_tmp4_ = wacom_backend_device_manager_x11_get_xdevice_node (id);
#line 52 "../src/Backend/DeviceManagerX11.vala"
	device_file = _tmp4_;
#line 53 "../src/Backend/DeviceManagerX11.vala"
	_tmp5_ = device_file;
#line 53 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp5_ == NULL) {
#line 54 "../src/Backend/DeviceManagerX11.vala"
		_g_free0 (device_file);
#line 54 "../src/Backend/DeviceManagerX11.vala"
		return;
#line 265 "DeviceManagerX11.c"
	}
#line 57 "../src/Backend/DeviceManagerX11.vala"
	_tmp6_ = self->priv->devices;
#line 57 "../src/Backend/DeviceManagerX11.vala"
	_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, gdk_device);
#line 57 "../src/Backend/DeviceManagerX11.vala"
	device = (WacomBackendDevice*) _tmp7_;
#line 58 "../src/Backend/DeviceManagerX11.vala"
	_tmp8_ = device;
#line 58 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp8_ != NULL) {
#line 277 "DeviceManagerX11.c"
		WacomBackendDevice* _tmp9_;
#line 59 "../src/Backend/DeviceManagerX11.vala"
		_tmp9_ = device;
#line 59 "../src/Backend/DeviceManagerX11.vala"
		g_signal_emit_by_name ((WacomBackendDeviceManager*) self, "device-changed", _tmp9_);
#line 283 "DeviceManagerX11.c"
	} else {
		const gchar* _tmp10_;
		WacomBackendDevice* _tmp11_;
		GeeHashMap* _tmp12_;
		WacomBackendDevice* _tmp13_;
		WacomBackendDevice* _tmp14_;
#line 61 "../src/Backend/DeviceManagerX11.vala"
		_tmp10_ = device_file;
#line 61 "../src/Backend/DeviceManagerX11.vala"
		_tmp11_ = wacom_backend_device_manager_x11_create_device (gdk_device, _tmp10_);
#line 61 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (device);
#line 61 "../src/Backend/DeviceManagerX11.vala"
		device = _tmp11_;
#line 62 "../src/Backend/DeviceManagerX11.vala"
		_tmp12_ = self->priv->devices;
#line 62 "../src/Backend/DeviceManagerX11.vala"
		_tmp13_ = device;
#line 62 "../src/Backend/DeviceManagerX11.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, gdk_device, _tmp13_);
#line 63 "../src/Backend/DeviceManagerX11.vala"
		_tmp14_ = device;
#line 63 "../src/Backend/DeviceManagerX11.vala"
		g_signal_emit_by_name ((WacomBackendDeviceManager*) self, "device-added", _tmp14_);
#line 308 "DeviceManagerX11.c"
	}
#line 36 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (device);
#line 36 "../src/Backend/DeviceManagerX11.vala"
	_g_free0 (device_file);
#line 314 "DeviceManagerX11.c"
}

static WacomBackendDevice*
wacom_backend_device_manager_x11_create_device (GdkDevice* gdk_device,
                                                const gchar* device_file)
{
	WacomBackendDevice* device = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GObject* _tmp4_;
	GObject* _tmp5_;
	WacomBackendDevice* result;
#line 67 "../src/Backend/DeviceManagerX11.vala"
	g_return_val_if_fail (gdk_device != NULL, NULL);
#line 67 "../src/Backend/DeviceManagerX11.vala"
	g_return_val_if_fail (device_file != NULL, NULL);
#line 68 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = gdk_device_get_name (gdk_device);
#line 68 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = _tmp0_;
#line 68 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = gdk_device_get_vendor_id (gdk_device);
#line 68 "../src/Backend/DeviceManagerX11.vala"
	_tmp3_ = gdk_device_get_product_id (gdk_device);
#line 68 "../src/Backend/DeviceManagerX11.vala"
	_tmp4_ = g_object_new (WACOM_BACKEND_TYPE_DEVICE, "name", _tmp1_, "device-file", device_file, "vendor-id", _tmp2_, "product-id", _tmp3_, "dev-type", wacom_backend_device_get_device_type (gdk_device), NULL);
#line 68 "../src/Backend/DeviceManagerX11.vala"
	_tmp5_ = G_IS_INITIALLY_UNOWNED (_tmp4_) ? g_object_ref_sink (_tmp4_) : _tmp4_;
#line 68 "../src/Backend/DeviceManagerX11.vala"
	device = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, WACOM_BACKEND_TYPE_DEVICE, WacomBackendDevice);
#line 77 "../src/Backend/DeviceManagerX11.vala"
	result = device;
#line 77 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 351 "DeviceManagerX11.c"
}

static void
wacom_backend_device_manager_x11_remove_device (WacomBackendDeviceManagerX11* self,
                                                GdkDevice* gdk_device)
{
	WacomBackendDevice* device = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	WacomBackendDevice* _tmp2_;
#line 80 "../src/Backend/DeviceManagerX11.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/Backend/DeviceManagerX11.vala"
	g_return_if_fail (gdk_device != NULL);
#line 81 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = self->priv->devices;
#line 81 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, gdk_device);
#line 81 "../src/Backend/DeviceManagerX11.vala"
	device = (WacomBackendDevice*) _tmp1_;
#line 83 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = device;
#line 83 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp2_ != NULL) {
#line 376 "DeviceManagerX11.c"
		WacomBackendDevice* _tmp3_;
		GeeHashMap* _tmp4_;
#line 84 "../src/Backend/DeviceManagerX11.vala"
		_tmp3_ = device;
#line 84 "../src/Backend/DeviceManagerX11.vala"
		g_signal_emit_by_name ((WacomBackendDeviceManager*) self, "device-removed", _tmp3_);
#line 85 "../src/Backend/DeviceManagerX11.vala"
		_tmp4_ = self->priv->devices;
#line 85 "../src/Backend/DeviceManagerX11.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, gdk_device, NULL);
#line 387 "DeviceManagerX11.c"
	}
#line 80 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (device);
#line 391 "DeviceManagerX11.c"
}

static gchar*
wacom_backend_device_manager_x11_get_xdevice_node (gint id)
{
	GdkDisplay* _tmp0_;
	Display* display = NULL;
	Display* _tmp1_;
	Atom prop = {0};
	Display* _tmp2_;
	Atom act_type = {0};
	gint act_format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	gint ret = 0;
	Display* _tmp3_;
	Atom _tmp4_ = {0};
	gint _tmp5_ = 0;
	gulong _tmp6_ = 0UL;
	gulong _tmp7_ = 0UL;
	void* _tmp8_ = NULL;
	gint _tmp9_;
	void* _tmp10_;
	gchar* _tmp11_;
	gchar* result;
#line 90 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = gdk_display_get_default ();
#line 90 "../src/Backend/DeviceManagerX11.vala"
	gdk_display_sync (_tmp0_);
#line 92 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = gdk_x11_get_default_xdisplay ();
#line 92 "../src/Backend/DeviceManagerX11.vala"
	display = _tmp1_;
#line 93 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = display;
#line 93 "../src/Backend/DeviceManagerX11.vala"
	prop = XInternAtom (_tmp2_, "Device Node", FALSE);
#line 100 "../src/Backend/DeviceManagerX11.vala"
	gdk_error_trap_push ();
#line 102 "../src/Backend/DeviceManagerX11.vala"
	_tmp3_ = display;
#line 102 "../src/Backend/DeviceManagerX11.vala"
	_tmp9_ = XIGetProperty (_tmp3_, id, prop, (glong) 0, (glong) 1000, FALSE, (Atom) AnyPropertyType, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_, (unsigned char **) (&_tmp8_));
#line 102 "../src/Backend/DeviceManagerX11.vala"
	act_type = _tmp4_;
#line 102 "../src/Backend/DeviceManagerX11.vala"
	act_format = _tmp5_;
#line 102 "../src/Backend/DeviceManagerX11.vala"
	n_items = _tmp6_;
#line 102 "../src/Backend/DeviceManagerX11.vala"
	bytes_after = _tmp7_;
#line 102 "../src/Backend/DeviceManagerX11.vala"
	data = _tmp8_;
#line 102 "../src/Backend/DeviceManagerX11.vala"
	ret = _tmp9_;
#line 117 "../src/Backend/DeviceManagerX11.vala"
	if (ret != Success) {
#line 118 "../src/Backend/DeviceManagerX11.vala"
		gdk_error_trap_pop_ignored ();
#line 119 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 119 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 456 "DeviceManagerX11.c"
	}
#line 122 "../src/Backend/DeviceManagerX11.vala"
	if (gdk_error_trap_pop () != 0) {
#line 123 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 123 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 464 "DeviceManagerX11.c"
	}
#line 126 "../src/Backend/DeviceManagerX11.vala"
	if (n_items == ((gulong) 0)) {
#line 127 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 127 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 472 "DeviceManagerX11.c"
	}
#line 130 "../src/Backend/DeviceManagerX11.vala"
	if (act_type != XA_STRING) {
#line 131 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 131 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 480 "DeviceManagerX11.c"
	}
#line 134 "../src/Backend/DeviceManagerX11.vala"
	if (act_format != 8) {
#line 135 "../src/Backend/DeviceManagerX11.vala"
		result = NULL;
#line 135 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 488 "DeviceManagerX11.c"
	}
#line 138 "../src/Backend/DeviceManagerX11.vala"
	_tmp10_ = data;
#line 138 "../src/Backend/DeviceManagerX11.vala"
	_tmp11_ = g_strdup ((const gchar*) _tmp10_);
#line 138 "../src/Backend/DeviceManagerX11.vala"
	result = _tmp11_;
#line 138 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 498 "DeviceManagerX11.c"
}

static GeeArrayList*
wacom_backend_device_manager_x11_real_list_devices (WacomBackendDeviceManager* base,
                                                    WacomBackendDeviceDeviceType type)
{
	WacomBackendDeviceManagerX11 * self;
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* result;
#line 141 "../src/Backend/DeviceManagerX11.vala"
	self = (WacomBackendDeviceManagerX11*) base;
#line 142 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = gee_array_list_new (WACOM_BACKEND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 142 "../src/Backend/DeviceManagerX11.vala"
	_result_ = _tmp0_;
#line 515 "DeviceManagerX11.c"
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 143 "../src/Backend/DeviceManagerX11.vala"
		_tmp1_ = self->priv->devices;
#line 143 "../src/Backend/DeviceManagerX11.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 143 "../src/Backend/DeviceManagerX11.vala"
		_tmp3_ = _tmp2_;
#line 143 "../src/Backend/DeviceManagerX11.vala"
		_tmp4_ = _tmp3_;
#line 143 "../src/Backend/DeviceManagerX11.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 143 "../src/Backend/DeviceManagerX11.vala"
		_tmp6_ = _tmp5_;
#line 143 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (_tmp4_);
#line 143 "../src/Backend/DeviceManagerX11.vala"
		_device_it = _tmp6_;
#line 143 "../src/Backend/DeviceManagerX11.vala"
		while (TRUE) {
#line 542 "DeviceManagerX11.c"
			GeeIterator* _tmp7_;
			WacomBackendDevice* device = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			WacomBackendDevice* _tmp10_;
			WacomBackendDeviceDeviceType _tmp11_;
			WacomBackendDeviceDeviceType _tmp12_;
#line 143 "../src/Backend/DeviceManagerX11.vala"
			_tmp7_ = _device_it;
#line 143 "../src/Backend/DeviceManagerX11.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 143 "../src/Backend/DeviceManagerX11.vala"
				break;
#line 556 "DeviceManagerX11.c"
			}
#line 143 "../src/Backend/DeviceManagerX11.vala"
			_tmp8_ = _device_it;
#line 143 "../src/Backend/DeviceManagerX11.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 143 "../src/Backend/DeviceManagerX11.vala"
			device = (WacomBackendDevice*) _tmp9_;
#line 144 "../src/Backend/DeviceManagerX11.vala"
			_tmp10_ = device;
#line 144 "../src/Backend/DeviceManagerX11.vala"
			_tmp11_ = wacom_backend_device_get_dev_type (_tmp10_);
#line 144 "../src/Backend/DeviceManagerX11.vala"
			_tmp12_ = _tmp11_;
#line 144 "../src/Backend/DeviceManagerX11.vala"
			if ((_tmp12_ & type) == type) {
#line 572 "DeviceManagerX11.c"
				GeeArrayList* _tmp13_;
				WacomBackendDevice* _tmp14_;
#line 145 "../src/Backend/DeviceManagerX11.vala"
				_tmp13_ = _result_;
#line 145 "../src/Backend/DeviceManagerX11.vala"
				_tmp14_ = device;
#line 145 "../src/Backend/DeviceManagerX11.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
#line 581 "DeviceManagerX11.c"
			}
#line 143 "../src/Backend/DeviceManagerX11.vala"
			_g_object_unref0 (device);
#line 585 "DeviceManagerX11.c"
		}
#line 143 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (_device_it);
#line 589 "DeviceManagerX11.c"
	}
#line 149 "../src/Backend/DeviceManagerX11.vala"
	result = _result_;
#line 149 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 595 "DeviceManagerX11.c"
}

static WacomBackendDevice*
wacom_backend_device_manager_x11_real_lookup_gdk_device (WacomBackendDeviceManager* base,
                                                         GdkDevice* device)
{
	WacomBackendDeviceManagerX11 * self;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	WacomBackendDevice* result;
#line 152 "../src/Backend/DeviceManagerX11.vala"
	self = (WacomBackendDeviceManagerX11*) base;
#line 152 "../src/Backend/DeviceManagerX11.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 153 "../src/Backend/DeviceManagerX11.vala"
	_tmp0_ = self->priv->devices;
#line 153 "../src/Backend/DeviceManagerX11.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, device);
#line 153 "../src/Backend/DeviceManagerX11.vala"
	result = (WacomBackendDevice*) _tmp1_;
#line 153 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 618 "DeviceManagerX11.c"
}

GdkDeviceToolType
wacom_backend_device_manager_x11_get_tool_type (GdkDevice* device)
{
	GdkDeviceToolType tool_type = 0;
	Atom act_type = {0};
	gint act_format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	gint id = 0;
	GdkX11Display* display = NULL;
	GdkDisplay* _tmp2_;
	GdkX11Display* _tmp3_;
	GdkX11Display* _tmp4_;
	gint ret = 0;
	GdkX11Display* _tmp5_;
	Display* _tmp6_;
	GdkX11Display* _tmp7_;
	Atom _tmp8_ = {0};
	gint _tmp9_ = 0;
	gulong _tmp10_ = 0UL;
	gulong _tmp11_ = 0UL;
	void* _tmp12_ = NULL;
	gint _tmp13_;
	GdkX11Display* _tmp14_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	Atom device_type = {0};
	void* _tmp17_;
	gchar* name = NULL;
	GdkX11Display* _tmp18_;
	Display* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	GdkDeviceToolType result;
#line 156 "../src/Backend/DeviceManagerX11.vala"
	g_return_val_if_fail (device != NULL, 0);
#line 157 "../src/Backend/DeviceManagerX11.vala"
	tool_type = GDK_DEVICE_TOOL_TYPE_UNKNOWN;
#line 164 "../src/Backend/DeviceManagerX11.vala"
	id = -1;
#line 165 "../src/Backend/DeviceManagerX11.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (device, gdk_x11_device_xi2_get_type ())) {
#line 664 "DeviceManagerX11.c"
		gint _tmp0_;
		gint _tmp1_;
#line 166 "../src/Backend/DeviceManagerX11.vala"
		g_object_get (G_TYPE_CHECK_INSTANCE_TYPE (device, gdk_x11_device_xi2_get_type ()) ? ((GdkX11DeviceXI2*) device) : NULL, "device-id", &_tmp0_, NULL);
#line 166 "../src/Backend/DeviceManagerX11.vala"
		_tmp1_ = _tmp0_;
#line 166 "../src/Backend/DeviceManagerX11.vala"
		id = _tmp1_;
#line 673 "DeviceManagerX11.c"
	} else {
#line 168 "../src/Backend/DeviceManagerX11.vala"
		id = gdk_x11_device_get_id (G_TYPE_CHECK_INSTANCE_CAST (device, gdk_x11_device_core_get_type (), GdkX11DeviceCore));
#line 677 "DeviceManagerX11.c"
	}
#line 171 "../src/Backend/DeviceManagerX11.vala"
	_tmp2_ = gdk_device_get_display (device);
#line 171 "../src/Backend/DeviceManagerX11.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp2_) : NULL);
#line 171 "../src/Backend/DeviceManagerX11.vala"
	display = _tmp3_;
#line 172 "../src/Backend/DeviceManagerX11.vala"
	_tmp4_ = display;
#line 172 "../src/Backend/DeviceManagerX11.vala"
	gdk_x11_display_error_trap_push (_tmp4_);
#line 174 "../src/Backend/DeviceManagerX11.vala"
	_tmp5_ = display;
#line 174 "../src/Backend/DeviceManagerX11.vala"
	_tmp6_ = gdk_x11_display_get_xdisplay (_tmp5_);
#line 174 "../src/Backend/DeviceManagerX11.vala"
	_tmp7_ = display;
#line 174 "../src/Backend/DeviceManagerX11.vala"
	_tmp13_ = XIGetProperty (_tmp6_, id, gdk_x11_get_xatom_by_name_for_display (_tmp7_, "Wacom Tool Type"), (glong) 0, (glong) 1, FALSE, XA_ATOM, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_, (unsigned char **) (&_tmp12_));
#line 174 "../src/Backend/DeviceManagerX11.vala"
	act_type = _tmp8_;
#line 174 "../src/Backend/DeviceManagerX11.vala"
	act_format = _tmp9_;
#line 174 "../src/Backend/DeviceManagerX11.vala"
	n_items = _tmp10_;
#line 174 "../src/Backend/DeviceManagerX11.vala"
	bytes_after = _tmp11_;
#line 174 "../src/Backend/DeviceManagerX11.vala"
	data = _tmp12_;
#line 174 "../src/Backend/DeviceManagerX11.vala"
	ret = _tmp13_;
#line 189 "../src/Backend/DeviceManagerX11.vala"
	_tmp14_ = display;
#line 189 "../src/Backend/DeviceManagerX11.vala"
	gdk_x11_display_error_trap_pop_ignored (_tmp14_);
#line 191 "../src/Backend/DeviceManagerX11.vala"
	if (ret != Success) {
#line 192 "../src/Backend/DeviceManagerX11.vala"
		result = tool_type;
#line 192 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (display);
#line 192 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 721 "DeviceManagerX11.c"
	}
#line 195 "../src/Backend/DeviceManagerX11.vala"
	if (act_type != XA_ATOM) {
#line 195 "../src/Backend/DeviceManagerX11.vala"
		_tmp16_ = TRUE;
#line 727 "DeviceManagerX11.c"
	} else {
#line 195 "../src/Backend/DeviceManagerX11.vala"
		_tmp16_ = act_format != 32;
#line 731 "DeviceManagerX11.c"
	}
#line 195 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp16_) {
#line 195 "../src/Backend/DeviceManagerX11.vala"
		_tmp15_ = TRUE;
#line 737 "DeviceManagerX11.c"
	} else {
#line 195 "../src/Backend/DeviceManagerX11.vala"
		_tmp15_ = n_items != ((gulong) 1);
#line 741 "DeviceManagerX11.c"
	}
#line 195 "../src/Backend/DeviceManagerX11.vala"
	if (_tmp15_) {
#line 196 "../src/Backend/DeviceManagerX11.vala"
		result = tool_type;
#line 196 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (display);
#line 196 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 751 "DeviceManagerX11.c"
	}
#line 200 "../src/Backend/DeviceManagerX11.vala"
	_tmp17_ = data;
#line 200 "../src/Backend/DeviceManagerX11.vala"
	device_type = *((Atom*) _tmp17_);
#line 201 "../src/Backend/DeviceManagerX11.vala"
	if (device_type == ((Atom) 0)) {
#line 202 "../src/Backend/DeviceManagerX11.vala"
		result = tool_type;
#line 202 "../src/Backend/DeviceManagerX11.vala"
		_g_object_unref0 (display);
#line 202 "../src/Backend/DeviceManagerX11.vala"
		return result;
#line 765 "DeviceManagerX11.c"
	}
#line 205 "../src/Backend/DeviceManagerX11.vala"
	_tmp18_ = display;
#line 205 "../src/Backend/DeviceManagerX11.vala"
	_tmp19_ = gdk_x11_display_get_xdisplay (_tmp18_);
#line 205 "../src/Backend/DeviceManagerX11.vala"
	_tmp20_ = XGetAtomName (_tmp19_, device_type);
#line 205 "../src/Backend/DeviceManagerX11.vala"
	name = _tmp20_;
#line 206 "../src/Backend/DeviceManagerX11.vala"
	_tmp21_ = name;
#line 206 "../src/Backend/DeviceManagerX11.vala"
	if (g_strcmp0 (_tmp21_, "STYLUS") == 0) {
#line 207 "../src/Backend/DeviceManagerX11.vala"
		tool_type = GDK_DEVICE_TOOL_TYPE_PEN;
#line 781 "DeviceManagerX11.c"
	} else {
		const gchar* _tmp22_;
#line 208 "../src/Backend/DeviceManagerX11.vala"
		_tmp22_ = name;
#line 208 "../src/Backend/DeviceManagerX11.vala"
		if (g_strcmp0 (_tmp22_, "CURSOR") == 0) {
#line 209 "../src/Backend/DeviceManagerX11.vala"
			tool_type = GDK_DEVICE_TOOL_TYPE_MOUSE;
#line 790 "DeviceManagerX11.c"
		} else {
			const gchar* _tmp23_;
#line 210 "../src/Backend/DeviceManagerX11.vala"
			_tmp23_ = name;
#line 210 "../src/Backend/DeviceManagerX11.vala"
			if (g_strcmp0 (_tmp23_, "ERASER") == 0) {
#line 211 "../src/Backend/DeviceManagerX11.vala"
				tool_type = GDK_DEVICE_TOOL_TYPE_ERASER;
#line 799 "DeviceManagerX11.c"
			}
		}
	}
#line 214 "../src/Backend/DeviceManagerX11.vala"
	result = tool_type;
#line 214 "../src/Backend/DeviceManagerX11.vala"
	_g_free0 (name);
#line 214 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (display);
#line 214 "../src/Backend/DeviceManagerX11.vala"
	return result;
#line 811 "DeviceManagerX11.c"
}

static void
wacom_backend_device_manager_x11_class_init (WacomBackendDeviceManagerX11Class * klass,
                                             gpointer klass_data)
{
#line 20 "../src/Backend/DeviceManagerX11.vala"
	wacom_backend_device_manager_x11_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Backend/DeviceManagerX11.vala"
	g_type_class_adjust_private_offset (klass, &WacomBackendDeviceManagerX11_private_offset);
#line 20 "../src/Backend/DeviceManagerX11.vala"
	((WacomBackendDeviceManagerClass *) klass)->list_devices = (GeeArrayList* (*) (WacomBackendDeviceManager*, WacomBackendDeviceDeviceType)) wacom_backend_device_manager_x11_real_list_devices;
#line 20 "../src/Backend/DeviceManagerX11.vala"
	((WacomBackendDeviceManagerClass *) klass)->lookup_gdk_device = (WacomBackendDevice* (*) (WacomBackendDeviceManager*, GdkDevice*)) wacom_backend_device_manager_x11_real_lookup_gdk_device;
#line 20 "../src/Backend/DeviceManagerX11.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_backend_device_manager_x11_finalize;
#line 828 "DeviceManagerX11.c"
}

static void
wacom_backend_device_manager_x11_instance_init (WacomBackendDeviceManagerX11 * self,
                                                gpointer klass)
{
#line 20 "../src/Backend/DeviceManagerX11.vala"
	self->priv = wacom_backend_device_manager_x11_get_instance_private (self);
#line 21 "../src/Backend/DeviceManagerX11.vala"
	self->priv->devices = NULL;
#line 839 "DeviceManagerX11.c"
}

static void
wacom_backend_device_manager_x11_finalize (GObject * obj)
{
	WacomBackendDeviceManagerX11 * self;
#line 20 "../src/Backend/DeviceManagerX11.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_BACKEND_TYPE_DEVICE_MANAGER_X11, WacomBackendDeviceManagerX11);
#line 21 "../src/Backend/DeviceManagerX11.vala"
	_g_object_unref0 (self->priv->devices);
#line 67 "../src/Backend/DeviceManagerX11.vala"
	G_OBJECT_CLASS (wacom_backend_device_manager_x11_parent_class)->finalize (obj);
#line 852 "DeviceManagerX11.c"
}

static GType
wacom_backend_device_manager_x11_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomBackendDeviceManagerX11Class), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_backend_device_manager_x11_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomBackendDeviceManagerX11), 0, (GInstanceInitFunc) wacom_backend_device_manager_x11_instance_init, NULL };
	GType wacom_backend_device_manager_x11_type_id;
	wacom_backend_device_manager_x11_type_id = g_type_register_static (WACOM_BACKEND_TYPE_DEVICE_MANAGER, "WacomBackendDeviceManagerX11", &g_define_type_info, 0);
	WacomBackendDeviceManagerX11_private_offset = g_type_add_instance_private (wacom_backend_device_manager_x11_type_id, sizeof (WacomBackendDeviceManagerX11Private));
	return wacom_backend_device_manager_x11_type_id;
}

GType
wacom_backend_device_manager_x11_get_type (void)
{
	static volatile gsize wacom_backend_device_manager_x11_type_id__once = 0;
	if (g_once_init_enter (&wacom_backend_device_manager_x11_type_id__once)) {
		GType wacom_backend_device_manager_x11_type_id;
		wacom_backend_device_manager_x11_type_id = wacom_backend_device_manager_x11_get_type_once ();
		g_once_init_leave (&wacom_backend_device_manager_x11_type_id__once, wacom_backend_device_manager_x11_type_id);
	}
	return wacom_backend_device_manager_x11_type_id__once;
}

