/* WacomDevice.c generated by valac 0.56.14, the Vala compiler
 * generated from WacomDevice.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "wacom.h"
#include <libwacom/libwacom.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#define WACOM_BACKEND_WACOM_DEVICE_WACOM_TABLET_SCHEMA "org.gnome.desktop.peripherals.tablet"
#define WACOM_BACKEND_WACOM_DEVICE_WACOM_SETTINGS_BASE "/org/gnome/desktop/peripherals/tablets/%s:%s/"

enum  {
	WACOM_BACKEND_WACOM_DEVICE_0_PROPERTY,
	WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY,
	WACOM_BACKEND_WACOM_DEVICE_IS_REVERSIBLE_PROPERTY,
	WACOM_BACKEND_WACOM_DEVICE_NUM_PROPERTIES
};
static GParamSpec* wacom_backend_wacom_device_properties[WACOM_BACKEND_WACOM_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _libwacom_destroy0(var) ((var == NULL) ? NULL : (var = (libwacom_destroy (var), NULL)))
#define _libwacom_database_destroy0(var) ((var == NULL) ? NULL : (var = (libwacom_database_destroy (var), NULL)))
#define __vala_WacomError_free_function_address_of0(var) ((var == NULL) ? NULL : (var = (_vala_WacomError_free_function_address_of (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _WacomBackendWacomDevicePrivate {
	WacomBackendDevice* _device;
	WacomDevice* wacom_device;
	GSettings* wacom_settings;
};

static gint WacomBackendWacomDevice_private_offset;
static gpointer wacom_backend_wacom_device_parent_class = NULL;
static WacomDeviceDatabase* wacom_backend_wacom_device_wacom_db;
static WacomDeviceDatabase* wacom_backend_wacom_device_wacom_db = NULL;

static void _vala_WacomError_free_function_address_of (WacomError* self);
static void wacom_backend_wacom_device_finalize (GObject * obj);
static GType wacom_backend_wacom_device_get_type_once (void);
static void _vala_wacom_backend_wacom_device_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_wacom_backend_wacom_device_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

GQuark
wacom_exception_quark (void)
{
#line 20 "../src/Backend/DeviceManagerX11.vala"
	return g_quark_from_static_string ("wacom-exception-quark");
#line 82 "WacomDevice.c"
}

static GType
wacom_exception_get_type_once (void)
{
	static const GEnumValue values[] = {{WACOM_EXCEPTION_LIBWACOM_ERROR, "WACOM_EXCEPTION_LIBWACOM_ERROR", "libwacom-error"}, {0, NULL, NULL}};
	GType wacom_exception_type_id;
	wacom_exception_type_id = g_enum_register_static ("WacomException", values);
	return wacom_exception_type_id;
}

GType
wacom_exception_get_type (void)
{
	static volatile gsize wacom_exception_type_id__once = 0;
	if (g_once_init_enter (&wacom_exception_type_id__once)) {
		GType wacom_exception_type_id;
		wacom_exception_type_id = wacom_exception_get_type_once ();
		g_once_init_leave (&wacom_exception_type_id__once, wacom_exception_type_id);
	}
	return wacom_exception_type_id__once;
}

static inline gpointer
wacom_backend_wacom_device_get_instance_private (WacomBackendWacomDevice* self)
{
	return G_STRUCT_MEMBER_P (self, WacomBackendWacomDevice_private_offset);
}

static void
_vala_WacomError_free_function_address_of (WacomError* self)
{
#line 54 "../src/Backend/WacomDevice.vala"
	libwacom_error_free (&self);
#line 117 "WacomDevice.c"
}

WacomBackendWacomDevice*
wacom_backend_wacom_device_construct (GType object_type,
                                      WacomBackendDevice* device,
                                      GError** error)
{
	WacomBackendWacomDevice * self = NULL;
	WacomDeviceDatabase* _tmp0_;
	WacomError* _error_ = NULL;
	WacomError* _tmp2_;
	WacomDeviceDatabase* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	WacomError* _tmp6_;
	WacomDevice* _tmp7_;
	WacomDevice* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 44 "../src/Backend/WacomDevice.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 45 "../src/Backend/WacomDevice.vala"
	self = (WacomBackendWacomDevice*) g_object_new (object_type, "device", device, NULL);
#line 47 "../src/Backend/WacomDevice.vala"
	_tmp0_ = wacom_backend_wacom_device_wacom_db;
#line 47 "../src/Backend/WacomDevice.vala"
	if (_tmp0_ == NULL) {
#line 144 "WacomDevice.c"
		WacomDeviceDatabase* _tmp1_;
#line 48 "../src/Backend/WacomDevice.vala"
		_tmp1_ = libwacom_database_new ();
#line 48 "../src/Backend/WacomDevice.vala"
		_libwacom_database_destroy0 (wacom_backend_wacom_device_wacom_db);
#line 48 "../src/Backend/WacomDevice.vala"
		wacom_backend_wacom_device_wacom_db = _tmp1_;
#line 152 "WacomDevice.c"
	}
#line 51 "../src/Backend/WacomDevice.vala"
	_tmp2_ = libwacom_error_new ();
#line 51 "../src/Backend/WacomDevice.vala"
	_error_ = _tmp2_;
#line 52 "../src/Backend/WacomDevice.vala"
	_tmp3_ = wacom_backend_wacom_device_wacom_db;
#line 52 "../src/Backend/WacomDevice.vala"
	_tmp4_ = wacom_backend_device_get_device_file (device);
#line 52 "../src/Backend/WacomDevice.vala"
	_tmp5_ = _tmp4_;
#line 52 "../src/Backend/WacomDevice.vala"
	_tmp6_ = _error_;
#line 52 "../src/Backend/WacomDevice.vala"
	_tmp7_ = libwacom_new_from_path (_tmp3_, _tmp5_, WFALLBACK_NONE, _tmp6_);
#line 52 "../src/Backend/WacomDevice.vala"
	_libwacom_destroy0 (self->priv->wacom_device);
#line 52 "../src/Backend/WacomDevice.vala"
	self->priv->wacom_device = _tmp7_;
#line 53 "../src/Backend/WacomDevice.vala"
	_tmp8_ = self->priv->wacom_device;
#line 53 "../src/Backend/WacomDevice.vala"
	if (_tmp8_ == NULL) {
#line 176 "WacomDevice.c"
		const gchar* _tmp9_ = NULL;
		WacomError* _tmp10_;
		const gchar* _tmp11_;
		GError* _tmp12_;
#line 54 "../src/Backend/WacomDevice.vala"
		_tmp10_ = _error_;
#line 54 "../src/Backend/WacomDevice.vala"
		_tmp11_ = libwacom_error_get_message (_tmp10_);
#line 54 "../src/Backend/WacomDevice.vala"
		_tmp9_ = _tmp11_;
#line 54 "../src/Backend/WacomDevice.vala"
		if (_tmp9_ == NULL) {
#line 54 "../src/Backend/WacomDevice.vala"
			_tmp9_ = "";
#line 191 "WacomDevice.c"
		}
#line 54 "../src/Backend/WacomDevice.vala"
		_tmp12_ = g_error_new_literal (WACOM_EXCEPTION, WACOM_EXCEPTION_LIBWACOM_ERROR, _tmp9_);
#line 54 "../src/Backend/WacomDevice.vala"
		_inner_error0_ = _tmp12_;
#line 54 "../src/Backend/WacomDevice.vala"
		if (_inner_error0_->domain == WACOM_EXCEPTION) {
#line 54 "../src/Backend/WacomDevice.vala"
			g_propagate_error (error, _inner_error0_);
#line 54 "../src/Backend/WacomDevice.vala"
			__vala_WacomError_free_function_address_of0 (_error_);
#line 54 "../src/Backend/WacomDevice.vala"
			_g_object_unref0 (self);
#line 54 "../src/Backend/WacomDevice.vala"
			return NULL;
#line 207 "WacomDevice.c"
		} else {
#line 54 "../src/Backend/WacomDevice.vala"
			__vala_WacomError_free_function_address_of0 (_error_);
#line 54 "../src/Backend/WacomDevice.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "../src/Backend/WacomDevice.vala"
			g_clear_error (&_inner_error0_);
#line 54 "../src/Backend/WacomDevice.vala"
			return NULL;
#line 217 "WacomDevice.c"
		}
	}
#line 44 "../src/Backend/WacomDevice.vala"
	__vala_WacomError_free_function_address_of0 (_error_);
#line 44 "../src/Backend/WacomDevice.vala"
	return self;
#line 224 "WacomDevice.c"
}

WacomBackendWacomDevice*
wacom_backend_wacom_device_new (WacomBackendDevice* device,
                                GError** error)
{
#line 44 "../src/Backend/WacomDevice.vala"
	return wacom_backend_wacom_device_construct (WACOM_BACKEND_TYPE_WACOM_DEVICE, device, error);
#line 233 "WacomDevice.c"
}

gint*
wacom_backend_wacom_device_get_supported_tools (WacomBackendWacomDevice* self,
                                                gint* result_length1)
{
	WacomDevice* _tmp0_;
	WacomDevice* _tmp3_;
	gint _tmp4_ = 0;
	gint* _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint* result;
#line 58 "../src/Backend/WacomDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../src/Backend/WacomDevice.vala"
	_tmp0_ = self->priv->wacom_device;
#line 59 "../src/Backend/WacomDevice.vala"
	if (_tmp0_ == NULL) {
#line 253 "WacomDevice.c"
		gint* _tmp1_;
		gint* _tmp2_;
		gint _tmp2__length1;
#line 60 "../src/Backend/WacomDevice.vala"
		_tmp1_ = g_new0 (gint, 0);
#line 60 "../src/Backend/WacomDevice.vala"
		_tmp2_ = _tmp1_;
#line 60 "../src/Backend/WacomDevice.vala"
		_tmp2__length1 = 0;
#line 60 "../src/Backend/WacomDevice.vala"
		if (result_length1) {
#line 60 "../src/Backend/WacomDevice.vala"
			*result_length1 = _tmp2__length1;
#line 267 "WacomDevice.c"
		}
#line 60 "../src/Backend/WacomDevice.vala"
		result = _tmp2_;
#line 60 "../src/Backend/WacomDevice.vala"
		return result;
#line 273 "WacomDevice.c"
	}
#line 63 "../src/Backend/WacomDevice.vala"
	_tmp3_ = self->priv->wacom_device;
#line 63 "../src/Backend/WacomDevice.vala"
	_tmp5_ = libwacom_get_supported_styli (_tmp3_, &_tmp4_);
#line 63 "../src/Backend/WacomDevice.vala"
	_tmp6_ = _tmp5_;
#line 63 "../src/Backend/WacomDevice.vala"
	_tmp6__length1 = _tmp4_;
#line 63 "../src/Backend/WacomDevice.vala"
	if (result_length1) {
#line 63 "../src/Backend/WacomDevice.vala"
		*result_length1 = _tmp6__length1;
#line 287 "WacomDevice.c"
	}
#line 63 "../src/Backend/WacomDevice.vala"
	result = _tmp6_;
#line 63 "../src/Backend/WacomDevice.vala"
	return result;
#line 293 "WacomDevice.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 72 "../src/Backend/WacomDevice.vala"
	return self ? g_object_ref (self) : NULL;
#line 301 "WacomDevice.c"
}

GSettings*
wacom_backend_wacom_device_get_settings (WacomBackendWacomDevice* self)
{
	GSettings* _tmp0_;
	GSettings* _tmp10_;
	GSettings* _tmp11_;
	GSettings* result;
#line 66 "../src/Backend/WacomDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../src/Backend/WacomDevice.vala"
	_tmp0_ = self->priv->wacom_settings;
#line 67 "../src/Backend/WacomDevice.vala"
	if (_tmp0_ == NULL) {
#line 317 "WacomDevice.c"
		gchar* path = NULL;
		WacomBackendDevice* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		WacomBackendDevice* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		GSettings* _tmp9_;
#line 68 "../src/Backend/WacomDevice.vala"
		_tmp1_ = self->priv->_device;
#line 68 "../src/Backend/WacomDevice.vala"
		_tmp2_ = wacom_backend_device_get_vendor_id (_tmp1_);
#line 68 "../src/Backend/WacomDevice.vala"
		_tmp3_ = _tmp2_;
#line 68 "../src/Backend/WacomDevice.vala"
		_tmp4_ = self->priv->_device;
#line 68 "../src/Backend/WacomDevice.vala"
		_tmp5_ = wacom_backend_device_get_product_id (_tmp4_);
#line 68 "../src/Backend/WacomDevice.vala"
		_tmp6_ = _tmp5_;
#line 68 "../src/Backend/WacomDevice.vala"
		_tmp7_ = g_strdup_printf (WACOM_BACKEND_WACOM_DEVICE_WACOM_SETTINGS_BASE, _tmp3_, _tmp6_);
#line 68 "../src/Backend/WacomDevice.vala"
		path = _tmp7_;
#line 69 "../src/Backend/WacomDevice.vala"
		_tmp8_ = path;
#line 69 "../src/Backend/WacomDevice.vala"
		_tmp9_ = g_settings_new_with_path (WACOM_BACKEND_WACOM_DEVICE_WACOM_TABLET_SCHEMA, _tmp8_);
#line 69 "../src/Backend/WacomDevice.vala"
		_g_object_unref0 (self->priv->wacom_settings);
#line 69 "../src/Backend/WacomDevice.vala"
		self->priv->wacom_settings = _tmp9_;
#line 67 "../src/Backend/WacomDevice.vala"
		_g_free0 (path);
#line 354 "WacomDevice.c"
	}
#line 72 "../src/Backend/WacomDevice.vala"
	_tmp10_ = self->priv->wacom_settings;
#line 72 "../src/Backend/WacomDevice.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 72 "../src/Backend/WacomDevice.vala"
	result = _tmp11_;
#line 72 "../src/Backend/WacomDevice.vala"
	return result;
#line 364 "WacomDevice.c"
}

WacomBackendDevice*
wacom_backend_wacom_device_get_device (WacomBackendWacomDevice* self)
{
	WacomBackendDevice* result;
	WacomBackendDevice* _tmp0_;
#line 28 "../src/Backend/WacomDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Backend/WacomDevice.vala"
	_tmp0_ = self->priv->_device;
#line 28 "../src/Backend/WacomDevice.vala"
	result = _tmp0_;
#line 28 "../src/Backend/WacomDevice.vala"
	return result;
#line 380 "WacomDevice.c"
}

static void
wacom_backend_wacom_device_set_device (WacomBackendWacomDevice* self,
                                       WacomBackendDevice* value)
{
	WacomBackendDevice* old_value;
#line 28 "../src/Backend/WacomDevice.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Backend/WacomDevice.vala"
	old_value = wacom_backend_wacom_device_get_device (self);
#line 28 "../src/Backend/WacomDevice.vala"
	if (old_value != value) {
#line 394 "WacomDevice.c"
		WacomBackendDevice* _tmp0_;
#line 28 "../src/Backend/WacomDevice.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/Backend/WacomDevice.vala"
		_g_object_unref0 (self->priv->_device);
#line 28 "../src/Backend/WacomDevice.vala"
		self->priv->_device = _tmp0_;
#line 28 "../src/Backend/WacomDevice.vala"
		g_object_notify_by_pspec ((GObject *) self, wacom_backend_wacom_device_properties[WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY]);
#line 404 "WacomDevice.c"
	}
}

static gboolean
_vala_libwacom_is_reversible (WacomDevice* self)
{
	gboolean result;
#line 165 "libwacom.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 166 "libwacom.vapi"
	result = libwacom_is_reversible (self) != 0;
#line 166 "libwacom.vapi"
	return result;
#line 418 "WacomDevice.c"
}

gboolean
wacom_backend_wacom_device_get_is_reversible (WacomBackendWacomDevice* self)
{
	gboolean result;
	WacomDevice* _tmp0_;
	WacomDevice* _tmp1_;
#line 35 "../src/Backend/WacomDevice.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Backend/WacomDevice.vala"
	_tmp0_ = self->priv->wacom_device;
#line 36 "../src/Backend/WacomDevice.vala"
	if (_tmp0_ == NULL) {
#line 37 "../src/Backend/WacomDevice.vala"
		result = FALSE;
#line 37 "../src/Backend/WacomDevice.vala"
		return result;
#line 437 "WacomDevice.c"
	}
#line 40 "../src/Backend/WacomDevice.vala"
	_tmp1_ = self->priv->wacom_device;
#line 40 "../src/Backend/WacomDevice.vala"
	result = _vala_libwacom_is_reversible (_tmp1_);
#line 40 "../src/Backend/WacomDevice.vala"
	return result;
#line 445 "WacomDevice.c"
}

static void
wacom_backend_wacom_device_class_init (WacomBackendWacomDeviceClass * klass,
                                       gpointer klass_data)
{
#line 24 "../src/Backend/WacomDevice.vala"
	wacom_backend_wacom_device_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Backend/WacomDevice.vala"
	g_type_class_adjust_private_offset (klass, &WacomBackendWacomDevice_private_offset);
#line 24 "../src/Backend/WacomDevice.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_wacom_backend_wacom_device_get_property;
#line 24 "../src/Backend/WacomDevice.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_wacom_backend_wacom_device_set_property;
#line 24 "../src/Backend/WacomDevice.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_backend_wacom_device_finalize;
#line 24 "../src/Backend/WacomDevice.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY, wacom_backend_wacom_device_properties[WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", WACOM_BACKEND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Backend/WacomDevice.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WACOM_BACKEND_WACOM_DEVICE_IS_REVERSIBLE_PROPERTY, wacom_backend_wacom_device_properties[WACOM_BACKEND_WACOM_DEVICE_IS_REVERSIBLE_PROPERTY] = g_param_spec_boolean ("is-reversible", "is-reversible", "is-reversible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 466 "WacomDevice.c"
}

static void
wacom_backend_wacom_device_instance_init (WacomBackendWacomDevice * self,
                                          gpointer klass)
{
#line 24 "../src/Backend/WacomDevice.vala"
	self->priv = wacom_backend_wacom_device_get_instance_private (self);
#line 29 "../src/Backend/WacomDevice.vala"
	self->priv->wacom_device = NULL;
#line 30 "../src/Backend/WacomDevice.vala"
	self->priv->wacom_settings = NULL;
#line 479 "WacomDevice.c"
}

static void
wacom_backend_wacom_device_finalize (GObject * obj)
{
	WacomBackendWacomDevice * self;
#line 24 "../src/Backend/WacomDevice.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_BACKEND_TYPE_WACOM_DEVICE, WacomBackendWacomDevice);
#line 28 "../src/Backend/WacomDevice.vala"
	_g_object_unref0 (self->priv->_device);
#line 29 "../src/Backend/WacomDevice.vala"
	_libwacom_destroy0 (self->priv->wacom_device);
#line 30 "../src/Backend/WacomDevice.vala"
	_g_object_unref0 (self->priv->wacom_settings);
#line 24 "../src/Backend/WacomDevice.vala"
	G_OBJECT_CLASS (wacom_backend_wacom_device_parent_class)->finalize (obj);
#line 496 "WacomDevice.c"
}

static GType
wacom_backend_wacom_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomBackendWacomDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_backend_wacom_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomBackendWacomDevice), 0, (GInstanceInitFunc) wacom_backend_wacom_device_instance_init, NULL };
	GType wacom_backend_wacom_device_type_id;
	wacom_backend_wacom_device_type_id = g_type_register_static (G_TYPE_OBJECT, "WacomBackendWacomDevice", &g_define_type_info, 0);
	WacomBackendWacomDevice_private_offset = g_type_add_instance_private (wacom_backend_wacom_device_type_id, sizeof (WacomBackendWacomDevicePrivate));
	return wacom_backend_wacom_device_type_id;
}

GType
wacom_backend_wacom_device_get_type (void)
{
	static volatile gsize wacom_backend_wacom_device_type_id__once = 0;
	if (g_once_init_enter (&wacom_backend_wacom_device_type_id__once)) {
		GType wacom_backend_wacom_device_type_id;
		wacom_backend_wacom_device_type_id = wacom_backend_wacom_device_get_type_once ();
		g_once_init_leave (&wacom_backend_wacom_device_type_id__once, wacom_backend_wacom_device_type_id);
	}
	return wacom_backend_wacom_device_type_id__once;
}

static void
_vala_wacom_backend_wacom_device_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	WacomBackendWacomDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WACOM_BACKEND_TYPE_WACOM_DEVICE, WacomBackendWacomDevice);
#line 24 "../src/Backend/WacomDevice.vala"
	switch (property_id) {
#line 24 "../src/Backend/WacomDevice.vala"
		case WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY:
#line 24 "../src/Backend/WacomDevice.vala"
		g_value_set_object (value, wacom_backend_wacom_device_get_device (self));
#line 24 "../src/Backend/WacomDevice.vala"
		break;
#line 24 "../src/Backend/WacomDevice.vala"
		case WACOM_BACKEND_WACOM_DEVICE_IS_REVERSIBLE_PROPERTY:
#line 24 "../src/Backend/WacomDevice.vala"
		g_value_set_boolean (value, wacom_backend_wacom_device_get_is_reversible (self));
#line 24 "../src/Backend/WacomDevice.vala"
		break;
#line 543 "WacomDevice.c"
		default:
#line 24 "../src/Backend/WacomDevice.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Backend/WacomDevice.vala"
		break;
#line 549 "WacomDevice.c"
	}
}

static void
_vala_wacom_backend_wacom_device_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	WacomBackendWacomDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WACOM_BACKEND_TYPE_WACOM_DEVICE, WacomBackendWacomDevice);
#line 24 "../src/Backend/WacomDevice.vala"
	switch (property_id) {
#line 24 "../src/Backend/WacomDevice.vala"
		case WACOM_BACKEND_WACOM_DEVICE_DEVICE_PROPERTY:
#line 24 "../src/Backend/WacomDevice.vala"
		wacom_backend_wacom_device_set_device (self, g_value_get_object (value));
#line 24 "../src/Backend/WacomDevice.vala"
		break;
#line 569 "WacomDevice.c"
		default:
#line 24 "../src/Backend/WacomDevice.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Backend/WacomDevice.vala"
		break;
#line 575 "WacomDevice.c"
	}
}

