/* WacomToolMap.c generated by valac 0.56.14, the Vala compiler
 * generated from WacomToolMap.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "wacom.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gstdio.h>

#define WACOM_BACKEND_WACOM_TOOL_MAP_GENERIC_STYLUS "Generic"
#define WACOM_BACKEND_WACOM_TOOL_MAP_KEY_TOOL_ID "ID"
#define WACOM_BACKEND_WACOM_TOOL_MAP_KEY_DEVICE_STYLI "Styli"

enum  {
	WACOM_BACKEND_WACOM_TOOL_MAP_0_PROPERTY,
	WACOM_BACKEND_WACOM_TOOL_MAP_NUM_PROPERTIES
};
static GParamSpec* wacom_backend_wacom_tool_map_properties[WACOM_BACKEND_WACOM_TOOL_MAP_NUM_PROPERTIES];
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _WacomBackendWacomToolMapPrivate {
	GKeyFile* tablets;
	GKeyFile* tools;
	gchar* tablet_path;
	gchar* tool_path;
	GeeHashMap* tablet_map;
	GeeHashMap* tool_map;
	GeeHashMap* no_serial_tool_map;
};

static gint WacomBackendWacomToolMap_private_offset;
static gpointer wacom_backend_wacom_tool_map_parent_class = NULL;
static GOnce wacom_backend_wacom_tool_map_instance;
static GOnce wacom_backend_wacom_tool_map_instance = G_ONCE_INIT;

static WacomBackendWacomToolMap* __lambda5_ (void);
static gpointer ___lambda5__gthread_func (gpointer self);
static void wacom_backend_wacom_tool_map_load_keyfiles (WacomBackendWacomToolMap* self);
static void wacom_backend_wacom_tool_map_cache_tools (WacomBackendWacomToolMap* self);
static void wacom_backend_wacom_tool_map_cache_devices (WacomBackendWacomToolMap* self);
static gchar* wacom_backend_wacom_tool_map_get_device_key (WacomBackendWacomDevice* device);
static gchar* wacom_backend_wacom_tool_map_get_tool_key (guint64 serial);
static void wacom_backend_wacom_tool_map_keyfile_add_stylus (WacomBackendWacomToolMap* self,
                                                      const gchar* tool_key,
                                                      guint64 id);
static void wacom_backend_wacom_tool_map_keyfile_add_device_stylus (WacomBackendWacomToolMap* self,
                                                             const gchar* device_key,
                                                             const gchar* tool_key);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void wacom_backend_wacom_tool_map_finalize (GObject * obj);
static GType wacom_backend_wacom_tool_map_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
wacom_backend_wacom_tool_map_get_instance_private (WacomBackendWacomToolMap* self)
{
	return G_STRUCT_MEMBER_P (self, WacomBackendWacomToolMap_private_offset);
}

static WacomBackendWacomToolMap*
__lambda5_ (void)
{
	WacomBackendWacomToolMap* _tmp0_;
	WacomBackendWacomToolMap* result;
#line 38 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = wacom_backend_wacom_tool_map_new ();
#line 38 "../src/Backend/WacomToolMap.vala"
	result = _tmp0_;
#line 38 "../src/Backend/WacomToolMap.vala"
	return result;
#line 110 "WacomToolMap.c"
}

static gpointer
___lambda5__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda5_ ();
#line 37 "../src/Backend/WacomToolMap.vala"
	return result;
#line 120 "WacomToolMap.c"
}

WacomBackendWacomToolMap*
wacom_backend_wacom_tool_map_get_default (void)
{
	gconstpointer _tmp0_;
	WacomBackendWacomToolMap* result;
#line 37 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = g_once (&wacom_backend_wacom_tool_map_instance, ___lambda5__gthread_func, NULL);
#line 37 "../src/Backend/WacomToolMap.vala"
	result = (WacomBackendWacomToolMap*) _tmp0_;
#line 37 "../src/Backend/WacomToolMap.vala"
	return result;
#line 134 "WacomToolMap.c"
}

WacomBackendWacomToolMap*
wacom_backend_wacom_tool_map_construct (GType object_type)
{
	WacomBackendWacomToolMap * self = NULL;
	GKeyFile* _tmp0_;
	GKeyFile* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
#line 42 "../src/Backend/WacomToolMap.vala"
	self = (WacomBackendWacomToolMap*) g_object_new (object_type, NULL);
#line 43 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = g_key_file_new ();
#line 43 "../src/Backend/WacomToolMap.vala"
	_g_key_file_unref0 (self->priv->tablets);
#line 43 "../src/Backend/WacomToolMap.vala"
	self->priv->tablets = _tmp0_;
#line 44 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = g_key_file_new ();
#line 44 "../src/Backend/WacomToolMap.vala"
	_g_key_file_unref0 (self->priv->tools);
#line 44 "../src/Backend/WacomToolMap.vala"
	self->priv->tools = _tmp1_;
#line 46 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 46 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->tablet_map);
#line 46 "../src/Backend/WacomToolMap.vala"
	self->priv->tablet_map = _tmp2_;
#line 47 "../src/Backend/WacomToolMap.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 47 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->tool_map);
#line 47 "../src/Backend/WacomToolMap.vala"
	self->priv->tool_map = _tmp3_;
#line 48 "../src/Backend/WacomToolMap.vala"
	_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->no_serial_tool_map);
#line 48 "../src/Backend/WacomToolMap.vala"
	self->priv->no_serial_tool_map = _tmp4_;
#line 50 "../src/Backend/WacomToolMap.vala"
	wacom_backend_wacom_tool_map_load_keyfiles (self);
#line 51 "../src/Backend/WacomToolMap.vala"
	wacom_backend_wacom_tool_map_cache_tools (self);
#line 52 "../src/Backend/WacomToolMap.vala"
	wacom_backend_wacom_tool_map_cache_devices (self);
#line 42 "../src/Backend/WacomToolMap.vala"
	return self;
#line 186 "WacomToolMap.c"
}

WacomBackendWacomToolMap*
wacom_backend_wacom_tool_map_new (void)
{
#line 42 "../src/Backend/WacomToolMap.vala"
	return wacom_backend_wacom_tool_map_construct (WACOM_BACKEND_TYPE_WACOM_TOOL_MAP);
#line 194 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_load_keyfiles (WacomBackendWacomToolMap* self)
{
	gchar* dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 55 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 56 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = g_build_filename (_tmp0_, "io.elementary.switchboard", "wacom", NULL);
#line 56 "../src/Backend/WacomToolMap.vala"
	dir = _tmp1_;
#line 58 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = dir;
#line 58 "../src/Backend/WacomToolMap.vala"
	if (g_mkdir_with_parents (_tmp2_, 0700) < 0) {
#line 221 "WacomToolMap.c"
		const gchar* _tmp3_;
#line 59 "../src/Backend/WacomToolMap.vala"
		_tmp3_ = dir;
#line 59 "../src/Backend/WacomToolMap.vala"
		g_warning ("WacomToolMap.vala:59: Could not create directory '%s', stylus mapping " \
"may not work well", _tmp3_);
#line 60 "../src/Backend/WacomToolMap.vala"
		_g_free0 (dir);
#line 60 "../src/Backend/WacomToolMap.vala"
		return;
#line 231 "WacomToolMap.c"
	}
#line 63 "../src/Backend/WacomToolMap.vala"
	_tmp4_ = dir;
#line 63 "../src/Backend/WacomToolMap.vala"
	_tmp5_ = g_build_filename (_tmp4_, "devices", NULL);
#line 63 "../src/Backend/WacomToolMap.vala"
	_g_free0 (self->priv->tablet_path);
#line 63 "../src/Backend/WacomToolMap.vala"
	self->priv->tablet_path = _tmp5_;
#line 241 "WacomToolMap.c"
	{
		GKeyFile* _tmp6_;
		const gchar* _tmp7_;
#line 65 "../src/Backend/WacomToolMap.vala"
		_tmp6_ = self->priv->tablets;
#line 65 "../src/Backend/WacomToolMap.vala"
		_tmp7_ = self->priv->tablet_path;
#line 65 "../src/Backend/WacomToolMap.vala"
		g_key_file_load_from_file (_tmp6_, _tmp7_, G_KEY_FILE_NONE, &_inner_error0_);
#line 65 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 253 "WacomToolMap.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 64 "../src/Backend/WacomToolMap.vala"
		e = _inner_error0_;
#line 64 "../src/Backend/WacomToolMap.vala"
		_inner_error0_ = NULL;
#line 67 "../src/Backend/WacomToolMap.vala"
		_tmp8_ = self->priv->tablet_path;
#line 67 "../src/Backend/WacomToolMap.vala"
		_tmp9_ = e;
#line 67 "../src/Backend/WacomToolMap.vala"
		_tmp10_ = _tmp9_->message;
#line 67 "../src/Backend/WacomToolMap.vala"
		g_warning ("WacomToolMap.vala:67: Could not load tablets keyfile '%s': %s", _tmp8_, _tmp10_);
#line 64 "../src/Backend/WacomToolMap.vala"
		_g_error_free0 (e);
#line 278 "WacomToolMap.c"
	}
	__finally0:
#line 64 "../src/Backend/WacomToolMap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/Backend/WacomToolMap.vala"
		_g_free0 (dir);
#line 64 "../src/Backend/WacomToolMap.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/Backend/WacomToolMap.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/Backend/WacomToolMap.vala"
		return;
#line 291 "WacomToolMap.c"
	}
#line 70 "../src/Backend/WacomToolMap.vala"
	_tmp11_ = dir;
#line 70 "../src/Backend/WacomToolMap.vala"
	_tmp12_ = g_build_filename (_tmp11_, "tools", NULL);
#line 70 "../src/Backend/WacomToolMap.vala"
	_g_free0 (self->priv->tool_path);
#line 70 "../src/Backend/WacomToolMap.vala"
	self->priv->tool_path = _tmp12_;
#line 301 "WacomToolMap.c"
	{
		GKeyFile* _tmp13_;
		const gchar* _tmp14_;
#line 72 "../src/Backend/WacomToolMap.vala"
		_tmp13_ = self->priv->tools;
#line 72 "../src/Backend/WacomToolMap.vala"
		_tmp14_ = self->priv->tool_path;
#line 72 "../src/Backend/WacomToolMap.vala"
		g_key_file_load_from_file (_tmp13_, _tmp14_, G_KEY_FILE_NONE, &_inner_error0_);
#line 72 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "WacomToolMap.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 71 "../src/Backend/WacomToolMap.vala"
		e = _inner_error0_;
#line 71 "../src/Backend/WacomToolMap.vala"
		_inner_error0_ = NULL;
#line 74 "../src/Backend/WacomToolMap.vala"
		_tmp15_ = self->priv->tool_path;
#line 74 "../src/Backend/WacomToolMap.vala"
		_tmp16_ = e;
#line 74 "../src/Backend/WacomToolMap.vala"
		_tmp17_ = _tmp16_->message;
#line 74 "../src/Backend/WacomToolMap.vala"
		g_warning ("WacomToolMap.vala:74: Could not load tools keyfile '%s': %s", _tmp15_, _tmp17_);
#line 71 "../src/Backend/WacomToolMap.vala"
		_g_error_free0 (e);
#line 338 "WacomToolMap.c"
	}
	__finally1:
#line 71 "../src/Backend/WacomToolMap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../src/Backend/WacomToolMap.vala"
		_g_free0 (dir);
#line 71 "../src/Backend/WacomToolMap.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 71 "../src/Backend/WacomToolMap.vala"
		g_clear_error (&_inner_error0_);
#line 71 "../src/Backend/WacomToolMap.vala"
		return;
#line 351 "WacomToolMap.c"
	}
#line 55 "../src/Backend/WacomToolMap.vala"
	_g_free0 (dir);
#line 355 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_cache_tools (WacomBackendWacomToolMap* self)
{
	gchar** serials = NULL;
	GKeyFile* _tmp0_;
	gsize _tmp1_ = 0;
	gchar** _tmp2_;
	gint serials_length1;
	gint _serials_size_;
	GError* _inner_error0_ = NULL;
#line 78 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = self->priv->tools;
#line 79 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = g_key_file_get_groups (_tmp0_, &_tmp1_);
#line 79 "../src/Backend/WacomToolMap.vala"
	serials = _tmp2_;
#line 79 "../src/Backend/WacomToolMap.vala"
	serials_length1 = _tmp1_;
#line 79 "../src/Backend/WacomToolMap.vala"
	_serials_size_ = serials_length1;
#line 380 "WacomToolMap.c"
	{
		gint i = 0;
#line 80 "../src/Backend/WacomToolMap.vala"
		i = 0;
#line 385 "WacomToolMap.c"
		{
			gboolean _tmp3_ = FALSE;
#line 80 "../src/Backend/WacomToolMap.vala"
			_tmp3_ = TRUE;
#line 80 "../src/Backend/WacomToolMap.vala"
			while (TRUE) {
#line 392 "WacomToolMap.c"
				gchar** _tmp5_;
				gint _tmp5__length1;
				guint64 serial = 0ULL;
				guint64 id = 0ULL;
				gchar* str = NULL;
#line 80 "../src/Backend/WacomToolMap.vala"
				if (!_tmp3_) {
#line 400 "WacomToolMap.c"
					gint _tmp4_;
#line 80 "../src/Backend/WacomToolMap.vala"
					_tmp4_ = i;
#line 80 "../src/Backend/WacomToolMap.vala"
					i = _tmp4_ + 1;
#line 406 "WacomToolMap.c"
				}
#line 80 "../src/Backend/WacomToolMap.vala"
				_tmp3_ = FALSE;
#line 80 "../src/Backend/WacomToolMap.vala"
				_tmp5_ = serials;
#line 80 "../src/Backend/WacomToolMap.vala"
				_tmp5__length1 = serials_length1;
#line 80 "../src/Backend/WacomToolMap.vala"
				if (!(i < _tmp5__length1)) {
#line 80 "../src/Backend/WacomToolMap.vala"
					break;
#line 418 "WacomToolMap.c"
				}
				{
					gboolean _tmp6_ = FALSE;
					gchar** _tmp7_;
					gint _tmp7__length1;
					const gchar* _tmp8_;
					guint64 _tmp9_ = 0ULL;
					gboolean _tmp10_;
#line 83 "../src/Backend/WacomToolMap.vala"
					_tmp7_ = serials;
#line 83 "../src/Backend/WacomToolMap.vala"
					_tmp7__length1 = serials_length1;
#line 83 "../src/Backend/WacomToolMap.vala"
					_tmp8_ = _tmp7_[i];
#line 83 "../src/Backend/WacomToolMap.vala"
					_tmp10_ = g_ascii_string_to_unsigned (_tmp8_, (guint) 16, 0ULL, G_MAXUINT64, &_tmp9_, &_inner_error0_);
#line 83 "../src/Backend/WacomToolMap.vala"
					serial = _tmp9_;
#line 83 "../src/Backend/WacomToolMap.vala"
					_tmp6_ = _tmp10_;
#line 83 "../src/Backend/WacomToolMap.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 441 "WacomToolMap.c"
						goto __catch0_g_error;
					}
#line 83 "../src/Backend/WacomToolMap.vala"
					if (!_tmp6_) {
#line 446 "WacomToolMap.c"
						gchar** _tmp11_;
						gint _tmp11__length1;
						const gchar* _tmp12_;
#line 84 "../src/Backend/WacomToolMap.vala"
						_tmp11_ = serials;
#line 84 "../src/Backend/WacomToolMap.vala"
						_tmp11__length1 = serials_length1;
#line 84 "../src/Backend/WacomToolMap.vala"
						_tmp12_ = _tmp11_[i];
#line 84 "../src/Backend/WacomToolMap.vala"
						g_warning ("WacomToolMap.vala:84: Invalid tool serial %s", _tmp12_);
#line 85 "../src/Backend/WacomToolMap.vala"
						continue;
#line 460 "WacomToolMap.c"
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
#line 82 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 88 "../src/Backend/WacomToolMap.vala"
					_tmp13_ = serials;
#line 88 "../src/Backend/WacomToolMap.vala"
					_tmp13__length1 = serials_length1;
#line 88 "../src/Backend/WacomToolMap.vala"
					_tmp14_ = _tmp13_[i];
#line 88 "../src/Backend/WacomToolMap.vala"
					g_warning ("WacomToolMap.vala:88: Invalid tool serial %s", _tmp14_);
#line 89 "../src/Backend/WacomToolMap.vala"
					continue;
#line 481 "WacomToolMap.c"
				}
				__finally0:
#line 82 "../src/Backend/WacomToolMap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "../src/Backend/WacomToolMap.vala"
					serials = (_vala_array_free (serials, serials_length1, (GDestroyNotify) g_free), NULL);
#line 82 "../src/Backend/WacomToolMap.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 82 "../src/Backend/WacomToolMap.vala"
					return;
#line 494 "WacomToolMap.c"
				}
				{
					gchar* _tmp15_ = NULL;
					GKeyFile* _tmp16_;
					gchar** _tmp17_;
					gint _tmp17__length1;
					const gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
#line 94 "../src/Backend/WacomToolMap.vala"
					_tmp16_ = self->priv->tools;
#line 94 "../src/Backend/WacomToolMap.vala"
					_tmp17_ = serials;
#line 94 "../src/Backend/WacomToolMap.vala"
					_tmp17__length1 = serials_length1;
#line 94 "../src/Backend/WacomToolMap.vala"
					_tmp18_ = _tmp17_[i];
#line 94 "../src/Backend/WacomToolMap.vala"
					_tmp19_ = g_key_file_get_string (_tmp16_, _tmp18_, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_TOOL_ID, &_inner_error0_);
#line 94 "../src/Backend/WacomToolMap.vala"
					_tmp15_ = _tmp19_;
#line 94 "../src/Backend/WacomToolMap.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 518 "WacomToolMap.c"
						goto __catch1_g_error;
					}
#line 94 "../src/Backend/WacomToolMap.vala"
					_tmp20_ = _tmp15_;
#line 94 "../src/Backend/WacomToolMap.vala"
					_tmp15_ = NULL;
#line 94 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 94 "../src/Backend/WacomToolMap.vala"
					str = _tmp20_;
#line 93 "../src/Backend/WacomToolMap.vala"
					_g_free0 (_tmp15_);
#line 531 "WacomToolMap.c"
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					gchar** _tmp21_;
					gint _tmp21__length1;
					const gchar* _tmp22_;
					GError* _tmp23_;
					const gchar* _tmp24_;
#line 93 "../src/Backend/WacomToolMap.vala"
					e = _inner_error0_;
#line 93 "../src/Backend/WacomToolMap.vala"
					_inner_error0_ = NULL;
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp21_ = serials;
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp21__length1 = serials_length1;
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp22_ = _tmp21_[i];
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp23_ = e;
#line 96 "../src/Backend/WacomToolMap.vala"
					_tmp24_ = _tmp23_->message;
#line 96 "../src/Backend/WacomToolMap.vala"
					g_warning ("WacomToolMap.vala:96: Could not get cached ID for tool with serial %s:" \
" %s", _tmp22_, _tmp24_);
#line 97 "../src/Backend/WacomToolMap.vala"
					_g_error_free0 (e);
#line 97 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 97 "../src/Backend/WacomToolMap.vala"
					continue;
#line 564 "WacomToolMap.c"
				}
				__finally1:
#line 93 "../src/Backend/WacomToolMap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 93 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 93 "../src/Backend/WacomToolMap.vala"
					serials = (_vala_array_free (serials, serials_length1, (GDestroyNotify) g_free), NULL);
#line 93 "../src/Backend/WacomToolMap.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 93 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 93 "../src/Backend/WacomToolMap.vala"
					return;
#line 579 "WacomToolMap.c"
				}
				{
					gboolean _tmp25_ = FALSE;
					const gchar* _tmp26_;
					guint64 _tmp27_ = 0ULL;
					gboolean _tmp28_;
#line 101 "../src/Backend/WacomToolMap.vala"
					_tmp26_ = str;
#line 101 "../src/Backend/WacomToolMap.vala"
					_tmp28_ = g_ascii_string_to_unsigned (_tmp26_, (guint) 16, 0ULL, G_MAXUINT64, &_tmp27_, &_inner_error0_);
#line 101 "../src/Backend/WacomToolMap.vala"
					id = _tmp27_;
#line 101 "../src/Backend/WacomToolMap.vala"
					_tmp25_ = _tmp28_;
#line 101 "../src/Backend/WacomToolMap.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 596 "WacomToolMap.c"
						goto __catch2_g_error;
					}
#line 101 "../src/Backend/WacomToolMap.vala"
					if (!_tmp25_) {
#line 601 "WacomToolMap.c"
						const gchar* _tmp29_;
#line 102 "../src/Backend/WacomToolMap.vala"
						_tmp29_ = str;
#line 102 "../src/Backend/WacomToolMap.vala"
						g_warning ("WacomToolMap.vala:102: Invalid tool ID %s", _tmp29_);
#line 103 "../src/Backend/WacomToolMap.vala"
						_g_free0 (str);
#line 103 "../src/Backend/WacomToolMap.vala"
						continue;
#line 611 "WacomToolMap.c"
					}
				}
				goto __finally2;
				__catch2_g_error:
				{
					const gchar* _tmp30_;
#line 100 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 106 "../src/Backend/WacomToolMap.vala"
					_tmp30_ = str;
#line 106 "../src/Backend/WacomToolMap.vala"
					g_warning ("WacomToolMap.vala:106: Invalid tool ID %s", _tmp30_);
#line 107 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 107 "../src/Backend/WacomToolMap.vala"
					continue;
#line 628 "WacomToolMap.c"
				}
				__finally2:
#line 100 "../src/Backend/WacomToolMap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 100 "../src/Backend/WacomToolMap.vala"
					serials = (_vala_array_free (serials, serials_length1, (GDestroyNotify) g_free), NULL);
#line 100 "../src/Backend/WacomToolMap.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 100 "../src/Backend/WacomToolMap.vala"
					return;
#line 643 "WacomToolMap.c"
				}
				{
					WacomBackendWacomTool* _tmp31_ = NULL;
					WacomBackendWacomTool* _tmp32_;
					GeeHashMap* _tmp33_;
					gchar** _tmp34_;
					gint _tmp34__length1;
					const gchar* _tmp35_;
#line 111 "../src/Backend/WacomToolMap.vala"
					_tmp32_ = wacom_backend_wacom_tool_new (serial, id, NULL, &_inner_error0_);
#line 111 "../src/Backend/WacomToolMap.vala"
					_tmp31_ = _tmp32_;
#line 111 "../src/Backend/WacomToolMap.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 658 "WacomToolMap.c"
						goto __catch3_g_error;
					}
#line 111 "../src/Backend/WacomToolMap.vala"
					_tmp33_ = self->priv->tool_map;
#line 111 "../src/Backend/WacomToolMap.vala"
					_tmp34_ = serials;
#line 111 "../src/Backend/WacomToolMap.vala"
					_tmp34__length1 = serials_length1;
#line 111 "../src/Backend/WacomToolMap.vala"
					_tmp35_ = _tmp34_[i];
#line 111 "../src/Backend/WacomToolMap.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp33_, _tmp35_, _tmp31_);
#line 110 "../src/Backend/WacomToolMap.vala"
					_g_object_unref0 (_tmp31_);
#line 673 "WacomToolMap.c"
				}
				goto __finally3;
				__catch3_g_error:
				{
#line 110 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 113 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 113 "../src/Backend/WacomToolMap.vala"
					continue;
#line 684 "WacomToolMap.c"
				}
				__finally3:
#line 110 "../src/Backend/WacomToolMap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 110 "../src/Backend/WacomToolMap.vala"
					_g_free0 (str);
#line 110 "../src/Backend/WacomToolMap.vala"
					serials = (_vala_array_free (serials, serials_length1, (GDestroyNotify) g_free), NULL);
#line 110 "../src/Backend/WacomToolMap.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 110 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 110 "../src/Backend/WacomToolMap.vala"
					return;
#line 699 "WacomToolMap.c"
				}
#line 80 "../src/Backend/WacomToolMap.vala"
				_g_free0 (str);
#line 703 "WacomToolMap.c"
			}
		}
	}
#line 78 "../src/Backend/WacomToolMap.vala"
	serials = (_vala_array_free (serials, serials_length1, (GDestroyNotify) g_free), NULL);
#line 709 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_cache_devices (WacomBackendWacomToolMap* self)
{
	gchar** ids = NULL;
	GKeyFile* _tmp0_;
	gsize _tmp1_ = 0;
	gchar** _tmp2_;
	gint ids_length1;
	gint _ids_size_;
	GError* _inner_error0_ = NULL;
#line 118 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = self->priv->tablets;
#line 119 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = g_key_file_get_groups (_tmp0_, &_tmp1_);
#line 119 "../src/Backend/WacomToolMap.vala"
	ids = _tmp2_;
#line 119 "../src/Backend/WacomToolMap.vala"
	ids_length1 = _tmp1_;
#line 119 "../src/Backend/WacomToolMap.vala"
	_ids_size_ = ids_length1;
#line 734 "WacomToolMap.c"
	{
		gint i = 0;
#line 120 "../src/Backend/WacomToolMap.vala"
		i = 0;
#line 739 "WacomToolMap.c"
		{
			gboolean _tmp3_ = FALSE;
#line 120 "../src/Backend/WacomToolMap.vala"
			_tmp3_ = TRUE;
#line 120 "../src/Backend/WacomToolMap.vala"
			while (TRUE) {
#line 746 "WacomToolMap.c"
				gchar** _tmp5_;
				gint _tmp5__length1;
				GeeArrayList* tools = NULL;
				GeeArrayList* _tmp6_;
				gchar** styli = NULL;
				gint styli_length1;
				gint _styli_size_;
				GeeArrayList* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
#line 120 "../src/Backend/WacomToolMap.vala"
				if (!_tmp3_) {
#line 759 "WacomToolMap.c"
					gint _tmp4_;
#line 120 "../src/Backend/WacomToolMap.vala"
					_tmp4_ = i;
#line 120 "../src/Backend/WacomToolMap.vala"
					i = _tmp4_ + 1;
#line 765 "WacomToolMap.c"
				}
#line 120 "../src/Backend/WacomToolMap.vala"
				_tmp3_ = FALSE;
#line 120 "../src/Backend/WacomToolMap.vala"
				_tmp5_ = ids;
#line 120 "../src/Backend/WacomToolMap.vala"
				_tmp5__length1 = ids_length1;
#line 120 "../src/Backend/WacomToolMap.vala"
				if (!(i < _tmp5__length1)) {
#line 120 "../src/Backend/WacomToolMap.vala"
					break;
#line 777 "WacomToolMap.c"
				}
#line 121 "../src/Backend/WacomToolMap.vala"
				_tmp6_ = gee_array_list_new (WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 121 "../src/Backend/WacomToolMap.vala"
				tools = _tmp6_;
#line 123 "../src/Backend/WacomToolMap.vala"
				styli = NULL;
#line 123 "../src/Backend/WacomToolMap.vala"
				styli_length1 = 0;
#line 123 "../src/Backend/WacomToolMap.vala"
				_styli_size_ = styli_length1;
#line 789 "WacomToolMap.c"
				{
					gchar** _tmp7_ = NULL;
					GKeyFile* _tmp8_;
					gchar** _tmp9_;
					gint _tmp9__length1;
					const gchar* _tmp10_;
					gsize _tmp11_ = 0;
					gchar** _tmp12_;
					gint _tmp7__length1;
					gint __tmp7__size_;
					gchar** _tmp13_;
					gint _tmp13__length1;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp8_ = self->priv->tablets;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp9_ = ids;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp9__length1 = ids_length1;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp10_ = _tmp9_[i];
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp12_ = g_key_file_get_string_list (_tmp8_, _tmp10_, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_DEVICE_STYLI, &_tmp11_, &_inner_error0_);
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp7_ = _tmp12_;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp7__length1 = _tmp11_;
#line 125 "../src/Backend/WacomToolMap.vala"
					__tmp7__size_ = _tmp7__length1;
#line 125 "../src/Backend/WacomToolMap.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../src/Backend/WacomToolMap.vala"
						if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 822 "WacomToolMap.c"
							goto __catch0_g_key_file_error;
						}
#line 125 "../src/Backend/WacomToolMap.vala"
						styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 125 "../src/Backend/WacomToolMap.vala"
						_g_object_unref0 (tools);
#line 125 "../src/Backend/WacomToolMap.vala"
						ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 125 "../src/Backend/WacomToolMap.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../src/Backend/WacomToolMap.vala"
						g_clear_error (&_inner_error0_);
#line 125 "../src/Backend/WacomToolMap.vala"
						return;
#line 837 "WacomToolMap.c"
					}
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp13_ = _tmp7_;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp13__length1 = _tmp7__length1;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp7_ = NULL;
#line 125 "../src/Backend/WacomToolMap.vala"
					_tmp7__length1 = 0;
#line 125 "../src/Backend/WacomToolMap.vala"
					styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 125 "../src/Backend/WacomToolMap.vala"
					styli = _tmp13_;
#line 125 "../src/Backend/WacomToolMap.vala"
					styli_length1 = _tmp13__length1;
#line 125 "../src/Backend/WacomToolMap.vala"
					_styli_size_ = styli_length1;
#line 124 "../src/Backend/WacomToolMap.vala"
					_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 857 "WacomToolMap.c"
				}
				goto __finally0;
				__catch0_g_key_file_error:
				{
					GError* e = NULL;
					gchar** _tmp14_;
					gint _tmp14__length1;
					const gchar* _tmp15_;
					GError* _tmp16_;
					const gchar* _tmp17_;
#line 124 "../src/Backend/WacomToolMap.vala"
					e = _inner_error0_;
#line 124 "../src/Backend/WacomToolMap.vala"
					_inner_error0_ = NULL;
#line 127 "../src/Backend/WacomToolMap.vala"
					_tmp14_ = ids;
#line 127 "../src/Backend/WacomToolMap.vala"
					_tmp14__length1 = ids_length1;
#line 127 "../src/Backend/WacomToolMap.vala"
					_tmp15_ = _tmp14_[i];
#line 127 "../src/Backend/WacomToolMap.vala"
					_tmp16_ = e;
#line 127 "../src/Backend/WacomToolMap.vala"
					_tmp17_ = _tmp16_->message;
#line 127 "../src/Backend/WacomToolMap.vala"
					g_warning ("WacomToolMap.vala:127: Could not get cached styli for tablet with id %" \
"s: %s", _tmp15_, _tmp17_);
#line 128 "../src/Backend/WacomToolMap.vala"
					_g_error_free0 (e);
#line 128 "../src/Backend/WacomToolMap.vala"
					styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 128 "../src/Backend/WacomToolMap.vala"
					_g_object_unref0 (tools);
#line 128 "../src/Backend/WacomToolMap.vala"
					continue;
#line 892 "WacomToolMap.c"
				}
				__finally0:
#line 124 "../src/Backend/WacomToolMap.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 124 "../src/Backend/WacomToolMap.vala"
					styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 124 "../src/Backend/WacomToolMap.vala"
					_g_object_unref0 (tools);
#line 124 "../src/Backend/WacomToolMap.vala"
					ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 124 "../src/Backend/WacomToolMap.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 124 "../src/Backend/WacomToolMap.vala"
					g_clear_error (&_inner_error0_);
#line 124 "../src/Backend/WacomToolMap.vala"
					return;
#line 909 "WacomToolMap.c"
				}
				{
					gint j = 0;
#line 131 "../src/Backend/WacomToolMap.vala"
					j = 0;
#line 915 "WacomToolMap.c"
					{
						gboolean _tmp18_ = FALSE;
#line 131 "../src/Backend/WacomToolMap.vala"
						_tmp18_ = TRUE;
#line 131 "../src/Backend/WacomToolMap.vala"
						while (TRUE) {
#line 922 "WacomToolMap.c"
							gchar** _tmp20_;
							gint _tmp20__length1;
							gchar** _tmp21_;
							gint _tmp21__length1;
							const gchar* _tmp22_;
							WacomBackendWacomTool* tool = NULL;
							GeeHashMap* _tmp26_;
							gchar** _tmp27_;
							gint _tmp27__length1;
							const gchar* _tmp28_;
							gpointer _tmp29_;
							WacomBackendWacomTool* _tmp30_;
#line 131 "../src/Backend/WacomToolMap.vala"
							if (!_tmp18_) {
#line 937 "WacomToolMap.c"
								gint _tmp19_;
#line 131 "../src/Backend/WacomToolMap.vala"
								_tmp19_ = j;
#line 131 "../src/Backend/WacomToolMap.vala"
								j = _tmp19_ + 1;
#line 943 "WacomToolMap.c"
							}
#line 131 "../src/Backend/WacomToolMap.vala"
							_tmp18_ = FALSE;
#line 131 "../src/Backend/WacomToolMap.vala"
							_tmp20_ = styli;
#line 131 "../src/Backend/WacomToolMap.vala"
							_tmp20__length1 = styli_length1;
#line 131 "../src/Backend/WacomToolMap.vala"
							if (!(j < _tmp20__length1)) {
#line 131 "../src/Backend/WacomToolMap.vala"
								break;
#line 955 "WacomToolMap.c"
							}
#line 132 "../src/Backend/WacomToolMap.vala"
							_tmp21_ = styli;
#line 132 "../src/Backend/WacomToolMap.vala"
							_tmp21__length1 = styli_length1;
#line 132 "../src/Backend/WacomToolMap.vala"
							_tmp22_ = _tmp21_[j];
#line 132 "../src/Backend/WacomToolMap.vala"
							if (g_strcmp0 (_tmp22_, WACOM_BACKEND_WACOM_TOOL_MAP_GENERIC_STYLUS) == 0) {
#line 965 "WacomToolMap.c"
								GeeHashMap* _tmp23_;
								gchar** _tmp24_;
								gint _tmp24__length1;
								const gchar* _tmp25_;
#line 133 "../src/Backend/WacomToolMap.vala"
								_tmp23_ = self->priv->no_serial_tool_map;
#line 133 "../src/Backend/WacomToolMap.vala"
								_tmp24_ = ids;
#line 133 "../src/Backend/WacomToolMap.vala"
								_tmp24__length1 = ids_length1;
#line 133 "../src/Backend/WacomToolMap.vala"
								_tmp25_ = _tmp24_[i];
#line 133 "../src/Backend/WacomToolMap.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, _tmp25_, NULL);
#line 980 "WacomToolMap.c"
							}
#line 136 "../src/Backend/WacomToolMap.vala"
							_tmp26_ = self->priv->tool_map;
#line 136 "../src/Backend/WacomToolMap.vala"
							_tmp27_ = styli;
#line 136 "../src/Backend/WacomToolMap.vala"
							_tmp27__length1 = styli_length1;
#line 136 "../src/Backend/WacomToolMap.vala"
							_tmp28_ = _tmp27_[j];
#line 136 "../src/Backend/WacomToolMap.vala"
							_tmp29_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp26_, _tmp28_);
#line 136 "../src/Backend/WacomToolMap.vala"
							tool = (WacomBackendWacomTool*) _tmp29_;
#line 137 "../src/Backend/WacomToolMap.vala"
							_tmp30_ = tool;
#line 137 "../src/Backend/WacomToolMap.vala"
							if (_tmp30_ != NULL) {
#line 998 "WacomToolMap.c"
								GeeArrayList* _tmp31_;
								WacomBackendWacomTool* _tmp32_;
#line 138 "../src/Backend/WacomToolMap.vala"
								_tmp31_ = tools;
#line 138 "../src/Backend/WacomToolMap.vala"
								_tmp32_ = tool;
#line 138 "../src/Backend/WacomToolMap.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp31_, _tmp32_);
#line 1007 "WacomToolMap.c"
							}
#line 131 "../src/Backend/WacomToolMap.vala"
							_g_object_unref0 (tool);
#line 1011 "WacomToolMap.c"
						}
					}
				}
#line 142 "../src/Backend/WacomToolMap.vala"
				_tmp33_ = tools;
#line 142 "../src/Backend/WacomToolMap.vala"
				_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
#line 142 "../src/Backend/WacomToolMap.vala"
				_tmp35_ = _tmp34_;
#line 142 "../src/Backend/WacomToolMap.vala"
				if (_tmp35_ > 0) {
#line 1023 "WacomToolMap.c"
					GeeHashMap* _tmp36_;
					gchar** _tmp37_;
					gint _tmp37__length1;
					const gchar* _tmp38_;
					GeeArrayList* _tmp39_;
#line 143 "../src/Backend/WacomToolMap.vala"
					_tmp36_ = self->priv->tablet_map;
#line 143 "../src/Backend/WacomToolMap.vala"
					_tmp37_ = ids;
#line 143 "../src/Backend/WacomToolMap.vala"
					_tmp37__length1 = ids_length1;
#line 143 "../src/Backend/WacomToolMap.vala"
					_tmp38_ = _tmp37_[i];
#line 143 "../src/Backend/WacomToolMap.vala"
					_tmp39_ = tools;
#line 143 "../src/Backend/WacomToolMap.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp36_, _tmp38_, _tmp39_);
#line 1041 "WacomToolMap.c"
				}
#line 120 "../src/Backend/WacomToolMap.vala"
				styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 120 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (tools);
#line 1047 "WacomToolMap.c"
			}
		}
	}
#line 118 "../src/Backend/WacomToolMap.vala"
	ids = (_vala_array_free (ids, ids_length1, (GDestroyNotify) g_free), NULL);
#line 1053 "WacomToolMap.c"
}

static gchar*
wacom_backend_wacom_tool_map_get_device_key (WacomBackendWacomDevice* device)
{
	WacomBackendDevice* _tmp0_;
	WacomBackendDevice* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	WacomBackendDevice* _tmp4_;
	WacomBackendDevice* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 148 "../src/Backend/WacomToolMap.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 149 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = wacom_backend_wacom_device_get_device (device);
#line 149 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = _tmp0_;
#line 149 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = wacom_backend_device_get_vendor_id (_tmp1_);
#line 149 "../src/Backend/WacomToolMap.vala"
	_tmp3_ = _tmp2_;
#line 149 "../src/Backend/WacomToolMap.vala"
	_tmp4_ = wacom_backend_wacom_device_get_device (device);
#line 149 "../src/Backend/WacomToolMap.vala"
	_tmp5_ = _tmp4_;
#line 149 "../src/Backend/WacomToolMap.vala"
	_tmp6_ = wacom_backend_device_get_product_id (_tmp5_);
#line 149 "../src/Backend/WacomToolMap.vala"
	_tmp7_ = _tmp6_;
#line 149 "../src/Backend/WacomToolMap.vala"
	_tmp8_ = g_strdup_printf ("%s:%s", _tmp3_, _tmp7_);
#line 149 "../src/Backend/WacomToolMap.vala"
	result = _tmp8_;
#line 149 "../src/Backend/WacomToolMap.vala"
	return result;
#line 1093 "WacomToolMap.c"
}

static gchar*
wacom_backend_wacom_tool_map_get_tool_key (guint64 serial)
{
	gchar* _tmp0_;
	gchar* result;
#line 153 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = g_strdup_printf ("%llx", serial);
#line 153 "../src/Backend/WacomToolMap.vala"
	result = _tmp0_;
#line 153 "../src/Backend/WacomToolMap.vala"
	return result;
#line 1107 "WacomToolMap.c"
}

void
wacom_backend_wacom_tool_map_add_relation (WacomBackendWacomToolMap* self,
                                           WacomBackendWacomDevice* device,
                                           WacomBackendWacomTool* tool)
{
	gchar* tool_key = NULL;
	gboolean tools_changed = FALSE;
	gboolean tablets_changed = FALSE;
	gchar* device_key = NULL;
	gchar* _tmp0_;
	guint64 serial = 0ULL;
	guint64 _tmp1_;
	guint64 _tmp2_;
	GeeArrayList* styli = NULL;
	GeeHashMap* _tmp21_;
	const gchar* _tmp22_;
	gpointer _tmp23_;
	GeeArrayList* _tmp24_;
	GeeArrayList* _tmp29_;
	GError* _inner_error0_ = NULL;
#line 156 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (device != NULL);
#line 156 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (tool != NULL);
#line 158 "../src/Backend/WacomToolMap.vala"
	tools_changed = FALSE;
#line 158 "../src/Backend/WacomToolMap.vala"
	tablets_changed = FALSE;
#line 160 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = wacom_backend_wacom_tool_map_get_device_key (device);
#line 160 "../src/Backend/WacomToolMap.vala"
	device_key = _tmp0_;
#line 161 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = wacom_backend_wacom_tool_get_serial (tool);
#line 161 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = _tmp1_;
#line 161 "../src/Backend/WacomToolMap.vala"
	serial = _tmp2_;
#line 163 "../src/Backend/WacomToolMap.vala"
	if (serial == ((guint64) 0)) {
#line 1152 "WacomToolMap.c"
		gchar* _tmp3_;
		GeeHashMap* _tmp4_;
		const gchar* _tmp5_;
#line 164 "../src/Backend/WacomToolMap.vala"
		_tmp3_ = g_strdup (WACOM_BACKEND_WACOM_TOOL_MAP_GENERIC_STYLUS);
#line 164 "../src/Backend/WacomToolMap.vala"
		_g_free0 (tool_key);
#line 164 "../src/Backend/WacomToolMap.vala"
		tool_key = _tmp3_;
#line 165 "../src/Backend/WacomToolMap.vala"
		_tmp4_ = self->priv->no_serial_tool_map;
#line 165 "../src/Backend/WacomToolMap.vala"
		_tmp5_ = device_key;
#line 165 "../src/Backend/WacomToolMap.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, _tmp5_, tool);
#line 1168 "WacomToolMap.c"
	} else {
		gchar* _tmp6_;
		GeeHashMap* _tmp7_;
		const gchar* _tmp8_;
#line 167 "../src/Backend/WacomToolMap.vala"
		_tmp6_ = wacom_backend_wacom_tool_map_get_tool_key (serial);
#line 167 "../src/Backend/WacomToolMap.vala"
		_g_free0 (tool_key);
#line 167 "../src/Backend/WacomToolMap.vala"
		tool_key = _tmp6_;
#line 168 "../src/Backend/WacomToolMap.vala"
		_tmp7_ = self->priv->tool_map;
#line 168 "../src/Backend/WacomToolMap.vala"
		_tmp8_ = tool_key;
#line 168 "../src/Backend/WacomToolMap.vala"
		if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp7_, _tmp8_)) {
#line 1185 "WacomToolMap.c"
			const gchar* _tmp9_;
			guint64 _tmp10_;
			guint64 _tmp11_;
			GeeHashMap* _tmp12_;
			const gchar* _tmp13_;
#line 169 "../src/Backend/WacomToolMap.vala"
			_tmp9_ = tool_key;
#line 169 "../src/Backend/WacomToolMap.vala"
			_tmp10_ = wacom_backend_wacom_tool_get_id (tool);
#line 169 "../src/Backend/WacomToolMap.vala"
			_tmp11_ = _tmp10_;
#line 169 "../src/Backend/WacomToolMap.vala"
			wacom_backend_wacom_tool_map_keyfile_add_stylus (self, _tmp9_, _tmp11_);
#line 170 "../src/Backend/WacomToolMap.vala"
			tools_changed = TRUE;
#line 171 "../src/Backend/WacomToolMap.vala"
			_tmp12_ = self->priv->tool_map;
#line 171 "../src/Backend/WacomToolMap.vala"
			_tmp13_ = tool_key;
#line 171 "../src/Backend/WacomToolMap.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, tool);
#line 1207 "WacomToolMap.c"
		} else {
			GeeHashMap* _tmp14_;
			const gchar* _tmp15_;
			gpointer _tmp16_;
			WacomBackendWacomTool* _tmp17_;
			gboolean _tmp18_;
#line 172 "../src/Backend/WacomToolMap.vala"
			_tmp14_ = self->priv->tool_map;
#line 172 "../src/Backend/WacomToolMap.vala"
			_tmp15_ = tool_key;
#line 172 "../src/Backend/WacomToolMap.vala"
			_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, _tmp15_);
#line 172 "../src/Backend/WacomToolMap.vala"
			_tmp17_ = (WacomBackendWacomTool*) _tmp16_;
#line 172 "../src/Backend/WacomToolMap.vala"
			_tmp18_ = _tmp17_ == NULL;
#line 172 "../src/Backend/WacomToolMap.vala"
			_g_object_unref0 (_tmp17_);
#line 172 "../src/Backend/WacomToolMap.vala"
			if (_tmp18_) {
#line 1228 "WacomToolMap.c"
				GeeHashMap* _tmp19_;
				const gchar* _tmp20_;
#line 173 "../src/Backend/WacomToolMap.vala"
				_tmp19_ = self->priv->tool_map;
#line 173 "../src/Backend/WacomToolMap.vala"
				_tmp20_ = tool_key;
#line 173 "../src/Backend/WacomToolMap.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, _tmp20_, tool);
#line 1237 "WacomToolMap.c"
			}
		}
	}
#line 177 "../src/Backend/WacomToolMap.vala"
	_tmp21_ = self->priv->tablet_map;
#line 177 "../src/Backend/WacomToolMap.vala"
	_tmp22_ = device_key;
#line 177 "../src/Backend/WacomToolMap.vala"
	_tmp23_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp21_, _tmp22_);
#line 177 "../src/Backend/WacomToolMap.vala"
	styli = (GeeArrayList*) _tmp23_;
#line 178 "../src/Backend/WacomToolMap.vala"
	_tmp24_ = styli;
#line 178 "../src/Backend/WacomToolMap.vala"
	if (_tmp24_ == NULL) {
#line 1253 "WacomToolMap.c"
		GeeArrayList* _tmp25_;
		GeeHashMap* _tmp26_;
		const gchar* _tmp27_;
		GeeArrayList* _tmp28_;
#line 179 "../src/Backend/WacomToolMap.vala"
		_tmp25_ = gee_array_list_new (WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 179 "../src/Backend/WacomToolMap.vala"
		_g_object_unref0 (styli);
#line 179 "../src/Backend/WacomToolMap.vala"
		styli = _tmp25_;
#line 180 "../src/Backend/WacomToolMap.vala"
		_tmp26_ = self->priv->tablet_map;
#line 180 "../src/Backend/WacomToolMap.vala"
		_tmp27_ = device_key;
#line 180 "../src/Backend/WacomToolMap.vala"
		_tmp28_ = styli;
#line 180 "../src/Backend/WacomToolMap.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp26_, _tmp27_, _tmp28_);
#line 1272 "WacomToolMap.c"
	}
#line 183 "../src/Backend/WacomToolMap.vala"
	_tmp29_ = styli;
#line 183 "../src/Backend/WacomToolMap.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp29_, tool)) {
#line 1278 "WacomToolMap.c"
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		GeeArrayList* _tmp32_;
#line 184 "../src/Backend/WacomToolMap.vala"
		tablets_changed = TRUE;
#line 185 "../src/Backend/WacomToolMap.vala"
		_tmp30_ = device_key;
#line 185 "../src/Backend/WacomToolMap.vala"
		_tmp31_ = tool_key;
#line 185 "../src/Backend/WacomToolMap.vala"
		wacom_backend_wacom_tool_map_keyfile_add_device_stylus (self, _tmp30_, _tmp31_);
#line 186 "../src/Backend/WacomToolMap.vala"
		_tmp32_ = styli;
#line 186 "../src/Backend/WacomToolMap.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, tool);
#line 1294 "WacomToolMap.c"
	}
#line 189 "../src/Backend/WacomToolMap.vala"
	if (tools_changed) {
#line 1298 "WacomToolMap.c"
		{
			GKeyFile* _tmp33_;
			const gchar* _tmp34_;
#line 191 "../src/Backend/WacomToolMap.vala"
			_tmp33_ = self->priv->tools;
#line 191 "../src/Backend/WacomToolMap.vala"
			_tmp34_ = self->priv->tool_path;
#line 191 "../src/Backend/WacomToolMap.vala"
			g_key_file_save_to_file (_tmp33_, _tmp34_, &_inner_error0_);
#line 191 "../src/Backend/WacomToolMap.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/Backend/WacomToolMap.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1312 "WacomToolMap.c"
					goto __catch0_g_file_error;
				}
#line 191 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (styli);
#line 191 "../src/Backend/WacomToolMap.vala"
				_g_free0 (device_key);
#line 191 "../src/Backend/WacomToolMap.vala"
				_g_free0 (tool_key);
#line 191 "../src/Backend/WacomToolMap.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../src/Backend/WacomToolMap.vala"
				g_clear_error (&_inner_error0_);
#line 191 "../src/Backend/WacomToolMap.vala"
				return;
#line 1327 "WacomToolMap.c"
			}
		}
		goto __finally0;
		__catch0_g_file_error:
		{
			GError* e = NULL;
			const gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 190 "../src/Backend/WacomToolMap.vala"
			e = _inner_error0_;
#line 190 "../src/Backend/WacomToolMap.vala"
			_inner_error0_ = NULL;
#line 193 "../src/Backend/WacomToolMap.vala"
			_tmp35_ = self->priv->tool_path;
#line 193 "../src/Backend/WacomToolMap.vala"
			_tmp36_ = e;
#line 193 "../src/Backend/WacomToolMap.vala"
			_tmp37_ = _tmp36_->message;
#line 193 "../src/Backend/WacomToolMap.vala"
			g_warning ("WacomToolMap.vala:193: Error saving tools keyfile '%s': %s", _tmp35_, _tmp37_);
#line 190 "../src/Backend/WacomToolMap.vala"
			_g_error_free0 (e);
#line 1351 "WacomToolMap.c"
		}
		__finally0:
#line 190 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/Backend/WacomToolMap.vala"
			_g_object_unref0 (styli);
#line 190 "../src/Backend/WacomToolMap.vala"
			_g_free0 (device_key);
#line 190 "../src/Backend/WacomToolMap.vala"
			_g_free0 (tool_key);
#line 190 "../src/Backend/WacomToolMap.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "../src/Backend/WacomToolMap.vala"
			g_clear_error (&_inner_error0_);
#line 190 "../src/Backend/WacomToolMap.vala"
			return;
#line 1368 "WacomToolMap.c"
		}
	}
#line 197 "../src/Backend/WacomToolMap.vala"
	if (tablets_changed) {
#line 1373 "WacomToolMap.c"
		{
			GKeyFile* _tmp38_;
			const gchar* _tmp39_;
#line 199 "../src/Backend/WacomToolMap.vala"
			_tmp38_ = self->priv->tablets;
#line 199 "../src/Backend/WacomToolMap.vala"
			_tmp39_ = self->priv->tablet_path;
#line 199 "../src/Backend/WacomToolMap.vala"
			g_key_file_save_to_file (_tmp38_, _tmp39_, &_inner_error0_);
#line 199 "../src/Backend/WacomToolMap.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "../src/Backend/WacomToolMap.vala"
				if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1387 "WacomToolMap.c"
					goto __catch1_g_file_error;
				}
#line 199 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (styli);
#line 199 "../src/Backend/WacomToolMap.vala"
				_g_free0 (device_key);
#line 199 "../src/Backend/WacomToolMap.vala"
				_g_free0 (tool_key);
#line 199 "../src/Backend/WacomToolMap.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 199 "../src/Backend/WacomToolMap.vala"
				g_clear_error (&_inner_error0_);
#line 199 "../src/Backend/WacomToolMap.vala"
				return;
#line 1402 "WacomToolMap.c"
			}
		}
		goto __finally1;
		__catch1_g_file_error:
		{
			GError* e = NULL;
			const gchar* _tmp40_;
			GError* _tmp41_;
			const gchar* _tmp42_;
#line 198 "../src/Backend/WacomToolMap.vala"
			e = _inner_error0_;
#line 198 "../src/Backend/WacomToolMap.vala"
			_inner_error0_ = NULL;
#line 201 "../src/Backend/WacomToolMap.vala"
			_tmp40_ = self->priv->tablet_path;
#line 201 "../src/Backend/WacomToolMap.vala"
			_tmp41_ = e;
#line 201 "../src/Backend/WacomToolMap.vala"
			_tmp42_ = _tmp41_->message;
#line 201 "../src/Backend/WacomToolMap.vala"
			g_warning ("WacomToolMap.vala:201: Error saving tablets keyfile '%s': %s", _tmp40_, _tmp42_);
#line 198 "../src/Backend/WacomToolMap.vala"
			_g_error_free0 (e);
#line 1426 "WacomToolMap.c"
		}
		__finally1:
#line 198 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 198 "../src/Backend/WacomToolMap.vala"
			_g_object_unref0 (styli);
#line 198 "../src/Backend/WacomToolMap.vala"
			_g_free0 (device_key);
#line 198 "../src/Backend/WacomToolMap.vala"
			_g_free0 (tool_key);
#line 198 "../src/Backend/WacomToolMap.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 198 "../src/Backend/WacomToolMap.vala"
			g_clear_error (&_inner_error0_);
#line 198 "../src/Backend/WacomToolMap.vala"
			return;
#line 1443 "WacomToolMap.c"
		}
	}
#line 156 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (styli);
#line 156 "../src/Backend/WacomToolMap.vala"
	_g_free0 (device_key);
#line 156 "../src/Backend/WacomToolMap.vala"
	_g_free0 (tool_key);
#line 1452 "WacomToolMap.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 218 "../src/Backend/WacomToolMap.vala"
	if ((*length) == (*size)) {
#line 218 "../src/Backend/WacomToolMap.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 218 "../src/Backend/WacomToolMap.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1467 "WacomToolMap.c"
	}
#line 218 "../src/Backend/WacomToolMap.vala"
	(*array)[(*length)++] = value;
#line 218 "../src/Backend/WacomToolMap.vala"
	(*array)[*length] = NULL;
#line 1473 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_keyfile_add_device_stylus (WacomBackendWacomToolMap* self,
                                                        const gchar* device_key,
                                                        const gchar* tool_key)
{
	gchar** styli = NULL;
	gint styli_length1;
	gint _styli_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp7_;
	GKeyFile* _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	GError* _inner_error0_ = NULL;
#line 206 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 206 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (device_key != NULL);
#line 206 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (tool_key != NULL);
#line 207 "../src/Backend/WacomToolMap.vala"
	styli = NULL;
#line 207 "../src/Backend/WacomToolMap.vala"
	styli_length1 = 0;
#line 207 "../src/Backend/WacomToolMap.vala"
	_styli_size_ = styli_length1;
#line 1503 "WacomToolMap.c"
	{
		gchar** _tmp0_ = NULL;
		GKeyFile* _tmp1_;
		gsize _tmp2_ = 0;
		gchar** _tmp3_;
		gint _tmp0__length1;
		gint __tmp0__size_;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 209 "../src/Backend/WacomToolMap.vala"
		_tmp1_ = self->priv->tablets;
#line 209 "../src/Backend/WacomToolMap.vala"
		_tmp3_ = g_key_file_get_string_list (_tmp1_, device_key, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_DEVICE_STYLI, &_tmp2_, &_inner_error0_);
#line 209 "../src/Backend/WacomToolMap.vala"
		_tmp0_ = _tmp3_;
#line 209 "../src/Backend/WacomToolMap.vala"
		_tmp0__length1 = _tmp2_;
#line 209 "../src/Backend/WacomToolMap.vala"
		__tmp0__size_ = _tmp0__length1;
#line 209 "../src/Backend/WacomToolMap.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 209 "../src/Backend/WacomToolMap.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 1527 "WacomToolMap.c"
				goto __catch0_g_key_file_error;
			}
#line 209 "../src/Backend/WacomToolMap.vala"
			styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 209 "../src/Backend/WacomToolMap.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 209 "../src/Backend/WacomToolMap.vala"
			g_clear_error (&_inner_error0_);
#line 209 "../src/Backend/WacomToolMap.vala"
			return;
#line 1538 "WacomToolMap.c"
		}
#line 209 "../src/Backend/WacomToolMap.vala"
		_tmp4_ = _tmp0_;
#line 209 "../src/Backend/WacomToolMap.vala"
		_tmp4__length1 = _tmp0__length1;
#line 209 "../src/Backend/WacomToolMap.vala"
		_tmp0_ = NULL;
#line 209 "../src/Backend/WacomToolMap.vala"
		_tmp0__length1 = 0;
#line 209 "../src/Backend/WacomToolMap.vala"
		styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 209 "../src/Backend/WacomToolMap.vala"
		styli = _tmp4_;
#line 209 "../src/Backend/WacomToolMap.vala"
		styli_length1 = _tmp4__length1;
#line 209 "../src/Backend/WacomToolMap.vala"
		_styli_size_ = styli_length1;
#line 208 "../src/Backend/WacomToolMap.vala"
		_tmp0_ = (_vala_array_free (_tmp0_, _tmp0__length1, (GDestroyNotify) g_free), NULL);
#line 1558 "WacomToolMap.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
#line 208 "../src/Backend/WacomToolMap.vala"
		g_clear_error (&_inner_error0_);
#line 1565 "WacomToolMap.c"
	}
	__finally0:
#line 208 "../src/Backend/WacomToolMap.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 208 "../src/Backend/WacomToolMap.vala"
		styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 208 "../src/Backend/WacomToolMap.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 208 "../src/Backend/WacomToolMap.vala"
		g_clear_error (&_inner_error0_);
#line 208 "../src/Backend/WacomToolMap.vala"
		return;
#line 1578 "WacomToolMap.c"
	}
#line 214 "../src/Backend/WacomToolMap.vala"
	_tmp5_ = styli;
#line 214 "../src/Backend/WacomToolMap.vala"
	_tmp5__length1 = styli_length1;
#line 214 "../src/Backend/WacomToolMap.vala"
	if (_tmp5_ == NULL) {
#line 1586 "WacomToolMap.c"
		gchar** _tmp6_;
#line 215 "../src/Backend/WacomToolMap.vala"
		_tmp6_ = g_new0 (gchar*, 0 + 1);
#line 215 "../src/Backend/WacomToolMap.vala"
		styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 215 "../src/Backend/WacomToolMap.vala"
		styli = _tmp6_;
#line 215 "../src/Backend/WacomToolMap.vala"
		styli_length1 = 0;
#line 215 "../src/Backend/WacomToolMap.vala"
		_styli_size_ = styli_length1;
#line 1598 "WacomToolMap.c"
	}
#line 218 "../src/Backend/WacomToolMap.vala"
	_tmp7_ = g_strdup (tool_key);
#line 218 "../src/Backend/WacomToolMap.vala"
	_vala_array_add1 (&styli, &styli_length1, &_styli_size_, _tmp7_);
#line 219 "../src/Backend/WacomToolMap.vala"
	_tmp8_ = self->priv->tablets;
#line 219 "../src/Backend/WacomToolMap.vala"
	_tmp9_ = styli;
#line 219 "../src/Backend/WacomToolMap.vala"
	_tmp9__length1 = styli_length1;
#line 219 "../src/Backend/WacomToolMap.vala"
	g_key_file_set_string_list (_tmp8_, device_key, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_DEVICE_STYLI, (const gchar* const*) _tmp9_, (gint) _tmp9__length1);
#line 206 "../src/Backend/WacomToolMap.vala"
	styli = (_vala_array_free (styli, styli_length1, (GDestroyNotify) g_free), NULL);
#line 1614 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_keyfile_add_stylus (WacomBackendWacomToolMap* self,
                                                 const gchar* tool_key,
                                                 guint64 id)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	GKeyFile* _tmp1_;
#line 222 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (self != NULL);
#line 222 "../src/Backend/WacomToolMap.vala"
	g_return_if_fail (tool_key != NULL);
#line 223 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = wacom_backend_wacom_tool_map_get_tool_key (id);
#line 223 "../src/Backend/WacomToolMap.vala"
	str = _tmp0_;
#line 224 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = self->priv->tools;
#line 224 "../src/Backend/WacomToolMap.vala"
	g_key_file_set_string (_tmp1_, tool_key, WACOM_BACKEND_WACOM_TOOL_MAP_KEY_TOOL_ID, str);
#line 222 "../src/Backend/WacomToolMap.vala"
	_g_free0 (str);
#line 1639 "WacomToolMap.c"
}

WacomBackendWacomTool*
wacom_backend_wacom_tool_map_lookup_tool (WacomBackendWacomToolMap* self,
                                          WacomBackendWacomDevice* device,
                                          guint64 serial)
{
	gchar* key = NULL;
	WacomBackendWacomTool* tool = NULL;
	WacomBackendWacomTool* result;
#line 227 "../src/Backend/WacomToolMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 227 "../src/Backend/WacomToolMap.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 229 "../src/Backend/WacomToolMap.vala"
	tool = NULL;
#line 231 "../src/Backend/WacomToolMap.vala"
	if (serial == ((guint64) 0)) {
#line 1658 "WacomToolMap.c"
		gchar* _tmp0_;
		GeeHashMap* _tmp1_;
		const gchar* _tmp2_;
		gpointer _tmp3_;
#line 232 "../src/Backend/WacomToolMap.vala"
		_tmp0_ = wacom_backend_wacom_tool_map_get_device_key (device);
#line 232 "../src/Backend/WacomToolMap.vala"
		_g_free0 (key);
#line 232 "../src/Backend/WacomToolMap.vala"
		key = _tmp0_;
#line 233 "../src/Backend/WacomToolMap.vala"
		_tmp1_ = self->priv->no_serial_tool_map;
#line 233 "../src/Backend/WacomToolMap.vala"
		_tmp2_ = key;
#line 233 "../src/Backend/WacomToolMap.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, _tmp2_);
#line 233 "../src/Backend/WacomToolMap.vala"
		_g_object_unref0 (tool);
#line 233 "../src/Backend/WacomToolMap.vala"
		tool = (WacomBackendWacomTool*) _tmp3_;
#line 1679 "WacomToolMap.c"
	} else {
		gchar* _tmp4_;
		GeeHashMap* _tmp5_;
		const gchar* _tmp6_;
		gpointer _tmp7_;
#line 235 "../src/Backend/WacomToolMap.vala"
		_tmp4_ = wacom_backend_wacom_tool_map_get_tool_key (serial);
#line 235 "../src/Backend/WacomToolMap.vala"
		_g_free0 (key);
#line 235 "../src/Backend/WacomToolMap.vala"
		key = _tmp4_;
#line 236 "../src/Backend/WacomToolMap.vala"
		_tmp5_ = self->priv->tool_map;
#line 236 "../src/Backend/WacomToolMap.vala"
		_tmp6_ = key;
#line 236 "../src/Backend/WacomToolMap.vala"
		_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, _tmp6_);
#line 236 "../src/Backend/WacomToolMap.vala"
		_g_object_unref0 (tool);
#line 236 "../src/Backend/WacomToolMap.vala"
		tool = (WacomBackendWacomTool*) _tmp7_;
#line 1701 "WacomToolMap.c"
	}
#line 239 "../src/Backend/WacomToolMap.vala"
	result = tool;
#line 239 "../src/Backend/WacomToolMap.vala"
	_g_free0 (key);
#line 239 "../src/Backend/WacomToolMap.vala"
	return result;
#line 1709 "WacomToolMap.c"
}

GeeArrayList*
wacom_backend_wacom_tool_map_list_tools (WacomBackendWacomToolMap* self,
                                         WacomBackendWacomDevice* device)
{
	GeeArrayList* styli = NULL;
	GeeArrayList* _tmp0_;
	gchar* key = NULL;
	gchar* _tmp1_;
	GeeArrayList* tablet_tools = NULL;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	GeeArrayList* _tmp5_;
	GeeHashMap* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result;
#line 242 "../src/Backend/WacomToolMap.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 242 "../src/Backend/WacomToolMap.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 243 "../src/Backend/WacomToolMap.vala"
	_tmp0_ = gee_array_list_new (WACOM_BACKEND_TYPE_WACOM_TOOL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 243 "../src/Backend/WacomToolMap.vala"
	styli = _tmp0_;
#line 245 "../src/Backend/WacomToolMap.vala"
	_tmp1_ = wacom_backend_wacom_tool_map_get_device_key (device);
#line 245 "../src/Backend/WacomToolMap.vala"
	key = _tmp1_;
#line 246 "../src/Backend/WacomToolMap.vala"
	_tmp2_ = self->priv->tablet_map;
#line 246 "../src/Backend/WacomToolMap.vala"
	_tmp3_ = key;
#line 246 "../src/Backend/WacomToolMap.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
#line 246 "../src/Backend/WacomToolMap.vala"
	tablet_tools = (GeeArrayList*) _tmp4_;
#line 247 "../src/Backend/WacomToolMap.vala"
	_tmp5_ = tablet_tools;
#line 247 "../src/Backend/WacomToolMap.vala"
	if (_tmp5_ != NULL) {
#line 1753 "WacomToolMap.c"
		GeeArrayList* _tmp6_;
		GeeHashMap* _tmp7_;
		const gchar* _tmp8_;
		gpointer _tmp9_;
		GeeArrayList* _tmp10_;
#line 248 "../src/Backend/WacomToolMap.vala"
		_tmp6_ = styli;
#line 248 "../src/Backend/WacomToolMap.vala"
		_tmp7_ = self->priv->tablet_map;
#line 248 "../src/Backend/WacomToolMap.vala"
		_tmp8_ = key;
#line 248 "../src/Backend/WacomToolMap.vala"
		_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp8_);
#line 248 "../src/Backend/WacomToolMap.vala"
		_tmp10_ = (GeeArrayList*) _tmp9_;
#line 248 "../src/Backend/WacomToolMap.vala"
		gee_array_list_add_all (_tmp6_, (GeeCollection*) _tmp10_);
#line 248 "../src/Backend/WacomToolMap.vala"
		_g_object_unref0 (_tmp10_);
#line 1773 "WacomToolMap.c"
	}
#line 251 "../src/Backend/WacomToolMap.vala"
	_tmp11_ = self->priv->no_serial_tool_map;
#line 251 "../src/Backend/WacomToolMap.vala"
	_tmp12_ = key;
#line 251 "../src/Backend/WacomToolMap.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp11_, _tmp12_)) {
#line 1781 "WacomToolMap.c"
		WacomBackendWacomTool* no_serial_tool = NULL;
		GeeHashMap* _tmp13_;
		const gchar* _tmp14_;
		gpointer _tmp15_;
		WacomBackendWacomTool* _tmp16_;
		GeeArrayList* _tmp23_;
		WacomBackendWacomTool* _tmp24_;
#line 252 "../src/Backend/WacomToolMap.vala"
		_tmp13_ = self->priv->no_serial_tool_map;
#line 252 "../src/Backend/WacomToolMap.vala"
		_tmp14_ = key;
#line 252 "../src/Backend/WacomToolMap.vala"
		_tmp15_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp13_, _tmp14_);
#line 252 "../src/Backend/WacomToolMap.vala"
		no_serial_tool = (WacomBackendWacomTool*) _tmp15_;
#line 253 "../src/Backend/WacomToolMap.vala"
		_tmp16_ = no_serial_tool;
#line 253 "../src/Backend/WacomToolMap.vala"
		if (_tmp16_ == NULL) {
#line 1801 "WacomToolMap.c"
			WacomBackendWacomTool* _tmp17_ = NULL;
			WacomBackendWacomTool* _tmp18_;
			WacomBackendWacomTool* _tmp19_;
			GeeHashMap* _tmp20_;
			const gchar* _tmp21_;
			WacomBackendWacomTool* _tmp22_;
#line 254 "../src/Backend/WacomToolMap.vala"
			_tmp18_ = wacom_backend_wacom_tool_new ((guint64) 0, (guint64) 0, device, &_inner_error0_);
#line 254 "../src/Backend/WacomToolMap.vala"
			_tmp17_ = _tmp18_;
#line 254 "../src/Backend/WacomToolMap.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (no_serial_tool);
#line 254 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (tablet_tools);
#line 254 "../src/Backend/WacomToolMap.vala"
				_g_free0 (key);
#line 254 "../src/Backend/WacomToolMap.vala"
				_g_object_unref0 (styli);
#line 254 "../src/Backend/WacomToolMap.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 254 "../src/Backend/WacomToolMap.vala"
				g_clear_error (&_inner_error0_);
#line 254 "../src/Backend/WacomToolMap.vala"
				return NULL;
#line 1828 "WacomToolMap.c"
			}
#line 254 "../src/Backend/WacomToolMap.vala"
			_tmp19_ = _tmp17_;
#line 254 "../src/Backend/WacomToolMap.vala"
			_tmp17_ = NULL;
#line 254 "../src/Backend/WacomToolMap.vala"
			_g_object_unref0 (no_serial_tool);
#line 254 "../src/Backend/WacomToolMap.vala"
			no_serial_tool = _tmp19_;
#line 255 "../src/Backend/WacomToolMap.vala"
			_tmp20_ = self->priv->no_serial_tool_map;
#line 255 "../src/Backend/WacomToolMap.vala"
			_tmp21_ = key;
#line 255 "../src/Backend/WacomToolMap.vala"
			_tmp22_ = no_serial_tool;
#line 255 "../src/Backend/WacomToolMap.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp20_, _tmp21_, _tmp22_);
#line 253 "../src/Backend/WacomToolMap.vala"
			_g_object_unref0 (_tmp17_);
#line 1848 "WacomToolMap.c"
		}
#line 258 "../src/Backend/WacomToolMap.vala"
		_tmp23_ = styli;
#line 258 "../src/Backend/WacomToolMap.vala"
		_tmp24_ = no_serial_tool;
#line 258 "../src/Backend/WacomToolMap.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 251 "../src/Backend/WacomToolMap.vala"
		_g_object_unref0 (no_serial_tool);
#line 1858 "WacomToolMap.c"
	}
#line 261 "../src/Backend/WacomToolMap.vala"
	result = styli;
#line 261 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (tablet_tools);
#line 261 "../src/Backend/WacomToolMap.vala"
	_g_free0 (key);
#line 261 "../src/Backend/WacomToolMap.vala"
	return result;
#line 1868 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_class_init (WacomBackendWacomToolMapClass * klass,
                                         gpointer klass_data)
{
#line 20 "../src/Backend/WacomToolMap.vala"
	wacom_backend_wacom_tool_map_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Backend/WacomToolMap.vala"
	g_type_class_adjust_private_offset (klass, &WacomBackendWacomToolMap_private_offset);
#line 20 "../src/Backend/WacomToolMap.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_backend_wacom_tool_map_finalize;
#line 1881 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_instance_init (WacomBackendWacomToolMap * self,
                                            gpointer klass)
{
#line 20 "../src/Backend/WacomToolMap.vala"
	self->priv = wacom_backend_wacom_tool_map_get_instance_private (self);
#line 1890 "WacomToolMap.c"
}

static void
wacom_backend_wacom_tool_map_finalize (GObject * obj)
{
	WacomBackendWacomToolMap * self;
#line 20 "../src/Backend/WacomToolMap.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_BACKEND_TYPE_WACOM_TOOL_MAP, WacomBackendWacomToolMap);
#line 25 "../src/Backend/WacomToolMap.vala"
	_g_key_file_unref0 (self->priv->tablets);
#line 26 "../src/Backend/WacomToolMap.vala"
	_g_key_file_unref0 (self->priv->tools);
#line 28 "../src/Backend/WacomToolMap.vala"
	_g_free0 (self->priv->tablet_path);
#line 29 "../src/Backend/WacomToolMap.vala"
	_g_free0 (self->priv->tool_path);
#line 31 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->tablet_map);
#line 32 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->tool_map);
#line 33 "../src/Backend/WacomToolMap.vala"
	_g_object_unref0 (self->priv->no_serial_tool_map);
#line 20 "../src/Backend/WacomToolMap.vala"
	G_OBJECT_CLASS (wacom_backend_wacom_tool_map_parent_class)->finalize (obj);
#line 1915 "WacomToolMap.c"
}

static GType
wacom_backend_wacom_tool_map_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomBackendWacomToolMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_backend_wacom_tool_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomBackendWacomToolMap), 0, (GInstanceInitFunc) wacom_backend_wacom_tool_map_instance_init, NULL };
	GType wacom_backend_wacom_tool_map_type_id;
	wacom_backend_wacom_tool_map_type_id = g_type_register_static (G_TYPE_OBJECT, "WacomBackendWacomToolMap", &g_define_type_info, 0);
	WacomBackendWacomToolMap_private_offset = g_type_add_instance_private (wacom_backend_wacom_tool_map_type_id, sizeof (WacomBackendWacomToolMapPrivate));
	return wacom_backend_wacom_tool_map_type_id;
}

GType
wacom_backend_wacom_tool_map_get_type (void)
{
	static volatile gsize wacom_backend_wacom_tool_map_type_id__once = 0;
	if (g_once_init_enter (&wacom_backend_wacom_tool_map_type_id__once)) {
		GType wacom_backend_wacom_tool_map_type_id;
		wacom_backend_wacom_tool_map_type_id = wacom_backend_wacom_tool_map_get_type_once ();
		g_once_init_leave (&wacom_backend_wacom_tool_map_type_id__once, wacom_backend_wacom_tool_map_type_id);
	}
	return wacom_backend_wacom_tool_map_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 20 "../src/Backend/DeviceManagerX11.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1947 "WacomToolMap.c"
		gssize i;
#line 20 "../src/Backend/DeviceManagerX11.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 20 "../src/Backend/DeviceManagerX11.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 20 "../src/Backend/DeviceManagerX11.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1955 "WacomToolMap.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 20 "../src/Backend/DeviceManagerX11.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 20 "../src/Backend/DeviceManagerX11.vala"
	g_free (array);
#line 1970 "WacomToolMap.c"
}

