/* Plug.c generated by valac 0.56.14, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "wacom.h"
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gdk/gdk.h>
#include <gmodule.h>

enum  {
	WACOM_PLUG_0_PROPERTY,
	WACOM_PLUG_NUM_PROPERTIES
};
static GParamSpec* wacom_plug_properties[WACOM_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _WacomPlugSearchData WacomPlugSearchData;

struct _WacomPlugPrivate {
	GtkStack* main_stack;
	GtkScrolledWindow* scrolled;
	GtkStack* empty_stack;
	WacomStylusView* stylus_view;
	WacomTabletView* tablet_view;
	WacomBackendDeviceManager* device_manager;
	GeeHashMap* devices;
	WacomBackendWacomTool* last_stylus;
	WacomBackendWacomToolMap* tool_map;
};

struct _WacomPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	WacomPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
};

static gint WacomPlug_private_offset;
static gpointer wacom_plug_parent_class = NULL;

static GtkWidget* wacom_plug_real_get_widget (SwitchboardPlug* base);
static gboolean wacom_plug_update_current_tool (WacomPlug* self,
                                         GdkEvent* event);
static gboolean _wacom_plug_update_current_tool_gtk_widget_event (GtkWidget* _sender,
                                                           GdkEvent* event,
                                                           gpointer self);
static void wacom_plug_on_device_added (WacomPlug* self,
                                 WacomBackendDevice* device);
static void _wacom_plug_on_device_added_wacom_backend_device_manager_device_added (WacomBackendDeviceManager* _sender,
                                                                            WacomBackendDevice* device,
                                                                            gpointer self);
static void wacom_plug_on_device_removed (WacomPlug* self,
                                   WacomBackendDevice* device);
static void _wacom_plug_on_device_removed_wacom_backend_device_manager_device_removed (WacomBackendDeviceManager* _sender,
                                                                                WacomBackendDevice* device,
                                                                                gpointer self);
static void wacom_plug_add_known_device (WacomPlug* self,
                                  WacomBackendDevice* d);
static void wacom_plug_update_current_page (WacomPlug* self);
static void wacom_plug_real_shown (SwitchboardPlug* base);
static void wacom_plug_real_hidden (SwitchboardPlug* base);
static void wacom_plug_real_search_callback (SwitchboardPlug* base,
                                      const gchar* location);
static void wacom_plug_real_search_data_free (gpointer _data);
static void wacom_plug_real_search (SwitchboardPlug* base,
                             const gchar* search,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
static gboolean wacom_plug_real_search_co (WacomPlugSearchData* _data_);
static void wacom_plug_finalize (GObject * obj);
static GType wacom_plug_get_type_once (void);

static inline gpointer
wacom_plug_get_instance_private (WacomPlug* self)
{
	return G_STRUCT_MEMBER_P (self, WacomPlug_private_offset);
}

WacomPlug*
wacom_plug_construct (GType object_type)
{
	WacomPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 37 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 38 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 40 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 40 "../src/Plug.vala"
	settings = _tmp0_;
#line 41 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "input/pointing/stylus", "general");
#line 43 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "input/wacom", "general");
#line 45 "../src/Plug.vala"
	self = (WacomPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "code-name", "pantheon-wacom", "display-name", _ ("Wacom"), "description", _ ("Configure Wacom tablet"), "icon", "input-tablet", "supported-settings", settings, NULL);
#line 36 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 36 "../src/Plug.vala"
	return self;
#line 145 "Plug.c"
}

WacomPlug*
wacom_plug_new (void)
{
#line 36 "../src/Plug.vala"
	return wacom_plug_construct (WACOM_TYPE_PLUG);
#line 153 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 64 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 161 "Plug.c"
}

static gboolean
_wacom_plug_update_current_tool_gtk_widget_event (GtkWidget* _sender,
                                                  GdkEvent* event,
                                                  gpointer self)
{
	gboolean result;
	result = wacom_plug_update_current_tool ((WacomPlug*) self, event);
#line 103 "../src/Plug.vala"
	return result;
#line 173 "Plug.c"
}

static void
_wacom_plug_on_device_added_wacom_backend_device_manager_device_added (WacomBackendDeviceManager* _sender,
                                                                       WacomBackendDevice* device,
                                                                       gpointer self)
{
#line 106 "../src/Plug.vala"
	wacom_plug_on_device_added ((WacomPlug*) self, device);
#line 183 "Plug.c"
}

static void
_wacom_plug_on_device_removed_wacom_backend_device_manager_device_removed (WacomBackendDeviceManager* _sender,
                                                                           WacomBackendDevice* device,
                                                                           gpointer self)
{
#line 107 "../src/Plug.vala"
	wacom_plug_on_device_removed ((WacomPlug*) self, device);
#line 193 "Plug.c"
}

static GtkWidget*
wacom_plug_real_get_widget (SwitchboardPlug* base)
{
	WacomPlug * self;
	GtkStack* _tmp0_;
	GtkStack* _tmp53_;
	GtkWidget* _tmp54_;
	GtkWidget* result;
#line 55 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 56 "../src/Plug.vala"
	_tmp0_ = self->priv->empty_stack;
#line 56 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 210 "Plug.c"
		GeeHashMap* _tmp1_;
		WacomBackendWacomToolMap* _tmp4_;
		WacomBackendWacomToolMap* _tmp5_;
		WacomStylusView* _tmp6_;
		WacomTabletView* _tmp7_;
		GtkStack* _tmp8_;
		GtkStack* _tmp9_;
		GtkStack* _tmp10_;
		WacomStylusView* _tmp11_;
		GtkStack* _tmp12_;
		WacomTabletView* _tmp13_;
		GtkStackSwitcher* switcher = NULL;
		GtkStackSwitcher* _tmp14_;
		GtkStackSwitcher* _tmp15_;
		GtkStackSwitcher* _tmp16_;
		GtkStackSwitcher* _tmp17_;
		GtkStackSwitcher* _tmp18_;
		GtkStack* _tmp19_;
		GtkGrid* main_grid = NULL;
		GtkGrid* _tmp20_;
		GtkGrid* _tmp21_;
		GtkGrid* _tmp22_;
		GtkStackSwitcher* _tmp23_;
		GtkGrid* _tmp24_;
		GtkStack* _tmp25_;
		GtkScrolledWindow* _tmp26_;
		GtkScrolledWindow* _tmp27_;
		GtkGrid* _tmp28_;
		GtkScrolledWindow* _tmp29_;
		GraniteWidgetsAlertView* alert_view = NULL;
		GraniteWidgetsAlertView* _tmp30_;
		GtkStack* _tmp31_;
		GtkStack* _tmp32_;
		GtkScrolledWindow* _tmp33_;
		GtkStack* _tmp34_;
		GraniteWidgetsAlertView* _tmp35_;
		GtkStack* _tmp36_;
		GtkStack* _tmp37_;
		GtkStack* _tmp38_;
		WacomBackendDeviceManager* _tmp39_;
		WacomBackendDeviceManager* _tmp40_;
		WacomBackendDeviceManager* _tmp41_;
		WacomBackendDeviceManager* _tmp42_;
#line 58 "../src/Plug.vala"
		_tmp1_ = self->priv->devices;
#line 58 "../src/Plug.vala"
		if (_tmp1_ == NULL) {
#line 258 "Plug.c"
			GeeHashMap* _tmp2_;
#line 59 "../src/Plug.vala"
			_tmp2_ = gee_hash_map_new (WACOM_BACKEND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, WACOM_BACKEND_TYPE_WACOM_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 59 "../src/Plug.vala"
			_g_object_unref0 (self->priv->devices);
#line 59 "../src/Plug.vala"
			self->priv->devices = _tmp2_;
#line 266 "Plug.c"
		} else {
			GeeHashMap* _tmp3_;
#line 61 "../src/Plug.vala"
			_tmp3_ = self->priv->devices;
#line 61 "../src/Plug.vala"
			gee_abstract_map_clear ((GeeAbstractMap*) _tmp3_);
#line 273 "Plug.c"
		}
#line 64 "../src/Plug.vala"
		_tmp4_ = wacom_backend_wacom_tool_map_get_default ();
#line 64 "../src/Plug.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 64 "../src/Plug.vala"
		_g_object_unref0 (self->priv->tool_map);
#line 64 "../src/Plug.vala"
		self->priv->tool_map = _tmp5_;
#line 66 "../src/Plug.vala"
		_tmp6_ = wacom_stylus_view_new ();
#line 66 "../src/Plug.vala"
		g_object_ref_sink (_tmp6_);
#line 66 "../src/Plug.vala"
		_g_object_unref0 (self->priv->stylus_view);
#line 66 "../src/Plug.vala"
		self->priv->stylus_view = _tmp6_;
#line 67 "../src/Plug.vala"
		_tmp7_ = wacom_tablet_view_new ();
#line 67 "../src/Plug.vala"
		g_object_ref_sink (_tmp7_);
#line 67 "../src/Plug.vala"
		_g_object_unref0 (self->priv->tablet_view);
#line 67 "../src/Plug.vala"
		self->priv->tablet_view = _tmp7_;
#line 69 "../src/Plug.vala"
		_tmp8_ = (GtkStack*) gtk_stack_new ();
#line 69 "../src/Plug.vala"
		g_object_ref_sink (_tmp8_);
#line 69 "../src/Plug.vala"
		_g_object_unref0 (self->priv->main_stack);
#line 69 "../src/Plug.vala"
		self->priv->main_stack = _tmp8_;
#line 70 "../src/Plug.vala"
		_tmp9_ = self->priv->main_stack;
#line 70 "../src/Plug.vala"
		g_object_set ((GtkWidget*) _tmp9_, "margin", 12, NULL);
#line 71 "../src/Plug.vala"
		_tmp10_ = self->priv->main_stack;
#line 71 "../src/Plug.vala"
		_tmp11_ = self->priv->stylus_view;
#line 71 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp10_, (GtkWidget*) _tmp11_, "stylus", _ ("Stylus"));
#line 72 "../src/Plug.vala"
		_tmp12_ = self->priv->main_stack;
#line 72 "../src/Plug.vala"
		_tmp13_ = self->priv->tablet_view;
#line 72 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp12_, (GtkWidget*) _tmp13_, "tablet", _ ("Tablet"));
#line 74 "../src/Plug.vala"
		_tmp14_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 74 "../src/Plug.vala"
		g_object_ref_sink (_tmp14_);
#line 74 "../src/Plug.vala"
		switcher = _tmp14_;
#line 75 "../src/Plug.vala"
		_tmp15_ = switcher;
#line 75 "../src/Plug.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp15_, GTK_ALIGN_CENTER);
#line 76 "../src/Plug.vala"
		_tmp16_ = switcher;
#line 76 "../src/Plug.vala"
		gtk_box_set_homogeneous ((GtkBox*) _tmp16_, TRUE);
#line 77 "../src/Plug.vala"
		_tmp17_ = switcher;
#line 77 "../src/Plug.vala"
		g_object_set ((GtkWidget*) _tmp17_, "margin", 12, NULL);
#line 78 "../src/Plug.vala"
		_tmp18_ = switcher;
#line 78 "../src/Plug.vala"
		_tmp19_ = self->priv->main_stack;
#line 78 "../src/Plug.vala"
		gtk_stack_switcher_set_stack (_tmp18_, _tmp19_);
#line 80 "../src/Plug.vala"
		_tmp20_ = (GtkGrid*) gtk_grid_new ();
#line 80 "../src/Plug.vala"
		g_object_ref_sink (_tmp20_);
#line 80 "../src/Plug.vala"
		main_grid = _tmp20_;
#line 81 "../src/Plug.vala"
		_tmp21_ = main_grid;
#line 81 "../src/Plug.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_CENTER);
#line 82 "../src/Plug.vala"
		_tmp22_ = main_grid;
#line 82 "../src/Plug.vala"
		_tmp23_ = switcher;
#line 82 "../src/Plug.vala"
		gtk_grid_attach (_tmp22_, (GtkWidget*) _tmp23_, 0, 0, 1, 1);
#line 83 "../src/Plug.vala"
		_tmp24_ = main_grid;
#line 83 "../src/Plug.vala"
		_tmp25_ = self->priv->main_stack;
#line 83 "../src/Plug.vala"
		gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 0, 1, 1, 1);
#line 85 "../src/Plug.vala"
		_tmp26_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 85 "../src/Plug.vala"
		g_object_ref_sink (_tmp26_);
#line 85 "../src/Plug.vala"
		_g_object_unref0 (self->priv->scrolled);
#line 85 "../src/Plug.vala"
		self->priv->scrolled = _tmp26_;
#line 86 "../src/Plug.vala"
		_tmp27_ = self->priv->scrolled;
#line 86 "../src/Plug.vala"
		_tmp28_ = main_grid;
#line 86 "../src/Plug.vala"
		gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 87 "../src/Plug.vala"
		_tmp29_ = self->priv->scrolled;
#line 87 "../src/Plug.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp29_);
#line 89 "../src/Plug.vala"
		_tmp30_ = granite_widgets_alert_view_new (_ ("No Tablets Available"), _ ("Please ensure your tablet is connected and switched on"), "input-tablet");
#line 89 "../src/Plug.vala"
		g_object_ref_sink (_tmp30_);
#line 89 "../src/Plug.vala"
		alert_view = _tmp30_;
#line 95 "../src/Plug.vala"
		_tmp31_ = (GtkStack*) gtk_stack_new ();
#line 95 "../src/Plug.vala"
		g_object_ref_sink (_tmp31_);
#line 95 "../src/Plug.vala"
		_g_object_unref0 (self->priv->empty_stack);
#line 95 "../src/Plug.vala"
		self->priv->empty_stack = _tmp31_;
#line 96 "../src/Plug.vala"
		_tmp32_ = self->priv->empty_stack;
#line 96 "../src/Plug.vala"
		_tmp33_ = self->priv->scrolled;
#line 96 "../src/Plug.vala"
		gtk_stack_add_named (_tmp32_, (GtkWidget*) _tmp33_, "main_view");
#line 97 "../src/Plug.vala"
		_tmp34_ = self->priv->empty_stack;
#line 97 "../src/Plug.vala"
		_tmp35_ = alert_view;
#line 97 "../src/Plug.vala"
		gtk_stack_add_named (_tmp34_, (GtkWidget*) _tmp35_, "no_tablets");
#line 99 "../src/Plug.vala"
		_tmp36_ = self->priv->empty_stack;
#line 99 "../src/Plug.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp36_);
#line 101 "../src/Plug.vala"
		_tmp37_ = self->priv->empty_stack;
#line 101 "../src/Plug.vala"
		gtk_stack_set_visible_child_name (_tmp37_, "no_tablets");
#line 103 "../src/Plug.vala"
		_tmp38_ = self->priv->empty_stack;
#line 103 "../src/Plug.vala"
		g_signal_connect_object ((GtkWidget*) _tmp38_, "event", (GCallback) _wacom_plug_update_current_tool_gtk_widget_event, self, 0);
#line 105 "../src/Plug.vala"
		_tmp39_ = wacom_backend_device_manager_get_default ();
#line 105 "../src/Plug.vala"
		_tmp40_ = _g_object_ref0 (_tmp39_);
#line 105 "../src/Plug.vala"
		_g_object_unref0 (self->priv->device_manager);
#line 105 "../src/Plug.vala"
		self->priv->device_manager = _tmp40_;
#line 106 "../src/Plug.vala"
		_tmp41_ = self->priv->device_manager;
#line 106 "../src/Plug.vala"
		g_signal_connect_object (_tmp41_, "device-added", (GCallback) _wacom_plug_on_device_added_wacom_backend_device_manager_device_added, self, 0);
#line 107 "../src/Plug.vala"
		_tmp42_ = self->priv->device_manager;
#line 107 "../src/Plug.vala"
		g_signal_connect_object (_tmp42_, "device-removed", (GCallback) _wacom_plug_on_device_removed_wacom_backend_device_manager_device_removed, self, 0);
#line 441 "Plug.c"
		{
			GeeArrayList* _device_list = NULL;
			WacomBackendDeviceManager* _tmp43_;
			GeeArrayList* _tmp44_;
			gint _device_size = 0;
			GeeArrayList* _tmp45_;
			gint _tmp46_;
			gint _tmp47_;
			gint _device_index = 0;
#line 109 "../src/Plug.vala"
			_tmp43_ = self->priv->device_manager;
#line 109 "../src/Plug.vala"
			_tmp44_ = wacom_backend_device_manager_list_devices (_tmp43_, WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET);
#line 109 "../src/Plug.vala"
			_device_list = _tmp44_;
#line 109 "../src/Plug.vala"
			_tmp45_ = _device_list;
#line 109 "../src/Plug.vala"
			_tmp46_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp45_);
#line 109 "../src/Plug.vala"
			_tmp47_ = _tmp46_;
#line 109 "../src/Plug.vala"
			_device_size = _tmp47_;
#line 109 "../src/Plug.vala"
			_device_index = -1;
#line 109 "../src/Plug.vala"
			while (TRUE) {
#line 469 "Plug.c"
				gint _tmp48_;
				gint _tmp49_;
				WacomBackendDevice* device = NULL;
				GeeArrayList* _tmp50_;
				gpointer _tmp51_;
				WacomBackendDevice* _tmp52_;
#line 109 "../src/Plug.vala"
				_device_index = _device_index + 1;
#line 109 "../src/Plug.vala"
				_tmp48_ = _device_index;
#line 109 "../src/Plug.vala"
				_tmp49_ = _device_size;
#line 109 "../src/Plug.vala"
				if (!(_tmp48_ < _tmp49_)) {
#line 109 "../src/Plug.vala"
					break;
#line 486 "Plug.c"
				}
#line 109 "../src/Plug.vala"
				_tmp50_ = _device_list;
#line 109 "../src/Plug.vala"
				_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) _tmp50_, _device_index);
#line 109 "../src/Plug.vala"
				device = (WacomBackendDevice*) _tmp51_;
#line 110 "../src/Plug.vala"
				_tmp52_ = device;
#line 110 "../src/Plug.vala"
				wacom_plug_add_known_device (self, _tmp52_);
#line 109 "../src/Plug.vala"
				_g_object_unref0 (device);
#line 500 "Plug.c"
			}
#line 109 "../src/Plug.vala"
			_g_object_unref0 (_device_list);
#line 504 "Plug.c"
		}
#line 113 "../src/Plug.vala"
		wacom_plug_update_current_page (self);
#line 56 "../src/Plug.vala"
		_g_object_unref0 (alert_view);
#line 56 "../src/Plug.vala"
		_g_object_unref0 (main_grid);
#line 56 "../src/Plug.vala"
		_g_object_unref0 (switcher);
#line 514 "Plug.c"
	}
#line 116 "../src/Plug.vala"
	_tmp53_ = self->priv->empty_stack;
#line 116 "../src/Plug.vala"
	_tmp54_ = _g_object_ref0 ((GtkWidget*) _tmp53_);
#line 116 "../src/Plug.vala"
	result = _tmp54_;
#line 116 "../src/Plug.vala"
	return result;
#line 524 "Plug.c"
}

static gboolean
wacom_plug_update_current_tool (WacomPlug* self,
                                GdkEvent* event)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 119 "../src/Plug.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 119 "../src/Plug.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 120 "../src/Plug.vala"
	if (gdk_event_get_event_type (event) == GDK_MOTION_NOTIFY) {
#line 539 "Plug.c"
		GdkDeviceTool* tool = NULL;
		GdkDeviceTool* _tmp0_;
		GdkDeviceTool* _tmp1_;
		GdkDeviceTool* _tmp2_;
		WacomBackendDevice* device = NULL;
		WacomBackendDeviceManager* _tmp3_;
		GdkDevice* _tmp4_;
		WacomBackendDevice* _tmp5_;
		WacomBackendDevice* _tmp6_;
		WacomBackendWacomDevice* wacom_device = NULL;
		GeeHashMap* _tmp7_;
		WacomBackendDevice* _tmp8_;
		gpointer _tmp9_;
		WacomBackendWacomDevice* _tmp10_;
		guint64 serial = 0ULL;
		GdkDeviceTool* _tmp11_;
		WacomBackendWacomTool* stylus = NULL;
		WacomBackendWacomToolMap* _tmp12_;
		WacomBackendWacomDevice* _tmp13_;
		WacomBackendWacomTool* _tmp14_;
		WacomBackendWacomTool* _tmp15_;
		WacomBackendWacomToolMap* _tmp22_;
		WacomBackendWacomDevice* _tmp23_;
		WacomBackendWacomTool* _tmp24_;
		WacomBackendWacomTool* _tmp25_;
		WacomBackendWacomTool* _tmp26_;
		WacomBackendWacomTool* _tmp29_;
		WacomBackendWacomTool* _tmp30_;
#line 121 "../src/Plug.vala"
		_tmp0_ = gdk_event_get_device_tool (event);
#line 121 "../src/Plug.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 121 "../src/Plug.vala"
		tool = _tmp1_;
#line 122 "../src/Plug.vala"
		_tmp2_ = tool;
#line 122 "../src/Plug.vala"
		if (_tmp2_ == NULL) {
#line 123 "../src/Plug.vala"
			result = GDK_EVENT_PROPAGATE;
#line 123 "../src/Plug.vala"
			_g_object_unref0 (tool);
#line 123 "../src/Plug.vala"
			return result;
#line 584 "Plug.c"
		}
#line 126 "../src/Plug.vala"
		_tmp3_ = self->priv->device_manager;
#line 126 "../src/Plug.vala"
		_tmp4_ = gdk_event_get_source_device (event);
#line 126 "../src/Plug.vala"
		_tmp5_ = wacom_backend_device_manager_lookup_gdk_device (_tmp3_, _tmp4_);
#line 126 "../src/Plug.vala"
		device = _tmp5_;
#line 127 "../src/Plug.vala"
		_tmp6_ = device;
#line 127 "../src/Plug.vala"
		if (_tmp6_ == NULL) {
#line 128 "../src/Plug.vala"
			result = GDK_EVENT_PROPAGATE;
#line 128 "../src/Plug.vala"
			_g_object_unref0 (device);
#line 128 "../src/Plug.vala"
			_g_object_unref0 (tool);
#line 128 "../src/Plug.vala"
			return result;
#line 606 "Plug.c"
		}
#line 131 "../src/Plug.vala"
		_tmp7_ = self->priv->devices;
#line 131 "../src/Plug.vala"
		_tmp8_ = device;
#line 131 "../src/Plug.vala"
		_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp8_);
#line 131 "../src/Plug.vala"
		wacom_device = (WacomBackendWacomDevice*) _tmp9_;
#line 132 "../src/Plug.vala"
		_tmp10_ = wacom_device;
#line 132 "../src/Plug.vala"
		if (_tmp10_ == NULL) {
#line 133 "../src/Plug.vala"
			result = GDK_EVENT_PROPAGATE;
#line 133 "../src/Plug.vala"
			_g_object_unref0 (wacom_device);
#line 133 "../src/Plug.vala"
			_g_object_unref0 (device);
#line 133 "../src/Plug.vala"
			_g_object_unref0 (tool);
#line 133 "../src/Plug.vala"
			return result;
#line 630 "Plug.c"
		}
#line 136 "../src/Plug.vala"
		_tmp11_ = tool;
#line 136 "../src/Plug.vala"
		serial = gdk_device_tool_get_serial (_tmp11_);
#line 138 "../src/Plug.vala"
		_tmp12_ = self->priv->tool_map;
#line 138 "../src/Plug.vala"
		_tmp13_ = wacom_device;
#line 138 "../src/Plug.vala"
		_tmp14_ = wacom_backend_wacom_tool_map_lookup_tool (_tmp12_, _tmp13_, serial);
#line 138 "../src/Plug.vala"
		stylus = _tmp14_;
#line 139 "../src/Plug.vala"
		_tmp15_ = stylus;
#line 139 "../src/Plug.vala"
		if (_tmp15_ == NULL) {
#line 648 "Plug.c"
			guint64 id = 0ULL;
			GdkDeviceTool* _tmp16_;
#line 140 "../src/Plug.vala"
			_tmp16_ = tool;
#line 140 "../src/Plug.vala"
			id = gdk_device_tool_get_hardware_id (_tmp16_);
#line 655 "Plug.c"
			{
				WacomBackendWacomTool* _tmp17_ = NULL;
				WacomBackendWacomDevice* _tmp18_;
				WacomBackendWacomTool* _tmp19_;
				WacomBackendWacomTool* _tmp20_;
#line 142 "../src/Plug.vala"
				_tmp18_ = wacom_device;
#line 142 "../src/Plug.vala"
				_tmp19_ = wacom_backend_wacom_tool_new (serial, id, _tmp18_, &_inner_error0_);
#line 142 "../src/Plug.vala"
				_tmp17_ = _tmp19_;
#line 142 "../src/Plug.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 669 "Plug.c"
					goto __catch0_g_error;
				}
#line 142 "../src/Plug.vala"
				_tmp20_ = _tmp17_;
#line 142 "../src/Plug.vala"
				_tmp17_ = NULL;
#line 142 "../src/Plug.vala"
				_g_object_unref0 (stylus);
#line 142 "../src/Plug.vala"
				stylus = _tmp20_;
#line 141 "../src/Plug.vala"
				_g_object_unref0 (_tmp17_);
#line 682 "Plug.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 141 "../src/Plug.vala"
				g_clear_error (&_inner_error0_);
#line 144 "../src/Plug.vala"
				result = GDK_EVENT_PROPAGATE;
#line 144 "../src/Plug.vala"
				_g_object_unref0 (stylus);
#line 144 "../src/Plug.vala"
				_g_object_unref0 (wacom_device);
#line 144 "../src/Plug.vala"
				_g_object_unref0 (device);
#line 144 "../src/Plug.vala"
				_g_object_unref0 (tool);
#line 144 "../src/Plug.vala"
				return result;
#line 701 "Plug.c"
			}
			__finally0:
#line 141 "../src/Plug.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 706 "Plug.c"
				gboolean _tmp21_ = FALSE;
#line 141 "../src/Plug.vala"
				_g_object_unref0 (stylus);
#line 141 "../src/Plug.vala"
				_g_object_unref0 (wacom_device);
#line 141 "../src/Plug.vala"
				_g_object_unref0 (device);
#line 141 "../src/Plug.vala"
				_g_object_unref0 (tool);
#line 141 "../src/Plug.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "../src/Plug.vala"
				g_clear_error (&_inner_error0_);
#line 141 "../src/Plug.vala"
				return _tmp21_;
#line 722 "Plug.c"
			}
		}
#line 148 "../src/Plug.vala"
		_tmp22_ = self->priv->tool_map;
#line 148 "../src/Plug.vala"
		_tmp23_ = wacom_device;
#line 148 "../src/Plug.vala"
		_tmp24_ = stylus;
#line 148 "../src/Plug.vala"
		wacom_backend_wacom_tool_map_add_relation (_tmp22_, _tmp23_, _tmp24_);
#line 149 "../src/Plug.vala"
		_tmp25_ = stylus;
#line 149 "../src/Plug.vala"
		_tmp26_ = self->priv->last_stylus;
#line 149 "../src/Plug.vala"
		if (_tmp25_ != _tmp26_) {
#line 739 "Plug.c"
			WacomStylusView* _tmp27_;
			WacomBackendWacomTool* _tmp28_;
#line 150 "../src/Plug.vala"
			_tmp27_ = self->priv->stylus_view;
#line 150 "../src/Plug.vala"
			_tmp28_ = stylus;
#line 150 "../src/Plug.vala"
			wacom_stylus_view_set_device (_tmp27_, _tmp28_);
#line 748 "Plug.c"
		}
#line 153 "../src/Plug.vala"
		_tmp29_ = stylus;
#line 153 "../src/Plug.vala"
		_tmp30_ = _g_object_ref0 (_tmp29_);
#line 153 "../src/Plug.vala"
		_g_object_unref0 (self->priv->last_stylus);
#line 153 "../src/Plug.vala"
		self->priv->last_stylus = _tmp30_;
#line 120 "../src/Plug.vala"
		_g_object_unref0 (stylus);
#line 120 "../src/Plug.vala"
		_g_object_unref0 (wacom_device);
#line 120 "../src/Plug.vala"
		_g_object_unref0 (device);
#line 120 "../src/Plug.vala"
		_g_object_unref0 (tool);
#line 766 "Plug.c"
	}
#line 156 "../src/Plug.vala"
	result = GDK_EVENT_PROPAGATE;
#line 156 "../src/Plug.vala"
	return result;
#line 772 "Plug.c"
}

static void
wacom_plug_add_known_device (WacomPlug* self,
                             WacomBackendDevice* d)
{
	WacomBackendDeviceDeviceType _tmp0_;
	WacomBackendDeviceDeviceType _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	WacomBackendDeviceDeviceType _tmp4_;
	WacomBackendDeviceDeviceType _tmp5_;
	GeeArrayList* tools = NULL;
	WacomBackendWacomToolMap* _tmp15_;
	GeeHashMap* _tmp16_;
	gpointer _tmp17_;
	WacomBackendWacomDevice* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	GError* _inner_error0_ = NULL;
#line 159 "../src/Plug.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/Plug.vala"
	g_return_if_fail (d != NULL);
#line 160 "../src/Plug.vala"
	_tmp0_ = wacom_backend_device_get_dev_type (d);
#line 160 "../src/Plug.vala"
	_tmp1_ = _tmp0_;
#line 160 "../src/Plug.vala"
	if (!((_tmp1_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_TABLET)) {
#line 161 "../src/Plug.vala"
		return;
#line 808 "Plug.c"
	}
#line 164 "../src/Plug.vala"
	_tmp4_ = wacom_backend_device_get_dev_type (d);
#line 164 "../src/Plug.vala"
	_tmp5_ = _tmp4_;
#line 164 "../src/Plug.vala"
	if ((_tmp5_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHSCREEN) {
#line 164 "../src/Plug.vala"
		_tmp3_ = TRUE;
#line 818 "Plug.c"
	} else {
		WacomBackendDeviceDeviceType _tmp6_;
		WacomBackendDeviceDeviceType _tmp7_;
#line 165 "../src/Plug.vala"
		_tmp6_ = wacom_backend_device_get_dev_type (d);
#line 165 "../src/Plug.vala"
		_tmp7_ = _tmp6_;
#line 165 "../src/Plug.vala"
		_tmp3_ = (_tmp7_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_TOUCHPAD;
#line 828 "Plug.c"
	}
#line 164 "../src/Plug.vala"
	if (_tmp3_) {
#line 164 "../src/Plug.vala"
		_tmp2_ = TRUE;
#line 834 "Plug.c"
	} else {
		WacomBackendDeviceDeviceType _tmp8_;
		WacomBackendDeviceDeviceType _tmp9_;
#line 166 "../src/Plug.vala"
		_tmp8_ = wacom_backend_device_get_dev_type (d);
#line 166 "../src/Plug.vala"
		_tmp9_ = _tmp8_;
#line 166 "../src/Plug.vala"
		_tmp2_ = (_tmp9_ & WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD) == WACOM_BACKEND_DEVICE_DEVICE_TYPE_PAD;
#line 844 "Plug.c"
	}
#line 164 "../src/Plug.vala"
	if (_tmp2_) {
#line 167 "../src/Plug.vala"
		return;
#line 850 "Plug.c"
	}
	{
		WacomBackendWacomDevice* _tmp10_ = NULL;
		WacomBackendWacomDevice* _tmp11_;
		GeeHashMap* _tmp12_;
#line 171 "../src/Plug.vala"
		_tmp11_ = wacom_backend_wacom_device_new (d, &_inner_error0_);
#line 171 "../src/Plug.vala"
		_tmp10_ = _tmp11_;
#line 171 "../src/Plug.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "../src/Plug.vala"
			if (_inner_error0_->domain == WACOM_EXCEPTION) {
#line 864 "Plug.c"
				goto __catch0_wacom_exception;
			}
#line 171 "../src/Plug.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/Plug.vala"
			g_clear_error (&_inner_error0_);
#line 171 "../src/Plug.vala"
			return;
#line 873 "Plug.c"
		}
#line 171 "../src/Plug.vala"
		_tmp12_ = self->priv->devices;
#line 171 "../src/Plug.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, d, _tmp10_);
#line 170 "../src/Plug.vala"
		_g_object_unref0 (_tmp10_);
#line 881 "Plug.c"
	}
	goto __finally0;
	__catch0_wacom_exception:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 170 "../src/Plug.vala"
		e = _inner_error0_;
#line 170 "../src/Plug.vala"
		_inner_error0_ = NULL;
#line 173 "../src/Plug.vala"
		_tmp13_ = e;
#line 173 "../src/Plug.vala"
		_tmp14_ = _tmp13_->message;
#line 173 "../src/Plug.vala"
		g_warning ("Plug.vala:173: Error initializing Wacom device: %s", _tmp14_);
#line 174 "../src/Plug.vala"
		_g_error_free0 (e);
#line 174 "../src/Plug.vala"
		return;
#line 903 "Plug.c"
	}
	__finally0:
#line 170 "../src/Plug.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/Plug.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 170 "../src/Plug.vala"
		g_clear_error (&_inner_error0_);
#line 170 "../src/Plug.vala"
		return;
#line 914 "Plug.c"
	}
#line 177 "../src/Plug.vala"
	_tmp15_ = self->priv->tool_map;
#line 177 "../src/Plug.vala"
	_tmp16_ = self->priv->devices;
#line 177 "../src/Plug.vala"
	_tmp17_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, d);
#line 177 "../src/Plug.vala"
	_tmp18_ = (WacomBackendWacomDevice*) _tmp17_;
#line 177 "../src/Plug.vala"
	_tmp19_ = wacom_backend_wacom_tool_map_list_tools (_tmp15_, _tmp18_);
#line 177 "../src/Plug.vala"
	_tmp20_ = _tmp19_;
#line 177 "../src/Plug.vala"
	_g_object_unref0 (_tmp18_);
#line 177 "../src/Plug.vala"
	tools = _tmp20_;
#line 178 "../src/Plug.vala"
	_tmp21_ = tools;
#line 178 "../src/Plug.vala"
	_tmp22_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp21_);
#line 178 "../src/Plug.vala"
	_tmp23_ = _tmp22_;
#line 178 "../src/Plug.vala"
	if (_tmp23_ > 0) {
#line 940 "Plug.c"
		WacomStylusView* _tmp24_;
		GeeArrayList* _tmp25_;
		gpointer _tmp26_;
		WacomBackendWacomTool* _tmp27_;
#line 179 "../src/Plug.vala"
		_tmp24_ = self->priv->stylus_view;
#line 179 "../src/Plug.vala"
		_tmp25_ = tools;
#line 179 "../src/Plug.vala"
		_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, 0);
#line 179 "../src/Plug.vala"
		_tmp27_ = (WacomBackendWacomTool*) _tmp26_;
#line 179 "../src/Plug.vala"
		wacom_stylus_view_set_device (_tmp24_, _tmp27_);
#line 179 "../src/Plug.vala"
		_g_object_unref0 (_tmp27_);
#line 957 "Plug.c"
	}
#line 159 "../src/Plug.vala"
	_g_object_unref0 (tools);
#line 961 "Plug.c"
}

static void
wacom_plug_update_current_page (WacomPlug* self)
{
	GtkStack* _tmp15_;
#line 183 "../src/Plug.vala"
	g_return_if_fail (self != NULL);
#line 970 "Plug.c"
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 184 "../src/Plug.vala"
		_tmp0_ = self->priv->devices;
#line 184 "../src/Plug.vala"
		_tmp1_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp0_);
#line 184 "../src/Plug.vala"
		_tmp2_ = _tmp1_;
#line 184 "../src/Plug.vala"
		_tmp3_ = _tmp2_;
#line 184 "../src/Plug.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 184 "../src/Plug.vala"
		_tmp5_ = _tmp4_;
#line 184 "../src/Plug.vala"
		_g_object_unref0 (_tmp3_);
#line 184 "../src/Plug.vala"
		_device_it = _tmp5_;
#line 184 "../src/Plug.vala"
		while (TRUE) {
#line 997 "Plug.c"
			GeeIterator* _tmp6_;
			WacomBackendDevice* device = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GtkStack* _tmp9_;
			WacomTabletView* _tmp10_;
			GeeHashMap* _tmp11_;
			WacomBackendDevice* _tmp12_;
			gpointer _tmp13_;
			WacomBackendWacomDevice* _tmp14_;
#line 184 "../src/Plug.vala"
			_tmp6_ = _device_it;
#line 184 "../src/Plug.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 184 "../src/Plug.vala"
				break;
#line 1014 "Plug.c"
			}
#line 184 "../src/Plug.vala"
			_tmp7_ = _device_it;
#line 184 "../src/Plug.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 184 "../src/Plug.vala"
			device = (WacomBackendDevice*) _tmp8_;
#line 185 "../src/Plug.vala"
			_tmp9_ = self->priv->empty_stack;
#line 185 "../src/Plug.vala"
			gtk_stack_set_visible_child_name (_tmp9_, "main_view");
#line 186 "../src/Plug.vala"
			_tmp10_ = self->priv->tablet_view;
#line 186 "../src/Plug.vala"
			_tmp11_ = self->priv->devices;
#line 186 "../src/Plug.vala"
			_tmp12_ = device;
#line 186 "../src/Plug.vala"
			_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, _tmp12_);
#line 186 "../src/Plug.vala"
			_tmp14_ = (WacomBackendWacomDevice*) _tmp13_;
#line 186 "../src/Plug.vala"
			wacom_tablet_view_set_device (_tmp10_, _tmp14_);
#line 186 "../src/Plug.vala"
			_g_object_unref0 (_tmp14_);
#line 187 "../src/Plug.vala"
			_g_object_unref0 (device);
#line 187 "../src/Plug.vala"
			_g_object_unref0 (_device_it);
#line 187 "../src/Plug.vala"
			return;
#line 1046 "Plug.c"
		}
#line 184 "../src/Plug.vala"
		_g_object_unref0 (_device_it);
#line 1050 "Plug.c"
	}
#line 190 "../src/Plug.vala"
	_tmp15_ = self->priv->empty_stack;
#line 190 "../src/Plug.vala"
	gtk_stack_set_visible_child_name (_tmp15_, "no_tablets");
#line 1056 "Plug.c"
}

static void
wacom_plug_on_device_added (WacomPlug* self,
                            WacomBackendDevice* device)
{
#line 193 "../src/Plug.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/Plug.vala"
	g_return_if_fail (device != NULL);
#line 194 "../src/Plug.vala"
	wacom_plug_add_known_device (self, device);
#line 195 "../src/Plug.vala"
	wacom_plug_update_current_page (self);
#line 1071 "Plug.c"
}

static void
wacom_plug_on_device_removed (WacomPlug* self,
                              WacomBackendDevice* device)
{
	GeeHashMap* _tmp0_;
#line 198 "../src/Plug.vala"
	g_return_if_fail (self != NULL);
#line 198 "../src/Plug.vala"
	g_return_if_fail (device != NULL);
#line 199 "../src/Plug.vala"
	_tmp0_ = self->priv->devices;
#line 199 "../src/Plug.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, device, NULL);
#line 200 "../src/Plug.vala"
	wacom_plug_update_current_page (self);
#line 1089 "Plug.c"
}

static void
wacom_plug_real_shown (SwitchboardPlug* base)
{
	WacomPlug * self;
#line 203 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 1098 "Plug.c"
}

static void
wacom_plug_real_hidden (SwitchboardPlug* base)
{
	WacomPlug * self;
#line 206 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 1107 "Plug.c"
}

static void
wacom_plug_real_search_callback (SwitchboardPlug* base,
                                 const gchar* location)
{
	WacomPlug * self;
#line 209 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 209 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 1119 "Plug.c"
}

static void
wacom_plug_real_search_data_free (gpointer _data)
{
	WacomPlugSearchData* _data_;
	_data_ = _data;
#line 20 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 20 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 20 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/Plug.vala"
	g_slice_free (WacomPlugSearchData, _data_);
#line 1135 "Plug.c"
}

static void
wacom_plug_real_search (SwitchboardPlug* base,
                        const gchar* search,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	WacomPlug * self;
	WacomPlugSearchData* _data_;
	WacomPlug* _tmp0_;
	gchar* _tmp1_;
#line 20 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 20 "../src/Plug.vala"
	self = (WacomPlug*) base;
#line 20 "../src/Plug.vala"
	_data_ = g_slice_new0 (WacomPlugSearchData);
#line 20 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, wacom_plug_real_search_data_free);
#line 20 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 20 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 20 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 20 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 20 "../src/Plug.vala"
	wacom_plug_real_search_co (_data_);
#line 1170 "Plug.c"
}

static GeeTreeMap*
wacom_plug_search_finish (SwitchboardPlug* base,
                          GAsyncResult* _res_)
{
	GeeTreeMap* result;
	WacomPlugSearchData* _data_;
#line 20 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 20 "../src/Plug.vala"
	result = _data_->result;
#line 20 "../src/Plug.vala"
	_data_->result = NULL;
#line 20 "../src/Plug.vala"
	return result;
#line 1187 "Plug.c"
}

static gboolean
wacom_plug_real_search_co (WacomPlugSearchData* _data_)
{
#line 213 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 213 "../src/Plug.vala"
		case 0:
#line 1197 "Plug.c"
		goto _state_0;
		default:
#line 213 "../src/Plug.vala"
		g_assert_not_reached ();
#line 1202 "Plug.c"
	}
	_state_0:
#line 214 "../src/Plug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 214 "../src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 214 "../src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 214 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 218 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 218 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 218 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 218 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 218 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1223 "Plug.c"
		}
	}
#line 218 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 218 "../src/Plug.vala"
	return FALSE;
#line 1230 "Plug.c"
}

static void
wacom_plug_class_init (WacomPlugClass * klass,
                       gpointer klass_data)
{
#line 20 "../src/Plug.vala"
	wacom_plug_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &WacomPlug_private_offset);
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) wacom_plug_real_get_widget;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) wacom_plug_real_shown;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) wacom_plug_real_hidden;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) wacom_plug_real_search_callback;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) wacom_plug_real_search;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) wacom_plug_search_finish;
#line 20 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_plug_finalize;
#line 1255 "Plug.c"
}

static void
wacom_plug_instance_init (WacomPlug * self,
                          gpointer klass)
{
#line 20 "../src/Plug.vala"
	self->priv = wacom_plug_get_instance_private (self);
#line 31 "../src/Plug.vala"
	self->priv->devices = NULL;
#line 33 "../src/Plug.vala"
	self->priv->last_stylus = NULL;
#line 1268 "Plug.c"
}

static void
wacom_plug_finalize (GObject * obj)
{
	WacomPlug * self;
#line 20 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_PLUG, WacomPlug);
#line 22 "../src/Plug.vala"
	_g_object_unref0 (self->priv->main_stack);
#line 23 "../src/Plug.vala"
	_g_object_unref0 (self->priv->scrolled);
#line 24 "../src/Plug.vala"
	_g_object_unref0 (self->priv->empty_stack);
#line 26 "../src/Plug.vala"
	_g_object_unref0 (self->priv->stylus_view);
#line 27 "../src/Plug.vala"
	_g_object_unref0 (self->priv->tablet_view);
#line 29 "../src/Plug.vala"
	_g_object_unref0 (self->priv->device_manager);
#line 31 "../src/Plug.vala"
	_g_object_unref0 (self->priv->devices);
#line 33 "../src/Plug.vala"
	_g_object_unref0 (self->priv->last_stylus);
#line 34 "../src/Plug.vala"
	_g_object_unref0 (self->priv->tool_map);
#line 20 "../src/Plug.vala"
	G_OBJECT_CLASS (wacom_plug_parent_class)->finalize (obj);
#line 1297 "Plug.c"
}

static GType
wacom_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomPlug), 0, (GInstanceInitFunc) wacom_plug_instance_init, NULL };
	GType wacom_plug_type_id;
	wacom_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "WacomPlug", &g_define_type_info, 0);
	WacomPlug_private_offset = g_type_add_instance_private (wacom_plug_type_id, sizeof (WacomPlugPrivate));
	return wacom_plug_type_id;
}

GType
wacom_plug_get_type (void)
{
	static volatile gsize wacom_plug_type_id__once = 0;
	if (g_once_init_enter (&wacom_plug_type_id__once)) {
		GType wacom_plug_type_id;
		wacom_plug_type_id = wacom_plug_get_type_once ();
		g_once_init_leave (&wacom_plug_type_id__once, wacom_plug_type_id);
	}
	return wacom_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	WacomPlug* plug = NULL;
	WacomPlug* _tmp0_;
	SwitchboardPlug* result;
#line 222 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 223 "../src/Plug.vala"
	g_debug ("Plug.vala:223: Activating Wacom plug");
#line 225 "../src/Plug.vala"
	_tmp0_ = wacom_plug_new ();
#line 225 "../src/Plug.vala"
	plug = _tmp0_;
#line 227 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 227 "../src/Plug.vala"
	return result;
#line 1340 "Plug.c"
}

