/* StylusView.c generated by valac 0.56.14, the Vala compiler
 * generated from StylusView.vala, do not modify */

/*
 * Copyright (c) 2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "wacom.h"
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <granite.h>

enum  {
	WACOM_STYLUS_VIEW_0_PROPERTY,
	WACOM_STYLUS_VIEW_NUM_PROPERTIES
};
static GParamSpec* wacom_stylus_view_properties[WACOM_STYLUS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;

struct _WacomStylusViewPrivate {
	WacomBackendWacomTool* device;
	GSettings* settings;
	GtkGrid* stylus_grid;
	gint last_grid_y_pos;
};

struct _Block1Data {
	int _ref_count_;
	WacomStylusView* self;
	GtkScale* scale;
	gchar* schema_key;
};

struct _Block2Data {
	int _ref_count_;
	WacomStylusView* self;
	GtkPopover* test_popover;
	WacomWidgetsDrawingArea* test_area;
};

static gint WacomStylusView_private_offset;
static gpointer wacom_stylus_view_parent_class = NULL;

static void wacom_stylus_view_build_button_settings (WacomStylusView* self,
                                              const gchar* label,
                                              const gchar* schema_key);
static void wacom_stylus_view_on_pressure_value_changed (WacomStylusView* self,
                                                  GtkScale* scale,
                                                  const gchar* schema_key);
static void wacom_stylus_view_set_pressure_scale_value_from_settings (WacomStylusView* self,
                                                               GtkScale* scale,
                                                               const gchar* schema_key);
static void wacom_stylus_view_build_pressure_slider (WacomStylusView* self,
                                              const gchar* label,
                                              const gchar* schema_key);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda6_ (Block1Data* _data1_);
static void ___lambda6__gtk_range_value_changed (GtkRange* _sender,
                                          gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda7_ (WacomStylusView* self,
                 GtkWidget* widget);
static void ___lambda7__gtk_callback (GtkWidget* widget,
                               gpointer self);
static void __lambda8_ (Block2Data* _data2_);
static void ___lambda8__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static GObject * wacom_stylus_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void wacom_stylus_view_finalize (GObject * obj);
static GType wacom_stylus_view_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gint32 WACOM_STYLUS_VIEW_PRESSURE_CURVES[7][4] = {{(gint32) 0, (gint32) 75, (gint32) 25, (gint32) 100}, {(gint32) 0, (gint32) 50, (gint32) 50, (gint32) 100}, {(gint32) 0, (gint32) 25, (gint32) 75, (gint32) 100}, {(gint32) 0, (gint32) 0, (gint32) 100, (gint32) 100}, {(gint32) 25, (gint32) 0, (gint32) 100, (gint32) 75}, {(gint32) 50, (gint32) 0, (gint32) 100, (gint32) 50}, {(gint32) 75, (gint32) 0, (gint32) 100, (gint32) 25}};

static inline gpointer
wacom_stylus_view_get_instance_private (WacomStylusView* self)
{
	return G_STRUCT_MEMBER_P (self, WacomStylusView_private_offset);
}

static void
wacom_stylus_view_build_button_settings (WacomStylusView* self,
                                         const gchar* label,
                                         const gchar* schema_key)
{
	GtkComboBoxText* button_combo = NULL;
	GtkComboBoxText* _tmp0_;
	GSettings* _tmp1_;
	GtkGrid* _tmp2_;
	WacomWidgetsSettingLabel* _tmp3_;
	WacomWidgetsSettingLabel* _tmp4_;
	GtkGrid* _tmp5_;
	gint _tmp6_;
#line 58 "../src/Views/StylusView.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/Views/StylusView.vala"
	g_return_if_fail (label != NULL);
#line 58 "../src/Views/StylusView.vala"
	g_return_if_fail (schema_key != NULL);
#line 59 "../src/Views/StylusView.vala"
	_tmp0_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 59 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp0_);
#line 59 "../src/Views/StylusView.vala"
	button_combo = _tmp0_;
#line 60 "../src/Views/StylusView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) button_combo, TRUE);
#line 61 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "default", _ ("Default"));
#line 62 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "middle", _ ("Middle Mouse Button Click"));
#line 63 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "right", _ ("Right Mouse Button Click"));
#line 64 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "back", _ ("Back"));
#line 65 "../src/Views/StylusView.vala"
	gtk_combo_box_text_append (button_combo, "forward", _ ("Forward"));
#line 67 "../src/Views/StylusView.vala"
	_tmp1_ = self->priv->settings;
#line 67 "../src/Views/StylusView.vala"
	g_settings_bind (_tmp1_, schema_key, (GObject*) button_combo, "active-id", G_SETTINGS_BIND_DEFAULT);
#line 68 "../src/Views/StylusView.vala"
	_tmp2_ = self->priv->stylus_grid;
#line 68 "../src/Views/StylusView.vala"
	_tmp3_ = wacom_widgets_setting_label_new (label);
#line 68 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp3_);
#line 68 "../src/Views/StylusView.vala"
	_tmp4_ = _tmp3_;
#line 68 "../src/Views/StylusView.vala"
	gtk_grid_attach (_tmp2_, (GtkWidget*) _tmp4_, 0, self->priv->last_grid_y_pos, 1, 1);
#line 68 "../src/Views/StylusView.vala"
	_g_object_unref0 (_tmp4_);
#line 69 "../src/Views/StylusView.vala"
	_tmp5_ = self->priv->stylus_grid;
#line 69 "../src/Views/StylusView.vala"
	gtk_grid_attach (_tmp5_, (GtkWidget*) button_combo, 1, self->priv->last_grid_y_pos, 1, 1);
#line 70 "../src/Views/StylusView.vala"
	_tmp6_ = self->priv->last_grid_y_pos;
#line 70 "../src/Views/StylusView.vala"
	self->priv->last_grid_y_pos = _tmp6_ + 1;
#line 58 "../src/Views/StylusView.vala"
	_g_object_unref0 (button_combo);
#line 186 "StylusView.c"
}

static void
wacom_stylus_view_on_pressure_value_changed (WacomStylusView* self,
                                             GtkScale* scale,
                                             const gchar* schema_key)
{
	gint new_value = 0;
	gboolean _tmp0_ = FALSE;
	GVariant** values = NULL;
	gint _tmp1_;
	GVariant** _tmp2_;
	gint values_length1;
	gint _values_size_;
	GVariant* array = NULL;
	const GVariantType* _tmp9_;
	GVariant** _tmp10_;
	gint _tmp10__length1;
	GVariant* _tmp11_;
	GSettings* _tmp12_;
	GVariant* _tmp13_;
#line 73 "../src/Views/StylusView.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/Views/StylusView.vala"
	g_return_if_fail (scale != NULL);
#line 73 "../src/Views/StylusView.vala"
	g_return_if_fail (schema_key != NULL);
#line 74 "../src/Views/StylusView.vala"
	new_value = (gint) gtk_range_get_value ((GtkRange*) scale);
#line 75 "../src/Views/StylusView.vala"
	if (new_value < 0) {
#line 75 "../src/Views/StylusView.vala"
		_tmp0_ = TRUE;
#line 220 "StylusView.c"
	} else {
#line 75 "../src/Views/StylusView.vala"
		_tmp0_ = new_value > 6;
#line 224 "StylusView.c"
	}
#line 75 "../src/Views/StylusView.vala"
	if (_tmp0_) {
#line 76 "../src/Views/StylusView.vala"
		return;
#line 230 "StylusView.c"
	}
#line 79 "../src/Views/StylusView.vala"
	_tmp1_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 79 "../src/Views/StylusView.vala"
	_tmp2_ = g_new0 (GVariant*, _tmp1_ + 1);
#line 79 "../src/Views/StylusView.vala"
	values = _tmp2_;
#line 79 "../src/Views/StylusView.vala"
	values_length1 = _tmp1_;
#line 79 "../src/Views/StylusView.vala"
	_values_size_ = values_length1;
#line 242 "StylusView.c"
	{
		gint i = 0;
#line 82 "../src/Views/StylusView.vala"
		i = 0;
#line 247 "StylusView.c"
		{
			gboolean _tmp3_ = FALSE;
#line 82 "../src/Views/StylusView.vala"
			_tmp3_ = TRUE;
#line 82 "../src/Views/StylusView.vala"
			while (TRUE) {
#line 254 "StylusView.c"
				GVariant** _tmp5_;
				gint _tmp5__length1;
				GVariant** _tmp6_;
				gint _tmp6__length1;
				gint32 _tmp7_;
				GVariant* _tmp8_;
#line 82 "../src/Views/StylusView.vala"
				if (!_tmp3_) {
#line 263 "StylusView.c"
					gint _tmp4_;
#line 82 "../src/Views/StylusView.vala"
					_tmp4_ = i;
#line 82 "../src/Views/StylusView.vala"
					i = _tmp4_ + 1;
#line 269 "StylusView.c"
				}
#line 82 "../src/Views/StylusView.vala"
				_tmp3_ = FALSE;
#line 82 "../src/Views/StylusView.vala"
				_tmp5_ = values;
#line 82 "../src/Views/StylusView.vala"
				_tmp5__length1 = values_length1;
#line 82 "../src/Views/StylusView.vala"
				if (!(i < _tmp5__length1)) {
#line 82 "../src/Views/StylusView.vala"
					break;
#line 281 "StylusView.c"
				}
#line 83 "../src/Views/StylusView.vala"
				_tmp6_ = values;
#line 83 "../src/Views/StylusView.vala"
				_tmp6__length1 = values_length1;
#line 83 "../src/Views/StylusView.vala"
				_tmp7_ = WACOM_STYLUS_VIEW_PRESSURE_CURVES[new_value][i];
#line 83 "../src/Views/StylusView.vala"
				_tmp8_ = g_variant_new_int32 (_tmp7_);
#line 83 "../src/Views/StylusView.vala"
				g_variant_ref_sink (_tmp8_);
#line 83 "../src/Views/StylusView.vala"
				_g_variant_unref0 (_tmp6_[i]);
#line 83 "../src/Views/StylusView.vala"
				_tmp6_[i] = _tmp8_;
#line 297 "StylusView.c"
			}
		}
	}
#line 86 "../src/Views/StylusView.vala"
	_tmp9_ = G_VARIANT_TYPE_INT32;
#line 86 "../src/Views/StylusView.vala"
	_tmp10_ = values;
#line 86 "../src/Views/StylusView.vala"
	_tmp10__length1 = values_length1;
#line 86 "../src/Views/StylusView.vala"
	_tmp11_ = g_variant_new_array (_tmp9_, _tmp10_, _tmp10__length1);
#line 86 "../src/Views/StylusView.vala"
	g_variant_ref_sink (_tmp11_);
#line 86 "../src/Views/StylusView.vala"
	_g_variant_unref0 (array);
#line 86 "../src/Views/StylusView.vala"
	array = _tmp11_;
#line 87 "../src/Views/StylusView.vala"
	_tmp12_ = self->priv->settings;
#line 87 "../src/Views/StylusView.vala"
	_tmp13_ = array;
#line 87 "../src/Views/StylusView.vala"
	g_settings_set_value (_tmp12_, schema_key, _tmp13_);
#line 73 "../src/Views/StylusView.vala"
	_g_variant_unref0 (array);
#line 73 "../src/Views/StylusView.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 325 "StylusView.c"
}

static void
wacom_stylus_view_set_pressure_scale_value_from_settings (WacomStylusView* self,
                                                          GtkScale* scale,
                                                          const gchar* schema_key)
{
	GVariant* settings_value = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gint _tmp3_;
	gint* values = NULL;
	gint _tmp5_;
	gint* _tmp6_;
	gint values_length1;
	gint _values_size_;
#line 90 "../src/Views/StylusView.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/Views/StylusView.vala"
	g_return_if_fail (scale != NULL);
#line 90 "../src/Views/StylusView.vala"
	g_return_if_fail (schema_key != NULL);
#line 91 "../src/Views/StylusView.vala"
	_tmp0_ = self->priv->settings;
#line 91 "../src/Views/StylusView.vala"
	_tmp1_ = g_settings_get_value (_tmp0_, schema_key);
#line 91 "../src/Views/StylusView.vala"
	settings_value = _tmp1_;
#line 92 "../src/Views/StylusView.vala"
	_tmp2_ = settings_value;
#line 92 "../src/Views/StylusView.vala"
	_tmp3_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 92 "../src/Views/StylusView.vala"
	if (g_variant_n_children (_tmp2_) != ((gsize) _tmp3_)) {
#line 361 "StylusView.c"
		gint _tmp4_;
#line 93 "../src/Views/StylusView.vala"
		_tmp4_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 93 "../src/Views/StylusView.vala"
		g_warning ("StylusView.vala:93: Invalid pressure curve format, expected %d values", _tmp4_);
#line 94 "../src/Views/StylusView.vala"
		_g_variant_unref0 (settings_value);
#line 94 "../src/Views/StylusView.vala"
		return;
#line 371 "StylusView.c"
	}
#line 97 "../src/Views/StylusView.vala"
	_tmp5_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 97 "../src/Views/StylusView.vala"
	_tmp6_ = g_new0 (gint, _tmp5_);
#line 97 "../src/Views/StylusView.vala"
	values = _tmp6_;
#line 97 "../src/Views/StylusView.vala"
	values_length1 = _tmp5_;
#line 97 "../src/Views/StylusView.vala"
	_values_size_ = values_length1;
#line 383 "StylusView.c"
	{
		gint i = 0;
#line 98 "../src/Views/StylusView.vala"
		i = 0;
#line 388 "StylusView.c"
		{
			gboolean _tmp7_ = FALSE;
#line 98 "../src/Views/StylusView.vala"
			_tmp7_ = TRUE;
#line 98 "../src/Views/StylusView.vala"
			while (TRUE) {
#line 395 "StylusView.c"
				gint _tmp9_;
				gint* _tmp10_;
				gint _tmp10__length1;
				GVariant* _tmp11_;
				GVariant* _tmp12_;
				GVariant* _tmp13_;
#line 98 "../src/Views/StylusView.vala"
				if (!_tmp7_) {
#line 404 "StylusView.c"
					gint _tmp8_;
#line 98 "../src/Views/StylusView.vala"
					_tmp8_ = i;
#line 98 "../src/Views/StylusView.vala"
					i = _tmp8_ + 1;
#line 410 "StylusView.c"
				}
#line 98 "../src/Views/StylusView.vala"
				_tmp7_ = FALSE;
#line 98 "../src/Views/StylusView.vala"
				_tmp9_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 98 "../src/Views/StylusView.vala"
				if (!(i < _tmp9_)) {
#line 98 "../src/Views/StylusView.vala"
					break;
#line 420 "StylusView.c"
				}
#line 99 "../src/Views/StylusView.vala"
				_tmp10_ = values;
#line 99 "../src/Views/StylusView.vala"
				_tmp10__length1 = values_length1;
#line 99 "../src/Views/StylusView.vala"
				_tmp11_ = settings_value;
#line 99 "../src/Views/StylusView.vala"
				_tmp12_ = g_variant_get_child_value (_tmp11_, (gsize) i);
#line 99 "../src/Views/StylusView.vala"
				_tmp13_ = _tmp12_;
#line 99 "../src/Views/StylusView.vala"
				_tmp10_[i] = (gint) g_variant_get_int32 (_tmp13_);
#line 99 "../src/Views/StylusView.vala"
				_g_variant_unref0 (_tmp13_);
#line 436 "StylusView.c"
			}
		}
	}
	{
		gint i = 0;
#line 102 "../src/Views/StylusView.vala"
		i = 0;
#line 444 "StylusView.c"
		{
			gboolean _tmp14_ = FALSE;
#line 102 "../src/Views/StylusView.vala"
			_tmp14_ = TRUE;
#line 102 "../src/Views/StylusView.vala"
			while (TRUE) {
#line 451 "StylusView.c"
				gint _tmp16_;
				gboolean match = FALSE;
#line 102 "../src/Views/StylusView.vala"
				if (!_tmp14_) {
#line 456 "StylusView.c"
					gint _tmp15_;
#line 102 "../src/Views/StylusView.vala"
					_tmp15_ = i;
#line 102 "../src/Views/StylusView.vala"
					i = _tmp15_ + 1;
#line 462 "StylusView.c"
				}
#line 102 "../src/Views/StylusView.vala"
				_tmp14_ = FALSE;
#line 102 "../src/Views/StylusView.vala"
				_tmp16_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES);
#line 102 "../src/Views/StylusView.vala"
				if (!(i < _tmp16_)) {
#line 102 "../src/Views/StylusView.vala"
					break;
#line 472 "StylusView.c"
				}
#line 103 "../src/Views/StylusView.vala"
				match = TRUE;
#line 476 "StylusView.c"
				{
					gint j = 0;
#line 104 "../src/Views/StylusView.vala"
					j = 0;
#line 481 "StylusView.c"
					{
						gboolean _tmp17_ = FALSE;
#line 104 "../src/Views/StylusView.vala"
						_tmp17_ = TRUE;
#line 104 "../src/Views/StylusView.vala"
						while (TRUE) {
#line 488 "StylusView.c"
							gint _tmp19_;
							gint* _tmp20_;
							gint _tmp20__length1;
							gint _tmp21_;
							gint32 _tmp22_;
#line 104 "../src/Views/StylusView.vala"
							if (!_tmp17_) {
#line 496 "StylusView.c"
								gint _tmp18_;
#line 104 "../src/Views/StylusView.vala"
								_tmp18_ = j;
#line 104 "../src/Views/StylusView.vala"
								j = _tmp18_ + 1;
#line 502 "StylusView.c"
							}
#line 104 "../src/Views/StylusView.vala"
							_tmp17_ = FALSE;
#line 104 "../src/Views/StylusView.vala"
							_tmp19_ = G_N_ELEMENTS (WACOM_STYLUS_VIEW_PRESSURE_CURVES[0]);
#line 104 "../src/Views/StylusView.vala"
							if (!(j < _tmp19_)) {
#line 104 "../src/Views/StylusView.vala"
								break;
#line 512 "StylusView.c"
							}
#line 105 "../src/Views/StylusView.vala"
							_tmp20_ = values;
#line 105 "../src/Views/StylusView.vala"
							_tmp20__length1 = values_length1;
#line 105 "../src/Views/StylusView.vala"
							_tmp21_ = _tmp20_[j];
#line 105 "../src/Views/StylusView.vala"
							_tmp22_ = WACOM_STYLUS_VIEW_PRESSURE_CURVES[i][j];
#line 105 "../src/Views/StylusView.vala"
							if (_tmp21_ != ((gint) _tmp22_)) {
#line 106 "../src/Views/StylusView.vala"
								match = FALSE;
#line 107 "../src/Views/StylusView.vala"
								break;
#line 528 "StylusView.c"
							}
						}
					}
				}
#line 111 "../src/Views/StylusView.vala"
				if (match) {
#line 112 "../src/Views/StylusView.vala"
					gtk_range_set_value ((GtkRange*) scale, (gdouble) i);
#line 113 "../src/Views/StylusView.vala"
					break;
#line 539 "StylusView.c"
				}
			}
		}
	}
#line 90 "../src/Views/StylusView.vala"
	values = (g_free (values), NULL);
#line 90 "../src/Views/StylusView.vala"
	_g_variant_unref0 (settings_value);
#line 548 "StylusView.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 118 "../src/Views/StylusView.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 118 "../src/Views/StylusView.vala"
	return _data1_;
#line 558 "StylusView.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 118 "../src/Views/StylusView.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 568 "StylusView.c"
		WacomStylusView* self;
#line 118 "../src/Views/StylusView.vala"
		self = _data1_->self;
#line 118 "../src/Views/StylusView.vala"
		_g_object_unref0 (_data1_->scale);
#line 118 "../src/Views/StylusView.vala"
		_g_free0 (_data1_->schema_key);
#line 118 "../src/Views/StylusView.vala"
		_g_object_unref0 (self);
#line 118 "../src/Views/StylusView.vala"
		g_slice_free (Block1Data, _data1_);
#line 580 "StylusView.c"
	}
}

static void
__lambda6_ (Block1Data* _data1_)
{
	WacomStylusView* self;
#line 128 "../src/Views/StylusView.vala"
	self = _data1_->self;
#line 129 "../src/Views/StylusView.vala"
	wacom_stylus_view_on_pressure_value_changed (self, _data1_->scale, _data1_->schema_key);
#line 592 "StylusView.c"
}

static void
___lambda6__gtk_range_value_changed (GtkRange* _sender,
                                     gpointer self)
{
#line 128 "../src/Views/StylusView.vala"
	__lambda6_ (self);
#line 601 "StylusView.c"
}

static void
wacom_stylus_view_build_pressure_slider (WacomStylusView* self,
                                         const gchar* label,
                                         const gchar* schema_key)
{
	Block1Data* _data1_;
	gchar* _tmp0_;
	GtkScale* _tmp1_;
	GtkGrid* _tmp2_;
	WacomWidgetsSettingLabel* _tmp3_;
	WacomWidgetsSettingLabel* _tmp4_;
	GtkGrid* _tmp5_;
	gint _tmp6_;
#line 118 "../src/Views/StylusView.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/Views/StylusView.vala"
	g_return_if_fail (label != NULL);
#line 118 "../src/Views/StylusView.vala"
	g_return_if_fail (schema_key != NULL);
#line 118 "../src/Views/StylusView.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 118 "../src/Views/StylusView.vala"
	_data1_->_ref_count_ = 1;
#line 118 "../src/Views/StylusView.vala"
	_data1_->self = g_object_ref (self);
#line 118 "../src/Views/StylusView.vala"
	_tmp0_ = g_strdup (schema_key);
#line 118 "../src/Views/StylusView.vala"
	_g_free0 (_data1_->schema_key);
#line 118 "../src/Views/StylusView.vala"
	_data1_->schema_key = _tmp0_;
#line 119 "../src/Views/StylusView.vala"
	_tmp1_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 6, (gdouble) 1);
#line 119 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp1_);
#line 119 "../src/Views/StylusView.vala"
	_data1_->scale = _tmp1_;
#line 120 "../src/Views/StylusView.vala"
	gtk_scale_set_draw_value (_data1_->scale, FALSE);
#line 121 "../src/Views/StylusView.vala"
	gtk_scale_set_has_origin (_data1_->scale, FALSE);
#line 122 "../src/Views/StylusView.vala"
	gtk_range_set_round_digits ((GtkRange*) _data1_->scale, 0);
#line 123 "../src/Views/StylusView.vala"
	gtk_scale_add_mark (_data1_->scale, (gdouble) 0, GTK_POS_BOTTOM, _ ("Soft"));
#line 124 "../src/Views/StylusView.vala"
	gtk_scale_add_mark (_data1_->scale, (gdouble) 6, GTK_POS_BOTTOM, _ ("Firm"));
#line 126 "../src/Views/StylusView.vala"
	wacom_stylus_view_set_pressure_scale_value_from_settings (self, _data1_->scale, _data1_->schema_key);
#line 128 "../src/Views/StylusView.vala"
	g_signal_connect_data ((GtkRange*) _data1_->scale, "value-changed", (GCallback) ___lambda6__gtk_range_value_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 132 "../src/Views/StylusView.vala"
	_tmp2_ = self->priv->stylus_grid;
#line 132 "../src/Views/StylusView.vala"
	_tmp3_ = wacom_widgets_setting_label_new (label);
#line 132 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp3_);
#line 132 "../src/Views/StylusView.vala"
	_tmp4_ = _tmp3_;
#line 132 "../src/Views/StylusView.vala"
	gtk_grid_attach (_tmp2_, (GtkWidget*) _tmp4_, 0, self->priv->last_grid_y_pos, 1, 1);
#line 132 "../src/Views/StylusView.vala"
	_g_object_unref0 (_tmp4_);
#line 133 "../src/Views/StylusView.vala"
	_tmp5_ = self->priv->stylus_grid;
#line 133 "../src/Views/StylusView.vala"
	gtk_grid_attach (_tmp5_, (GtkWidget*) _data1_->scale, 1, self->priv->last_grid_y_pos, 1, 1);
#line 134 "../src/Views/StylusView.vala"
	_tmp6_ = self->priv->last_grid_y_pos;
#line 134 "../src/Views/StylusView.vala"
	self->priv->last_grid_y_pos = _tmp6_ + 1;
#line 118 "../src/Views/StylusView.vala"
	block1_data_unref (_data1_);
#line 118 "../src/Views/StylusView.vala"
	_data1_ = NULL;
#line 679 "StylusView.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 137 "../src/Views/StylusView.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 137 "../src/Views/StylusView.vala"
	return _data2_;
#line 689 "StylusView.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 137 "../src/Views/StylusView.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 699 "StylusView.c"
		WacomStylusView* self;
#line 137 "../src/Views/StylusView.vala"
		self = _data2_->self;
#line 137 "../src/Views/StylusView.vala"
		_g_object_unref0 (_data2_->test_area);
#line 137 "../src/Views/StylusView.vala"
		_g_object_unref0 (_data2_->test_popover);
#line 137 "../src/Views/StylusView.vala"
		_g_object_unref0 (self);
#line 137 "../src/Views/StylusView.vala"
		g_slice_free (Block2Data, _data2_);
#line 711 "StylusView.c"
	}
}

static void
__lambda7_ (WacomStylusView* self,
            GtkWidget* widget)
{
#line 138 "../src/Views/StylusView.vala"
	g_return_if_fail (widget != NULL);
#line 139 "../src/Views/StylusView.vala"
	gtk_widget_destroy (widget);
#line 723 "StylusView.c"
}

static void
___lambda7__gtk_callback (GtkWidget* widget,
                          gpointer self)
{
#line 138 "../src/Views/StylusView.vala"
	__lambda7_ ((WacomStylusView*) self, widget);
#line 732 "StylusView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 142 "../src/Views/StylusView.vala"
	return self ? g_object_ref (self) : NULL;
#line 740 "StylusView.c"
}

static void
__lambda8_ (Block2Data* _data2_)
{
	WacomStylusView* self;
#line 183 "../src/Views/StylusView.vala"
	self = _data2_->self;
#line 184 "../src/Views/StylusView.vala"
	wacom_widgets_drawing_area_clear (_data2_->test_area);
#line 185 "../src/Views/StylusView.vala"
	gtk_widget_show_all ((GtkWidget*) _data2_->test_popover);
#line 753 "StylusView.c"
}

static void
___lambda8__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 183 "../src/Views/StylusView.vala"
	__lambda8_ (self);
#line 762 "StylusView.c"
}

void
wacom_stylus_view_set_device (WacomStylusView* self,
                              WacomBackendWacomTool* dev)
{
	Block2Data* _data2_;
	GtkGrid* _tmp0_;
	WacomBackendWacomTool* _tmp1_;
	WacomBackendWacomTool* _tmp2_;
	GSettings* _tmp3_;
	gboolean _tmp4_ = FALSE;
	WacomBackendWacomTool* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	WacomBackendWacomTool* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	WacomBackendWacomTool* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	GtkButton* test_button = NULL;
	GtkButton* _tmp17_;
	GtkPopover* _tmp18_;
	WacomWidgetsDrawingArea* _tmp19_;
	GtkGrid* _tmp20_;
#line 137 "../src/Views/StylusView.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Views/StylusView.vala"
	g_return_if_fail (dev != NULL);
#line 137 "../src/Views/StylusView.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 137 "../src/Views/StylusView.vala"
	_data2_->_ref_count_ = 1;
#line 137 "../src/Views/StylusView.vala"
	_data2_->self = g_object_ref (self);
#line 138 "../src/Views/StylusView.vala"
	_tmp0_ = self->priv->stylus_grid;
#line 138 "../src/Views/StylusView.vala"
	gtk_container_foreach ((GtkContainer*) _tmp0_, ___lambda7__gtk_callback, self);
#line 142 "../src/Views/StylusView.vala"
	_tmp1_ = _g_object_ref0 (dev);
#line 142 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->device);
#line 142 "../src/Views/StylusView.vala"
	self->priv->device = _tmp1_;
#line 143 "../src/Views/StylusView.vala"
	_tmp2_ = self->priv->device;
#line 143 "../src/Views/StylusView.vala"
	_tmp3_ = wacom_backend_wacom_tool_get_settings (_tmp2_);
#line 143 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->settings);
#line 143 "../src/Views/StylusView.vala"
	self->priv->settings = _tmp3_;
#line 145 "../src/Views/StylusView.vala"
	_tmp5_ = self->priv->device;
#line 145 "../src/Views/StylusView.vala"
	_tmp6_ = wacom_backend_wacom_tool_get_has_pressure_detection (_tmp5_);
#line 145 "../src/Views/StylusView.vala"
	_tmp7_ = _tmp6_;
#line 145 "../src/Views/StylusView.vala"
	if (_tmp7_) {
#line 825 "StylusView.c"
		WacomBackendWacomTool* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 145 "../src/Views/StylusView.vala"
		_tmp8_ = self->priv->device;
#line 145 "../src/Views/StylusView.vala"
		_tmp9_ = wacom_backend_wacom_tool_get_has_eraser (_tmp8_);
#line 145 "../src/Views/StylusView.vala"
		_tmp10_ = _tmp9_;
#line 145 "../src/Views/StylusView.vala"
		_tmp4_ = _tmp10_;
#line 837 "StylusView.c"
	} else {
#line 145 "../src/Views/StylusView.vala"
		_tmp4_ = FALSE;
#line 841 "StylusView.c"
	}
#line 145 "../src/Views/StylusView.vala"
	if (_tmp4_) {
#line 146 "../src/Views/StylusView.vala"
		wacom_stylus_view_build_pressure_slider (self, _ ("Eraser Pressure Feel:"), "eraser-pressure-curve");
#line 847 "StylusView.c"
	}
#line 149 "../src/Views/StylusView.vala"
	_tmp11_ = self->priv->device;
#line 149 "../src/Views/StylusView.vala"
	_tmp12_ = wacom_backend_wacom_tool_get_num_buttons (_tmp11_);
#line 149 "../src/Views/StylusView.vala"
	_tmp13_ = _tmp12_;
#line 149 "../src/Views/StylusView.vala"
	switch (_tmp13_) {
#line 149 "../src/Views/StylusView.vala"
		case 1:
#line 859 "StylusView.c"
		{
#line 151 "../src/Views/StylusView.vala"
			wacom_stylus_view_build_button_settings (self, _ ("Button Action:"), "button-action");
#line 152 "../src/Views/StylusView.vala"
			break;
#line 865 "StylusView.c"
		}
#line 149 "../src/Views/StylusView.vala"
		case 2:
#line 869 "StylusView.c"
		{
#line 154 "../src/Views/StylusView.vala"
			wacom_stylus_view_build_button_settings (self, _ ("Top Button Action:"), "secondary-button-action");
#line 155 "../src/Views/StylusView.vala"
			wacom_stylus_view_build_button_settings (self, _ ("Bottom Button Action:"), "button-action");
#line 156 "../src/Views/StylusView.vala"
			break;
#line 877 "StylusView.c"
		}
#line 149 "../src/Views/StylusView.vala"
		case 3:
#line 881 "StylusView.c"
		{
#line 158 "../src/Views/StylusView.vala"
			wacom_stylus_view_build_button_settings (self, _ ("Top Button Action:"), "secondary-button-action");
#line 159 "../src/Views/StylusView.vala"
			wacom_stylus_view_build_button_settings (self, _ ("Middle Button Action:"), "button-action");
#line 160 "../src/Views/StylusView.vala"
			wacom_stylus_view_build_button_settings (self, _ ("Bottom Button Action:"), "tertiary-button-action");
#line 161 "../src/Views/StylusView.vala"
			break;
#line 891 "StylusView.c"
		}
		default:
		{
#line 163 "../src/Views/StylusView.vala"
			break;
#line 897 "StylusView.c"
		}
	}
#line 166 "../src/Views/StylusView.vala"
	_tmp14_ = self->priv->device;
#line 166 "../src/Views/StylusView.vala"
	_tmp15_ = wacom_backend_wacom_tool_get_has_pressure_detection (_tmp14_);
#line 166 "../src/Views/StylusView.vala"
	_tmp16_ = _tmp15_;
#line 166 "../src/Views/StylusView.vala"
	if (_tmp16_) {
#line 167 "../src/Views/StylusView.vala"
		wacom_stylus_view_build_pressure_slider (self, _ ("Tip Pressure Feel:"), "pressure-curve");
#line 910 "StylusView.c"
	}
#line 171 "../src/Views/StylusView.vala"
	_tmp17_ = (GtkButton*) gtk_button_new_with_label (_ ("Test Tablet Settings"));
#line 171 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp17_);
#line 171 "../src/Views/StylusView.vala"
	test_button = _tmp17_;
#line 172 "../src/Views/StylusView.vala"
	_tmp18_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) test_button);
#line 172 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp18_);
#line 172 "../src/Views/StylusView.vala"
	_data2_->test_popover = _tmp18_;
#line 173 "../src/Views/StylusView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _data2_->test_popover, TRUE);
#line 174 "../src/Views/StylusView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _data2_->test_popover, TRUE);
#line 175 "../src/Views/StylusView.vala"
	gtk_popover_set_position (_data2_->test_popover, GTK_POS_BOTTOM);
#line 177 "../src/Views/StylusView.vala"
	_tmp19_ = wacom_widgets_drawing_area_new ();
#line 177 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp19_);
#line 177 "../src/Views/StylusView.vala"
	_data2_->test_area = _tmp19_;
#line 178 "../src/Views/StylusView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _data2_->test_area, TRUE);
#line 179 "../src/Views/StylusView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _data2_->test_area, TRUE);
#line 181 "../src/Views/StylusView.vala"
	gtk_container_add ((GtkContainer*) _data2_->test_popover, (GtkWidget*) _data2_->test_area);
#line 183 "../src/Views/StylusView.vala"
	g_signal_connect_data (test_button, "clicked", (GCallback) ___lambda8__gtk_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 188 "../src/Views/StylusView.vala"
	_tmp20_ = self->priv->stylus_grid;
#line 188 "../src/Views/StylusView.vala"
	gtk_grid_attach (_tmp20_, (GtkWidget*) test_button, 0, self->priv->last_grid_y_pos, 2, 1);
#line 190 "../src/Views/StylusView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 192 "../src/Views/StylusView.vala"
	gtk_stack_set_visible_child_name ((GtkStack*) self, "stylus");
#line 137 "../src/Views/StylusView.vala"
	_g_object_unref0 (test_button);
#line 137 "../src/Views/StylusView.vala"
	block2_data_unref (_data2_);
#line 137 "../src/Views/StylusView.vala"
	_data2_ = NULL;
#line 958 "StylusView.c"
}

WacomStylusView*
wacom_stylus_view_construct (GType object_type)
{
	WacomStylusView * self = NULL;
#line 20 "../src/Views/StylusView.vala"
	self = (WacomStylusView*) g_object_new (object_type, NULL);
#line 20 "../src/Views/StylusView.vala"
	return self;
#line 969 "StylusView.c"
}

WacomStylusView*
wacom_stylus_view_new (void)
{
#line 20 "../src/Views/StylusView.vala"
	return wacom_stylus_view_construct (WACOM_TYPE_STYLUS_VIEW);
#line 977 "StylusView.c"
}

static GObject *
wacom_stylus_view_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WacomStylusView * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GraniteWidgetsAlertView* no_stylus_view = NULL;
	GraniteWidgetsAlertView* _tmp3_;
	GraniteWidgetsAlertView* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkGrid* _tmp6_;
	GraniteWidgetsAlertView* _tmp7_;
#line 38 "../src/Views/StylusView.vala"
	parent_class = G_OBJECT_CLASS (wacom_stylus_view_parent_class);
#line 38 "../src/Views/StylusView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../src/Views/StylusView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_STYLUS_VIEW, WacomStylusView);
#line 39 "../src/Views/StylusView.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 39 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp0_);
#line 39 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->stylus_grid);
#line 39 "../src/Views/StylusView.vala"
	self->priv->stylus_grid = _tmp0_;
#line 40 "../src/Views/StylusView.vala"
	_tmp1_ = self->priv->stylus_grid;
#line 40 "../src/Views/StylusView.vala"
	gtk_grid_set_row_spacing (_tmp1_, 12);
#line 41 "../src/Views/StylusView.vala"
	_tmp2_ = self->priv->stylus_grid;
#line 41 "../src/Views/StylusView.vala"
	gtk_grid_set_column_spacing (_tmp2_, 12);
#line 43 "../src/Views/StylusView.vala"
	_tmp3_ = granite_widgets_alert_view_new (_ ("No Stylus Detected"), _ ("Please move your stylus close to the tablet"), "input-tablet");
#line 43 "../src/Views/StylusView.vala"
	g_object_ref_sink (_tmp3_);
#line 43 "../src/Views/StylusView.vala"
	no_stylus_view = _tmp3_;
#line 48 "../src/Views/StylusView.vala"
	_tmp4_ = no_stylus_view;
#line 48 "../src/Views/StylusView.vala"
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) _tmp4_);
#line 48 "../src/Views/StylusView.vala"
	gtk_style_context_remove_class (_tmp5_, GTK_STYLE_CLASS_VIEW);
#line 50 "../src/Views/StylusView.vala"
	_tmp6_ = self->priv->stylus_grid;
#line 50 "../src/Views/StylusView.vala"
	gtk_stack_add_named ((GtkStack*) self, (GtkWidget*) _tmp6_, "stylus");
#line 51 "../src/Views/StylusView.vala"
	_tmp7_ = no_stylus_view;
#line 51 "../src/Views/StylusView.vala"
	gtk_stack_add_named ((GtkStack*) self, (GtkWidget*) _tmp7_, "no_stylus");
#line 53 "../src/Views/StylusView.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 55 "../src/Views/StylusView.vala"
	gtk_stack_set_visible_child_name ((GtkStack*) self, "no_stylus");
#line 38 "../src/Views/StylusView.vala"
	_g_object_unref0 (no_stylus_view);
#line 38 "../src/Views/StylusView.vala"
	return obj;
#line 1047 "StylusView.c"
}

static void
wacom_stylus_view_class_init (WacomStylusViewClass * klass,
                              gpointer klass_data)
{
#line 20 "../src/Views/StylusView.vala"
	wacom_stylus_view_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Views/StylusView.vala"
	g_type_class_adjust_private_offset (klass, &WacomStylusView_private_offset);
#line 20 "../src/Views/StylusView.vala"
	G_OBJECT_CLASS (klass)->constructor = wacom_stylus_view_constructor;
#line 20 "../src/Views/StylusView.vala"
	G_OBJECT_CLASS (klass)->finalize = wacom_stylus_view_finalize;
#line 1062 "StylusView.c"
}

static void
wacom_stylus_view_instance_init (WacomStylusView * self,
                                 gpointer klass)
{
#line 20 "../src/Views/StylusView.vala"
	self->priv = wacom_stylus_view_get_instance_private (self);
#line 36 "../src/Views/StylusView.vala"
	self->priv->last_grid_y_pos = 0;
#line 1073 "StylusView.c"
}

static void
wacom_stylus_view_finalize (GObject * obj)
{
	WacomStylusView * self;
#line 20 "../src/Views/StylusView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WACOM_TYPE_STYLUS_VIEW, WacomStylusView);
#line 32 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->device);
#line 33 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->settings);
#line 35 "../src/Views/StylusView.vala"
	_g_object_unref0 (self->priv->stylus_grid);
#line 20 "../src/Views/StylusView.vala"
	G_OBJECT_CLASS (wacom_stylus_view_parent_class)->finalize (obj);
#line 1090 "StylusView.c"
}

static GType
wacom_stylus_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WacomStylusViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) wacom_stylus_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WacomStylusView), 0, (GInstanceInitFunc) wacom_stylus_view_instance_init, NULL };
	GType wacom_stylus_view_type_id;
	wacom_stylus_view_type_id = g_type_register_static (gtk_stack_get_type (), "WacomStylusView", &g_define_type_info, 0);
	WacomStylusView_private_offset = g_type_add_instance_private (wacom_stylus_view_type_id, sizeof (WacomStylusViewPrivate));
	return wacom_stylus_view_type_id;
}

GType
wacom_stylus_view_get_type (void)
{
	static volatile gsize wacom_stylus_view_type_id__once = 0;
	if (g_once_init_enter (&wacom_stylus_view_type_id__once)) {
		GType wacom_stylus_view_type_id;
		wacom_stylus_view_type_id = wacom_stylus_view_get_type_once ();
		g_once_init_leave (&wacom_stylus_view_type_id__once, wacom_stylus_view_type_id);
	}
	return wacom_stylus_view_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 20 "../src/Backend/DeviceManagerX11.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1122 "StylusView.c"
		gssize i;
#line 20 "../src/Backend/DeviceManagerX11.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 20 "../src/Backend/DeviceManagerX11.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 20 "../src/Backend/DeviceManagerX11.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1130 "StylusView.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 20 "../src/Backend/DeviceManagerX11.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 20 "../src/Backend/DeviceManagerX11.vala"
	g_free (array);
#line 1145 "StylusView.c"
}

